SystemOrganization addCategory: #'CodeSight-Tests'!
SystemOrganization addCategory: #'CodeSight-Tracer'!
SystemOrganization addCategory: #'CodeSight-TestTracer'!
SystemOrganization addCategory: #'CodeSight-Browser'!
SystemOrganization addCategory: #'CodeSight-Install'!
SystemOrganization addCategory: #'CodeSight-Analyzing'!
SystemOrganization addCategory: #CodeSight!
SystemOrganization addCategory: #'CodeSight-View'!
SystemOrganization addCategory: #'CodeSight-Text'!
SystemOrganization addCategory: #'CodeSight-Events'!
SystemOrganization addCategory: #'CodeSight-Tracing'!
SystemOrganization addCategory: #'CodeSight-Distribution'!
SystemOrganization addCategory: #'CodeSight-DistributionTests'!

!OBEnhancementDefinitionPanel methodsFor: '*CodeSight-override' stamp: 'bs 9/24/2009 08:03'!
accept: aText notifying: aController
	| result |
	CSTestRunner sourceCodeAccessMonitor critical: [
		result := super accept: aText notifying: aController ].
	^ result.! !

Object subclass: #ATddBenchmarker
	instanceVariableNames: 'packages methods coveredMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Analyzing'!

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/21/2009 03:51'!
appMethods

	| class |
	^ self methods reject: [:ea |
		class := ea methodClass ifNil: [ea clientMethod searchForClass].
		class
			ifNil: [false]
			ifNotNil: [class inheritsFrom: TestCase]].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/20/2009 03:38'!
classesOfPackages

	^ (packages gather: [:p | p classes]) asSet! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/21/2009 04:14'!
computeTestClassesTimesPerMethodFrom: timeForEachTestClass

	| testClassesTimesPerMethod |
	testClassesTimesPerMethod := Dictionary new. "appMethod -> coveringTestClassesTime"
	(self methodsCovered: self methods) do: [:appMethod |
		testClassesTimesPerMethod
			at: appMethod
			put: (self coveringTestClassesTimeFor: appMethod from: timeForEachTestClass)].
	^ testClassesTimesPerMethod.! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/21/2009 04:14'!
computeTestTimesPerMethodFrom: timeForEachTest

	| testTimesPerMethod |
	testTimesPerMethod := Dictionary new. "appMethod -> coveringTestMethodsTime"
	(self methodsCovered: self methods) do: [:appMethod |
		testTimesPerMethod
			at: appMethod
			put: (self coveringTestMethodsTimeFor: appMethod from: timeForEachTest)].
	^ testTimesPerMethod.! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/20/2009 03:48'!
computeTimeForAllTestsFrom: timeForEachTest

	^ timeForEachTest values sum.! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/20/2009 18:06'!
computeTimeForEachTest

	| aTestRunner testClasses timeForEach |
	aTestRunner := CSTestRunner new.
	testClasses := self testClassesOfPackages.
	timeForEach := Dictionary new.
	testClasses
		do: [:testClass | 
			testClass selectors
				select: [:s | s isTestSelector]
				thenDo: [:s | | time |
					time := [aTestRunner runSuite: (testClass suiteWithSelectorsMatching: s)] timeToRun.
					timeForEach at: (testClass >> s) methodReference put: time]]
		displayingProgress: 'Running Tests (' , testClasses size asString, ' test classes)'.
	^ timeForEach! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/20/2009 18:11'!
computeTimeForEachTestClassFrom: timeForEachTest

	| timeForEach |
	timeForEach := Dictionary new.
	self testClassesOfPackages do: [:class | | methodsOfClass time |
		methodsOfClass := timeForEachTest keys select: [:m | m actualClass = class].
		time := methodsOfClass inject: 0 into: [:t :m | (timeForEachTest at: m) + t].
		timeForEach at: class put: time].
	^ timeForEach! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
coveringTestClassesTimeFor: appMethod from: timeForEachTestClass

	| testClasses |
	testClasses := (appMethod coveringTestMethods
		collect: [:ea | ea methodClass]
		thenSelect: [:ea | ea isObsolete not]) asSet.
	^ testClasses
		inject: 0
		into: [:sum :c | (timeForEachTestClass at: c) + sum].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
coveringTestMethodsTimeFor: appMethod from: timeForEachTest

	^ appMethod coveringTestMethods
		inject: 0
		into: [:sum :m | (timeForEachTest at: m methodReference ifAbsent: [0"???"]) + sum].! !

!ATddBenchmarker methodsFor: 'running' stamp: 'rkrk 9/20/2009 18:17'!
measureCoveringTimesForPackages: packageString

	^ String streamContents: [:stream |
		self 
			measureCoveringTimesForPackages: packageString 
			printOn: stream].
	! !

!ATddBenchmarker methodsFor: 'running' stamp: 'bs 1/22/2010 15:24'!
measureCoveringTimesForPackages: packageString printOn: stream

	"^ #(coveringTestMethodsTime coveringTestClassesTime timeForRunningAllTestsAtEveryChange)"
	| timeForEachTest timeForEachTestClass timeForAllTests testClassesTimesPerMethod testTimesPerMethod coveredTestMethodsTimes coveredTestClassesTimes |
	packages := PackageOrganizer default packages select: [:p | p packageName startsWith: packageString].
	packages do: [:p | CSWrappingInstrumentor systemInstrumentor instrumentPackage: p].

	timeForEachTest := self computeTimeForEachTest.
	timeForEachTestClass := self computeTimeForEachTestClassFrom: timeForEachTest.
	timeForAllTests := self computeTimeForAllTestsFrom: timeForEachTest.
	testTimesPerMethod := self computeTestTimesPerMethodFrom: timeForEachTest.
	testClassesTimesPerMethod := self computeTestClassesTimesPerMethodFrom: timeForEachTestClass.

	"CSV style output
	appMethods,coveredMethods,coveredTestMethodsTimes average, coveredTestMethodsTimes median, coveredTestMethodsTimes min, coveredTestMethodsTimes max, coveredTestMethodsTimes sum, coveredTestClassesTimes avg, coveredTestClassesTimes median, coveredTestClassesTimes sum, timeForAllTests, timeForAllTests sum"
	coveredTestMethodsTimes := testTimesPerMethod values.
	coveredTestClassesTimes := testClassesTimesPerMethod values.
	stream
		print: self appMethods size; nextPut: $,;
		print: (self methodsCovered: self appMethods) size; nextPut: $,;
		print: (coveredTestMethodsTimes average roundTo: 1); nextPut: $,;
		print: (coveredTestMethodsTimes median roundTo: 1); nextPut: $,;
		print: coveredTestMethodsTimes min; nextPut: $,;
		print: coveredTestMethodsTimes max; nextPut: $,;
		print: coveredTestMethodsTimes sum; nextPut: $,;
		print: (coveredTestClassesTimes average roundTo: 1); nextPut: $,;
		print: (coveredTestClassesTimes median roundTo: 1); nextPut: $,;
		print: coveredTestClassesTimes sum; nextPut: $,;
		print: timeForAllTests; nextPut: $,;
		print: (self methodsCovered: self methods) size * timeForAllTests;
		cr.
		
	packages do: [:p |CSInstrumentor systemInstrumentor uninstrumentPackage: p].! !

!ATddBenchmarker methodsFor: 'running' stamp: 'bs 10/8/2009 16:10'!
measureTestExecutionTimeForPackages: packageString

	| aTestSuite testClasses nRuns |
	packages := PackageOrganizer default packages select: [:p | p packageName startsWith: packageString].
	"packages do: [:p | CSCoverageTracingWrapper registerPackage: p]."
	
	aTestSuite := TestSuite new.
	testClasses := self testClassesOfPackages.
	
	self testClassesOfPackages
		do: [:testClass | 
			testClass selectors
				select: [:s | s isTestSelector]
				thenDo: [:s | aTestSuite addTest: (testClass selector: s)]].
			
	nRuns := 2.
	^ ([nRuns timesRepeat: [CSTestRunner new runSuite: aTestSuite]] timeToRun / nRuns).
	! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
methods

	^ methods ifNil: [
		methods := self classesOfPackages gather: [:class |
			class methodDict values]].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/21/2009 04:16'!
methodsCovered: methodCol

	^ methodCol select: [:ea | ea hasCoveringTestMethods].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
testClassesOfPackages

	^ self classesOfPackages select: [:class |
		class inheritsFrom: TestCase].! !

Object subclass: #ATddMCAnalyzer
	instanceVariableNames: 'inspector methodVersionResult doAfterGathering'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Analyzing'!

!ATddMCAnalyzer class methodsFor: 'service' stamp: 'bs 11/20/2009 15:42'!
printVersionDatesOfPackage: packageName

	| instance dates |
	instance := self new.
	instance
		gatherVersionsOf: packageName
		thenDo: [:versionInfos |
			self halt.
			dates := (versionInfos collect: [:ea | ea date]) asSet.
			dates := dates	asOrderedCollection sortBy: [:a :b | a < b].
			Transcript cr; show: packageName; show: ' -- active development'.
			dates do: [:ea | Transcript cr; show: ea asString]].
	^instance.! !

!ATddMCAnalyzer class methodsFor: 'service' stamp: 'rkrk 9/20/2009 00:57'!
printVersionDatesOfPackage: packageName inRepo: repo

	| instance dates |
	instance := self new.
	instance
		gatherVersionsOf: {packageName}
		in: repo
		thenDo: [:versionInfos |
			dates := (versionInfos collect: [:ea | ea date]) asSet.
			dates := dates	asOrderedCollection sortBy: [:a :b | a < b].
			Transcript cr; show: packageName; show: ' -- active development'.
			dates do: [:ea | Transcript cr; show: ea asString]].
	^instance.! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 17:24'!
gatherVersionsOf: packageNames in: mcRepository thenDo: block 
	inspector ifNotNil: [ inspector stop ].
	inspector := CSMczInspectorOld 
		newForPackagesNamed: packageNames
		inRepo: mcRepository.
	methodVersionResult := OrderedCollection new.
	inspector addDependent: self.
	inspector startInspectVersions.
	doAfterGathering := block.
	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 17:24'!
gatherVersionsOf: packageName thenDo: block 
	inspector ifNotNil: [ inspector stop ].
	inspector := CSMczInspectorOld newForPackageNamed: packageName.
	methodVersionResult := OrderedCollection new.
	inspector addDependent: self.
	inspector startInspectVersions.
	doAfterGathering := block.
	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 17:24'!
inspect: selector of: class in: packageName 
	inspector ifNotNil: [ inspector stop ].
	inspector := CSMczInspectorOld newForPackageNamed: packageName.
	methodVersionResult := OrderedCollection new.
	inspector addDependent: self.
	inspector 
		startInspectVersionsFor: selector
		in: class.
	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'nil' stamp: 'rkrk 9/20/2009 00:58'!
methodVersionResult

	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 00:24'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #done ifFalse: [^ self].
	Transcript cr show: 'done'.
	doAfterGathering value: methodVersionResult.! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 9/19/2009 23:13'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.
	aSymbol = #versionFound ifFalse: [^self].
	Transcript cr; show: 'Found ' , anObject asString.
	methodVersionResult add: anObject.! !

Object subclass: #ATddReceiverAnalyzer
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Analyzing'!

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:32'!
getClassOf: method

	^ method methodClass ifNil: [method searchForClass].! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:38'!
init

	stream := WriteStream on: ''.! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:29'!
isOverwritten: method

	"CompiledMethod>>overridingMethods does not work"
	^ (self overridingClasses: method) notEmpty! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:35'!
methodsNotOverwrittenIn: package

	^ ((package coreMethods collect: [:ea | ea compiledMethod]
		thenSelect: [:method | method hasCoveringTestMethods])
		reject: [:method | self isOverwritten: method])
		reject: [:method | (self getClassOf: method) allSubclasses isEmpty].! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:32'!
overridingClasses: method

	^ (self getClassOf: method) allSubclasses select: [:ea |
		ea includesSelector: method selector].! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 22:29'!
printTestsForOverwrittenMethodsWithAndWithoutReceiverIn: package

	"self printTestsForOverwrittenMethodsWithAndWithoutReceiverIn:
		(PackageInfo named: 'AweSOM')"
	| methods
	appMethodClass pureTestCount testCountReceiver allNoRecv allRecv stat |
	self init.
	methods := self methodsNotOverwrittenIn: package.
	methods do: [:appMethod |
		appMethodClass := self getClassOf: appMethod.
		pureTestCount := appMethod coveringTestMethods size.
		allNoRecv := allRecv := 0.
		"<for each subclass>"
		appMethodClass allSubclasses do: [:subclass |
			testCountReceiver := 0.
			"<for each coveringTest>"
			"<if subclass or any of its subclasses are
			included in receiverclasses of coveringTest --> count+1>"
			testCountReceiver := appMethod coveringTestMethods count: [:test | 
				stat := test statisticsForCoveredMethod: appMethod clientMethod.
				(stat receiverClasses includesAnyOf: subclass withAllSubclasses)].
			"----"
			allNoRecv := allNoRecv + pureTestCount.
			allRecv := allRecv + testCountReceiver.
			"print it"
			stream
				cr; nextPutAll: 'If method '; nextPutAll: appMethod selector;
				nextPutAll: ' would be added to '; nextPutAll: subclass name; space;
				print: pureTestCount; nextPutAll: '/'; print: testCountReceiver;
				nextPutAll: ' should run.'.
		].
		"print it again"
		stream
			cr; print: allRecv; nextPut: $/; print: allNoRecv;
			nextPut: $=;
			print: (allRecv isZero
				ifTrue: [0]
				ifFalse: [allRecv / allNoRecv * 100 asFloat]).
		Transcript show: stream contents.
	].! !

Object subclass: #ATddVersionLoader
	instanceVariableNames: 'repo versionFileNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Analyzing'!

!ATddVersionLoader class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:42'!
loadVersionsNamed: versionNames from: mcRepository

	| fileNames |
	fileNames := versionNames collect: [:ea |
		(ea endsWith: '.mcz') ifTrue: [ea] ifFalse: [ea , '.mcz']].
	self new
		repo: mcRepository;
		versionFileNames: fileNames;
		loadAll;
		yourself.! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:46'!
loadAll

	| versions |
	versions := self versionFileNames collect: [:ea |
		repo loadVersionFromFileNamed: ea].
	versions do: [:ea | ea load].! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:42'!
repo: mcRepository

	repo := mcRepository! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:44'!
versionFileNames

	^ versionFileNames! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:43'!
versionFileNames: fileNames

	versionFileNames := fileNames! !

Object subclass: #CSCodeSight
	instanceVariableNames: 'instrumentor testRunner packageChooser runningTestMethod isActiveCounter isActive isSystemInstance wasCleanedUp systemEventAnalyzer testActorId developmentActorId maintenanceActorId distributionMode managedPackages testReplicator maintenanceReplicator openEvents actor'
	classVariableNames: 'Instance Instances SourceCodeMonitor'
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSCodeSight class methodsFor: 'synchronizing' stamp: 'bs 1/25/2010 18:55:14.46'!
sourceCodeMonitor
	" SourceCodeMonitor := nil"
	^ SourceCodeMonitor ifNil: [ SourceCodeMonitor := DummyMonitor new ]! !

!CSCodeSight methodsFor: 'tracing' stamp: 'bs 1/4/2010 14:57'!
activateTracing
	isActiveCounter ifNil: [isActiveCounter := 0].
	isActiveCounter := isActiveCounter + 1.
	isActive := isActiveCounter > 0.! !

!CSCodeSight methodsFor: 'distribution-actors' stamp: 'replica 2/24/2010 21:44:43.066'!
actor
	actor ifNil: [ 
		actor := CSActor new.
		actor codeSight: self ].
	^ actor! !

!CSCodeSight methodsFor: 'package management' stamp: 'bs 3/2/2010 22:37:44.467'!
addToManagedPackages: aPackageInfo
	self managedPackages add: aPackageInfo.
	^ self instrumentor instrumentPackage: aPackageInfo.! !

!CSCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 09:23'!
buildControlPanelWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		model: self;
		layout: #vertical;
		children: (self toolButtons collect: [ :each |
			aBuilder pluggableActionButtonSpec new
				model: self; 
				label: each first;
				action: each second;
				yourself ]);
		yourself.! !

!CSCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 09:16'!
buildWith: aBuilder
	| windowSpec |
	windowSpec := aBuilder pluggableWindowSpec new
		model: self; label: self label; extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildControlPanelWith: aBuilder)
				frame: (0.00 @ 0.00 corner: 1.00 @ 1.00);
				yourself);
			yourself);
		closeAction: #close;
		yourself.
	
	^aBuilder build: windowSpec
	! !

!CSCodeSight methodsFor: 'initialize-release' stamp: 'replica 3/1/2010 13:58:43.669'!
cleanUp
	(self wasCleanedUp)
		ifFalse: [
			self isSystemInstance ifTrue: [ self uninstallFromSystem ].
			self systemNotifier noMoreNotificationsFor: self.
			self csTestRunner cleanUp.
			self instrumentor cleanUp.
			self wasCleanedUp: true ]! !

!CSCodeSight methodsFor: 'ui-building' stamp: 'bs 1/4/2010 14:34'!
close
	self cleanUp! !

!CSCodeSight methodsFor: 'accessing' stamp: 'bs 1/13/2010 08:55'!
csTestRunner
	^ testRunner! !

!CSCodeSight methodsFor: 'accessing' stamp: 'bs 1/13/2010 08:55'!
csTestRunner: anObject
	testRunner := anObject! !

!CSCodeSight methodsFor: 'tracing' stamp: 'bs 1/4/2010 14:57'!
deactivateTracing
	isActiveCounter ifNil: [isActiveCounter := 0].
	isActiveCounter := isActiveCounter - 1.
	isActive := isActiveCounter > 0.! !

!CSCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/23/2010 08:53:31.317'!
developmentActorId
	^ developmentActorId 
		ifNil: [ developmentActorId := ActorId localhostPort: self developmentActorPort ]! !

!CSCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/23/2010 08:49:48.69'!
developmentActorPort
	^ 12000! !

!CSCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:24:45.391'!
distributionMode
	^ distributionMode ifNil: [ distributionMode := false ]! !

!CSCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:23:12.178'!
distributionMode: aBoolean
	^ distributionMode := aBoolean.! !

!CSCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 08:58'!
extent
	^ 200 @ 250! !

!CSCodeSight methodsFor: 'initialize-release' stamp: 'bs 1/4/2010 14:12'!
finalize
	self cleanUp! !

!CSCodeSight methodsFor: 'system event handling' stamp: 'bs 3/2/2010 21:17:39.328'!
handle: aSystemEvent affectedClass: aClass
	| codeSightEvent |
	(self isClassManaged: aClass)
		ifTrue: [ 
			codeSightEvent := self systemEventAnalyzer analyze: aSystemEvent.
			codeSightEvent handle: self ].! !

!CSCodeSight methodsFor: 'system event handling' stamp: 'bs 1/11/2010 10:09'!
handleClassEvent: anEvent
	self handle: anEvent affectedClass: anEvent item! !

!CSCodeSight methodsFor: 'system event handling' stamp: 'bs 3/2/2010 13:48:32.141'!
handleMethodEvent: anEvent
	self handle: anEvent affectedClass: anEvent itemClass! !

!CSCodeSight methodsFor: 'system event handling' stamp: 'replica 2/24/2010 16:27:27.72'!
handleSystemEvent: anEvent
	self runsDistributed
		ifTrue: [ self replicateModification: anEvent ].
	
	(anEvent itemKind == #class) ifTrue: [ self handleClassEvent: anEvent ].
	(anEvent itemKind == #method) ifTrue: [ self handleMethodEvent: anEvent ].! !

!CSCodeSight methodsFor: 'initialize-release' stamp: 'replica 2/24/2010 22:17:27.734'!
initialize
	self instrumentor: CSWrappingInstrumentor new.
	self instrumentor codeSight: self.
	self csTestRunner: CSTestRunner new.
	self csTestRunner codeSight: self.
	self packageChooser: CSPackageChooser new.
	self packageChooser codeSight: self.
	{ #class. #method. #protocol. #category } do: [ :itemKind |
		self systemNotifier notify: self ofSystemChangesOfItem: itemKind  using: #handleSystemEvent: ].
	
	"self systemNotifier notify: self ofSystemChangesOfItem: #class  using: #handleClassEvent:.
	self systemNotifier notify: self ofSystemChangesOfItem: #method  using: #handleMethodEvent:."! !

!CSCodeSight methodsFor: 'test info' stamp: 'bs 1/14/2010 14:15'!
installIntoSystem
	CSInfo instance: (CSRealInfo new codeSight: self; yourself).
	self csTestRunner addDependent: CSInfo instance.
	self isSystemInstance: true
		
	
	! !

!CSCodeSight methodsFor: 'test info' stamp: 'bs 1/14/2010 13:34'!
installUninstallLabel
	^ self isSystemInstance
		ifTrue: [ 'uninstall from system' ]
		ifFalse: [ 'install into system' ].! !

!CSCodeSight methodsFor: 'instrumenting' stamp: 'bs 2/23/2010 11:43:42.226'!
instrumentCode
	self managedPackages do: [ :aPackageInfo | 
		self instrumentor instrumentPackage: aPackageInfo ]! !

!CSCodeSight methodsFor: 'accessing' stamp: 'bs 1/4/2010 10:46'!
instrumentor
	^ instrumentor! !

!CSCodeSight methodsFor: 'accessing' stamp: 'bs 1/4/2010 10:46'!
instrumentor: anObject
	instrumentor := anObject! !

!CSCodeSight methodsFor: 'package management' stamp: 'bs 2/25/2010 10:52:39.006'!
isClassManaged: aClass
	^ (self instrumentor isClassInstrumented: aClass) 
		or: [self managedPackages includes: (self packageOfClass: aClass) ]! !

!CSCodeSight methodsFor: 'accessing' stamp: 'bs 1/14/2010 13:40'!
isSystemInstance
	^ isSystemInstance ifNil: [ isSystemInstance := false ]! !

!CSCodeSight methodsFor: 'accessing' stamp: 'bs 2/25/2010 10:33:55.565'!
isSystemInstance: anObject
	isSystemInstance := anObject.
	self changed: #installUninstallLabel. ! !

!CSCodeSight methodsFor: 'tracing' stamp: 'bs 1/4/2010 14:57'!
isTracingActivated
	^ isActive ifNil: [isActive := false]! !

!CSCodeSight methodsFor: 'ui-building' stamp: 'bs 1/3/2010 20:11'!
label
	^ 'CodeSight'! !

!CSCodeSight methodsFor: 'distribution-messages' stamp: 'bs 3/2/2010 21:17:49.694'!
maintainCoverage: testMethodNames
	| testMethodsToRun testsToCoverageData coverageData |
	testMethodsToRun := testMethodNames collect: [ :name | CompiledMethod fromQualifiedName: name ].
	self csTestRunner reset; runTestMethods: testMethodsToRun.
	
	testsToCoverageData := Dictionary new.
	testMethodsToRun do: [ :testMethod | 
		coverageData := testsToCoverageData 
				at: testMethod qualifiedName
				put: Dictionary new.
		
		testMethod coveredMethodsStatistics keysAndValuesDo: [ :method :stats |
			coverageData 
				at: (method qualifiedName)
				put: (stats receiverClasses collect: [:ea | ea name ]) ] ].
		
	self developmentActorId testCoverage: testsToCoverageData.! !

!CSCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/25/2010 10:55:39.813'!
maintenanceActorId
	^ maintenanceActorId 
		ifNil: [ maintenanceActorId := ActorId localhostPort: self maintenanceActorPort ]! !

!CSCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/23/2010 08:53:54.166'!
maintenanceActorPort
	^ 12007! !

!CSCodeSight methodsFor: 'distribution-replicas' stamp: 'bs 2/23/2010 13:29:23.295'!
maintenanceReplicator
	^ maintenanceReplicator! !

!CSCodeSight methodsFor: 'distribution-replicas' stamp: 'bs 2/23/2010 13:29:33.135'!
maintenanceReplicator: anObject
	maintenanceReplicator := anObject! !

!CSCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:23:33.709'!
makeDistributed
	self distributionMode: true
	! !

!CSCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:23:27.222'!
makeStandalone
	self distributionMode: false! !

!CSCodeSight methodsFor: 'package management' stamp: 'bs 2/23/2010 09:50:03.578'!
managedPackages
	^ managedPackages ifNil: [ managedPackages := WeakSet new ]! !

!CSCodeSight methodsFor: 'distribution-messages' stamp: 'bs 3/2/2010 21:13:53.811'!
modification: aCommandString
	Compiler evaluate: aCommandString! !

!CSCodeSight methodsFor: 'ui-building' stamp: 'bs 1/4/2010 14:38'!
open
	^ ToolBuilder open: self! !

!CSCodeSight methodsFor: 'distribution-accessing' stamp: 'replica 2/24/2010 17:46:37.084'!
openEvents
	^ openEvents ifNil: [ openEvents := SharedQueue2 new ]! !

!CSCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 10:15'!
openPackageChooser
	^ self packageChooser open! !

!CSCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 09:32'!
openTestDriver! !

!CSCodeSight methodsFor: 'ui-building' stamp: 'bs 1/14/2010 10:15'!
openTestRunner
	^ self csTestRunner open! !

!CSCodeSight methodsFor: 'distribution-ui' stamp: 'bs 2/23/2010 09:29:52.58'!
operationModeLabel
	^ self runsDistributed
		ifTrue: [ 'standalone mode' ]
		ifFalse: [ 'distribution mode' ]! !

!CSCodeSight methodsFor: 'accessing' stamp: 'bs 1/14/2010 09:37'!
packageChooser
	^ packageChooser! !

!CSCodeSight methodsFor: 'accessing' stamp: 'bs 1/14/2010 09:37'!
packageChooser: anObject
	packageChooser := anObject! !

!CSCodeSight methodsFor: 'package management' stamp: 'bs 1/4/2010 16:43'!
packageOfClass: aClass
	^ PackageOrganizer default
		packageOfClass: aClass
		ifNone: [PackageInfo named: (Smalltalk organization categoryOfElement: aClass name)].! !

!CSCodeSight methodsFor: 'package management' stamp: 'bs 2/23/2010 11:49:00.632'!
removeFromManagedPackages: aPackageInfo
	self managedPackages remove: aPackageInfo.
	^ self instrumentor uninstrumentPackage: aPackageInfo.! !

!CSCodeSight methodsFor: 'distribution-replicas' stamp: 'bs 2/25/2010 10:58:56.703'!
replicateModification: aSystemEvent
	| command |
	command := self testReplicator handle: aSystemEvent.
	{ self testActorId. self maintenanceActorId } do: [ :actorId | 
		actorId modification: command ].! !

!CSCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/25/2010 10:59:26.695'!
resetOpenEvents
	^ openEvents := SharedQueue2 new! !

!CSCodeSight methodsFor: 'distribution-messages' stamp: 'bs 3/2/2010 21:17:53.481'!
runTests: testMethodNames
	| testMethodsToRun |
	testMethodsToRun := testMethodNames collect: [ :name | CompiledMethod fromQualifiedName: name ].
	self csTestRunner reset; runTestMethods: testMethodsToRun.
	self developmentActorId testResult: self csTestRunner result copy.! !

!CSCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/23/2010 13:54:13.983'!
runningProcessId
	^ ThisOSProcess thisOSProcess pid.! !

!CSCodeSight methodsFor: 'tracing' stamp: 'bs 1/4/2010 14:57'!
runningTestMethod
	^ runningTestMethod
	! !

!CSCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:23:45.798'!
runsDistributed
	^ self distributionMode! !

!CSCodeSight methodsFor: 'distribution-accessing' stamp: 'bs 2/23/2010 09:24:18.858'!
runsStandalone
	self runsDistributed not! !

!CSCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/25/2010 08:39:15.208'!
startActorOnPort: anInteger

	self actor startOn: anInteger.! !

!CSCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/25/2010 08:39:10.874'!
startDevelopmentActor
	self startActorOnPort: self developmentActorPort! !

!CSCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 3/2/2010 21:13:09.607'!
startMaintenanceActor
	self startReplicaActorOnPort: self maintenanceActorPort.
	self csTestRunner tddAutoRunStop.
	self switchToWeavingInstrumentor.
	self activateTracing.! !

!CSCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/25/2010 08:38:55.908'!
startReplicaActorOnPort: anInteger
	
	Utilities setAuthorInitials: 'replica'.
	self actor startOn: anInteger.! !

!CSCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 3/2/2010 21:45:09.773'!
startTestActor
	self startReplicaActorOnPort: self testActorPort.
	self uninstrumentCode.! !

!CSCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/25/2010 08:39:06.365'!
switchToDistributedMode
	self
		turnOffStandaloneMode;
		turnOnDistributedMode.! !

!CSCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/23/2010 11:50:56.977'!
switchToStandaloneMode
	self 
		turnOffDistributedMode;
		turnOnStandaloneMode;
		makeStandalone.! !

!CSCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 3/2/2010 21:45:34.979'!
switchToWeavingInstrumentor
	self uninstrumentCode.
	self instrumentor: CSWeavingInstrumentor new.
	self instrumentor codeSight: self.
	self instrumentCode.! !

!CSCodeSight methodsFor: 'accessing' stamp: 'bs 1/17/2010 14:04'!
systemEventAnalyzer
	^ systemEventAnalyzer ifNil: [ systemEventAnalyzer := CSSystemEventAnalyzer new ]! !

!CSCodeSight methodsFor: 'accessing' stamp: 'bs 1/4/2010 10:47'!
systemNotifier
	^ SystemChangeNotifier uniqueInstance! !

!CSCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/25/2010 10:55:27.866'!
testActorId
	^ testActorId 
		ifNil: [ testActorId := ActorId localhostPort: self testActorPort ]! !

!CSCodeSight methodsFor: 'distribution-actors' stamp: 'bs 2/23/2010 08:49:39.406'!
testActorPort
	^ 12003! !

!CSCodeSight methodsFor: 'distribution-messages' stamp: 'bs 2/25/2010 12:08:23.61'!
testCoverage: testsToCoverageData
	| aTestMethod |
	testsToCoverageData keysAndValuesDo: [ :aTestName :coverageData |
		aTestMethod := CompiledMethod fromQualifiedName: aTestName.
		coverageData keysAndValuesDo: [ :aMethodName :classSymbols | 
			aTestMethod 
				called: (CompiledMethod fromQualifiedName: aMethodName) unwrappedMethod
				receiverClasses: (classSymbols collect: [ :ea | Smalltalk classNamed: ea ]) ]
		].
	self openEvents next afterRunningTestsOn: self csTestRunner.! !

!CSCodeSight methodsFor: 'tracing' stamp: 'bs 1/4/2010 14:57'!
testMethodGoingToRun: aCompiledMethod
	runningTestMethod := aCompiledMethod
	! !

!CSCodeSight methodsFor: 'distribution-replicas' stamp: 'bs 2/23/2010 13:29:47.025'!
testReplicator
	^ testReplicator! !

!CSCodeSight methodsFor: 'distribution-replicas' stamp: 'bs 2/23/2010 13:29:54.286'!
testReplicator: anObject
	testReplicator := anObject! !

!CSCodeSight methodsFor: 'distribution-messages' stamp: 'bs 3/3/2010 09:02:22.028'!
testResult: aTestResult
	self csTestRunner 
		result: aTestResult;
		updateResults;
		updateResultsInHistory! !

!CSCodeSight methodsFor: 'distribution-ui' stamp: 'bs 2/23/2010 11:52:13.677'!
toggleOperationMode
	self runsDistributed
		ifTrue: [ self switchToStandaloneMode ]
		ifFalse: [ self switchToDistributedMode ].
	self changed: #operationModeLabel.! !

!CSCodeSight methodsFor: 'test info' stamp: 'bs 1/14/2010 14:16'!
toggleSystemInstallation
	self isSystemInstance
		ifTrue: [ self uninstallFromSystem ]
		ifFalse: [ self installIntoSystem ].
		
	
	! !

!CSCodeSight methodsFor: 'ui-building' stamp: 'bs 2/23/2010 09:03:40.812'!
toolButtons
	^ #(( 'Package Chooser' #openPackageChooser )
		( 'Test Runner' #openTestRunner )
		( 'Test Driver' #openTestDriver )
		( #installUninstallLabel #toggleSystemInstallation )
		( #operationModeLabel #toggleOperationMode ))! !

!CSCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/25/2010 11:00:03.722'!
turnOffDistributedMode
	self actor stop.
	self testActorId close.
	self maintenanceActorId close.
	self testReplicator stopReplicaAndCleanUp.
	self maintenanceReplicator stopReplicaAndCleanUp.
	self resetOpenEvents.! !

!CSCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 3/2/2010 21:44:36.47'!
turnOffStandaloneMode! !

!CSCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 2/25/2010 11:46:10.529'!
turnOnDistributedMode
	| runningProcessId tmpTestReplicator tmpMaintenanceReplicator |
	tmpTestReplicator := (CSReplicator newTestReplicaOnPort: self testActorPort).
	tmpMaintenanceReplicator := (CSReplicator newMaintenanceReplicaOnPort: self maintenanceActorPort).
	
	runningProcessId := self runningProcessId.
	SmalltalkImage current snapshot: true andQuit: false.
	"check whether this is the process that created the replica"
	(runningProcessId == self runningProcessId) 
		ifTrue: [
			tmpTestReplicator createAndStartReplica.
			
			SmalltalkImage current snapshot: true andQuit: false.
			(runningProcessId == self runningProcessId) 
				ifTrue: [
					tmpMaintenanceReplicator createAndStartReplica.
					self testReplicator: tmpTestReplicator.
					self maintenanceReplicator: tmpMaintenanceReplicator.
					self startDevelopmentActor.
					self makeDistributed. ]
				ifFalse: [
					self startMaintenanceActor ] ]
		ifFalse: [
			self startTestActor ].! !

!CSCodeSight methodsFor: 'distribution-mode-switching' stamp: 'bs 3/2/2010 21:44:51.8'!
turnOnStandaloneMode! !

!CSCodeSight methodsFor: 'test info' stamp: 'bs 1/14/2010 14:16'!
uninstallFromSystem
	self csTestRunner removeDependent: CSInfo instance.
	CSInfo resetToZeroInfo.
	self isSystemInstance: false 
		
	
	! !

!CSCodeSight methodsFor: 'instrumenting' stamp: 'bs 2/23/2010 11:43:46.751'!
uninstrumentCode
	self managedPackages do: [ :aPackageInfo | 
		self instrumentor uninstrumentPackage: aPackageInfo ]! !

!CSCodeSight methodsFor: 'initialize-release' stamp: 'bs 1/14/2010 15:04'!
wasCleanedUp
	^ wasCleanedUp ifNil: [ wasCleanedUp := false ]! !

!CSCodeSight methodsFor: 'initialize-release' stamp: 'bs 1/14/2010 15:04'!
wasCleanedUp: aBoolean
	^ wasCleanedUp := aBoolean! !

CSCodeSight subclass: #CSCodeSightForDistributionRequestTests
	instanceVariableNames: 'distributionTestsDevelopmentActor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-DistributionTests'!

!CSCodeSightForDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:57:09.767'!
developmentActorId
	^ self distributionTestsDevelopmentActor ! !

!CSCodeSightForDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:56:48.729'!
distributionTestsDevelopmentActor
	^ distributionTestsDevelopmentActor 
		ifNil: [ distributionTestsDevelopmentActor := CSDistributionTestsDevelopmentActor new ]! !

Object subclass: #CSDistributionTestsDevelopmentActor
	instanceVariableNames: 'receivedTestResult receivedTestCoverage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-DistributionTests'!

!CSDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.603'!
receivedTestCoverage
	^ receivedTestCoverage! !

!CSDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.605'!
receivedTestResult 
	^ receivedTestResult! !

!CSDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.607'!
testCoverage: coverageData
	receivedTestCoverage := coverageData! !

!CSDistributionTestsDevelopmentActor methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:54:50.609'!
testResult: aTestResult
	receivedTestResult := aTestResult! !

Object subclass: #CSEvent
	instanceVariableNames: 'systemEvent testMethodsToRun'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Events'!

!CSEvent class methodsFor: 'instance creation' stamp: 'replica 2/23/2010 15:50:14.959'!
systemEvent: anEvent
	^ self new 
		systemEvent: anEvent; 
		yourself! !

!CSEvent methodsFor: 'handling' stamp: 'bs 3/1/2010 16:26:13.359'!
handle: codeSight
	codeSight instrumentor handle: self systemEvent.! !

!CSEvent methodsFor: 'accessing' stamp: 'replica 2/23/2010 15:52:16.542'!
systemEvent
	^ systemEvent! !

!CSEvent methodsFor: 'accessing' stamp: 'replica 2/23/2010 15:52:29.986'!
systemEvent: anObject
	systemEvent := anObject! !

!CSEvent methodsFor: 'accessing' stamp: 'replica 2/23/2010 15:52:35.412'!
testMethodsToRun
	^ testMethodsToRun! !

!CSEvent methodsFor: 'accessing' stamp: 'replica 2/23/2010 15:52:46.832'!
testMethodsToRun: anObject
	testMethodsToRun := anObject! !

CSEvent subclass: #CSModificationEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Events'!

!CSModificationEvent class methodsFor: 'instance creation' stamp: 'bs 1/16/2010 00:14'!
systemEvent: anEvent
	^ self new 
		systemEvent: anEvent; 
		yourself! !

!CSModificationEvent methodsFor: 'covered entities' stamp: 'bs 1/15/2010 09:17'!
affectedMethods
	self subclassResponsibility! !

!CSModificationEvent methodsFor: 'test-running' stamp: 'bs 1/23/2010 15:56'!
afterRunningTestsOn: aTestRunner
	! !

!CSModificationEvent methodsFor: 'test-running' stamp: 'bs 3/1/2010 18:56:14.651'!
beforeRunningTestsOn: aTestRunner

	self 
		recordEffectsOn: aTestRunner;
		testMethodsToRun: self collectTestMethodsToRun;
		resetCoverageData.
	! !

!CSModificationEvent methodsFor: 'test-driving' stamp: 'bs 1/23/2010 15:15'!
collectTestMethodsToRun
	self subclassResponsibility! !

!CSModificationEvent methodsFor: 'handling' stamp: 'bs 3/4/2010 21:55:59.947'!
handle: codeSight
	| testRunner |
	testRunner := codeSight csTestRunner.
	testRunner isInTddAutoRunMode
		ifFalse: [ codeSight instrumentor handle: self systemEvent ]
		ifTrue: [
			self beforeRunningTestsOn: testRunner.
			codeSight instrumentor handle: self systemEvent.
			self processOn: testRunner.
			codeSight runsDistributed
				ifTrue: [ codeSight openEvents nextPut: self ] ].
	
	! !

!CSModificationEvent methodsFor: 'test-driving' stamp: 'bs 3/1/2010 19:07:36.747'!
processOn: aTestRunner
	| codeSight testsToRun testMethodNames |
	codeSight := aTestRunner codeSight.
	testsToRun := aTestRunner defectTestMethods, self testMethodsToRun.
	codeSight runsDistributed
		ifFalse: [
			codeSight activateTracing.
			aTestRunner runTestsInSuite: testsToRun.
			codeSight deactivateTracing.
			self afterRunningTestsOn: aTestRunner	]
		ifTrue: [
			testMethodNames := testsToRun collect: [ :ea | ea qualifiedName ].
			codeSight testActorId runTests: testMethodNames.
			codeSight maintenanceActorId maintainCoverage: testMethodNames
			]! !

!CSModificationEvent methodsFor: 'test-driving' stamp: 'bs 1/15/2010 16:19'!
recordEffectsOn: aTddMonitor! !

!CSModificationEvent methodsFor: 'covered entities' stamp: 'bs 1/23/2010 15:22'!
resetCoverageData
	self resetCoverageOfAffectedMethods.
	self testMethodsToRun do: [ :testMethod | testMethod resetCoveredMethodsStatistics ].! !

!CSModificationEvent methodsFor: 'covered entities' stamp: 'bs 1/17/2010 22:13'!
resetCoverageOfAffectedMethods
	self affectedMethods do: [ :ea | ea resetCoveringTestMethods ]! !

CSModificationEvent subclass: #CSNonTestMethodEvent
	instanceVariableNames: 'oldDefects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Events'!

CSNonTestMethodEvent subclass: #CSAddedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Events'!

CSAddedEvent subclass: #CSMethodAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Events'!

!CSMethodAdded methodsFor: 'system event accessing' stamp: 'bs 1/16/2010 00:14'!
addedMethod
	^ self systemEvent item! !

!CSMethodAdded methodsFor: 'covered entities' stamp: 'bs 1/17/2010 21:50'!
affectedMethods
	^ Set with: self addedMethod! !

!CSMethodAdded methodsFor: 'test-driving' stamp: 'bs 1/23/2010 15:16'!
collectTestMethodsToRun
	^ (self addedMethod overriddenAndOverridingMethods
		gather: [ :supOrSubMethod | supOrSubMethod coveringTestMethods ]) 
			asIdentitySet! !

!CSMethodAdded methodsFor: 'test-driving' stamp: 'bs 1/17/2010 21:50'!
recordEffectsOn: aTestDriver
	aTestDriver tddMonitor nonTestMethodAddedOrModified: self addedMethod
	! !

CSNonTestMethodEvent subclass: #CSModifiedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Events'!

CSModifiedEvent subclass: #CSClassModified
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Events'!

!CSClassModified methodsFor: 'covered entities' stamp: 'bs 1/17/2010 15:18'!
affectedMethods
	| modifiedClass |
	modifiedClass := self modifiedClass.
	^ { modifiedClass. modifiedClass class }
		gather: [ :class | class withAllSubclasses 
			gather: [ :eachClass | eachClass methodDict values 
				 select: [ :eachMethod | eachMethod isTestMethod not ] ] ]! !

!CSClassModified methodsFor: 'test-driving' stamp: 'bs 1/23/2010 15:17'!
collectTestMethodsToRun
	^ self testMethods, (self affectedMethods gather: [ :ea | ea coveringTestMethods ]).
		! !

!CSClassModified methodsFor: 'system event accessing' stamp: 'bs 1/17/2010 15:24'!
modifiedClass
	^ self wasInstanceDefinitionModified
		ifTrue: [ self systemEvent oldItem ]
		ifFalse: [ self systemEvent item ].! !

!CSClassModified methodsFor: 'system event accessing' stamp: 'bs 1/15/2010 16:51'!
testMethods
	^ self modifiedClass isTestCaseClass
		ifTrue: [ self modifiedClass methodDict values select: [ :ea | ea isTestMethod ]  ]
		ifFalse: [ Set new ]! !

!CSClassModified methodsFor: 'system event accessing' stamp: 'bs 1/17/2010 21:36'!
wasInstanceDefinitionModified
	^ self systemEvent areInstVarsModified
		or: [ self systemEvent isSuperclassModified ]! !

CSModifiedEvent subclass: #CSMethodModified
	instanceVariableNames: 'previouslyFixedTests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Events'!

!CSMethodModified methodsFor: 'covered entities' stamp: 'bs 1/17/2010 21:49'!
affectedMethods
	^ Set with: self oldMethod! !

!CSMethodModified methodsFor: 'test-running' stamp: 'replica 2/24/2010 19:52:05.446'!
afterRunningTestsOn: aTestRunner
	"withTracingWrapper uninstall."
	
	previouslyFixedTests
		select: [ :ea | self newMethod coveringTestMethods includes: ea ]
		thenDo: [ :ea | self newMethod fixes: ea ].! !

!CSMethodModified methodsFor: 'test-running' stamp: 'bs 3/1/2010 18:55:00.383'!
beforeRunningTestsOn: aTestRunner
	super beforeRunningTestsOn: aTestRunner.
	previouslyFixedTests := self oldMethod fixedTestMethods.
	
	"selector := self newMethod selector.
	methodClass := self newMethod methodClass.
	
	withTracingWrapper := CSWithTracingWrapper 
			on: selector inClass: methodClass inContext: aTestRunner codeSight.
	withTracingWrapper install. "! !

!CSMethodModified methodsFor: 'test-driving' stamp: 'bs 1/23/2010 15:17'!
collectTestMethodsToRun
	^ self oldMethod coveringTestMethods "which are not available for modified version"! !

!CSMethodModified methodsFor: 'system event accessing' stamp: 'bs 1/16/2010 00:16'!
newMethod
	^ self systemEvent item! !

!CSMethodModified methodsFor: 'system event accessing' stamp: 'bs 1/16/2010 00:16'!
oldMethod
	^ self systemEvent oldItem! !

!CSMethodModified methodsFor: 'test-driving' stamp: 'bs 1/17/2010 21:49'!
recordEffectsOn: aTestDriver
	aTestDriver tddMonitor nonTestMethodAddedOrModified: self newMethod
	! !

!CSNonTestMethodEvent methodsFor: 'test-running' stamp: 'bs 1/23/2010 15:59'!
afterRunningTestsOn: aTestRunner
	| newDefects |
	newDefects := aTestRunner defectTestMethods.
	aTestRunner tddMonitor testsTurnedGreen: (oldDefects difference: newDefects).
	aTestRunner tddMonitor unsupportedTestsSpecified: (newDefects difference: oldDefects).
	"die zeile drber muss eigentlich weg und da muss so was hin wie, modification: brokeTests:"! !

!CSNonTestMethodEvent methodsFor: 'test-running' stamp: 'bs 3/1/2010 18:54:54.186'!
beforeRunningTestsOn: aTestRunner
	super beforeRunningTestsOn: aTestRunner.
	oldDefects := aTestRunner defectTestMethods.! !

!CSNonTestMethodEvent methodsFor: 'test-driving' stamp: 'bs 1/23/2010 15:16'!
collectTestMethodsToRun
	^ (self affectedMethods gather: [ :ea | ea coveringTestMethods ]) asSet! !

CSNonTestMethodEvent subclass: #CSRemovedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Events'!

CSRemovedEvent subclass: #CSClassRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Events'!

!CSClassRemoved methodsFor: 'covered entities' stamp: 'bs 1/15/2010 10:49'!
affectedMethods
	^ { self removedClass. self removedClass class } 
		gather: [ :eachClass | eachClass withAllSubclasses 
			gather: [ :eachSubclass | eachSubclass methodDict values 
				select: [ :eachMethod | eachMethod isTestMethod not ]  ] ]! !

!CSClassRemoved methodsFor: 'system event processing' stamp: 'bs 1/16/2010 00:17'!
removedClass
	^ self systemEvent item! !

!CSClassRemoved methodsFor: 'system event processing' stamp: 'bs 1/15/2010 11:34'!
removedMethods
	^ { self removedClass. self removedClass class } 
		gather: [ :eachClass | eachClass methodDict values ]! !

CSRemovedEvent subclass: #CSMethodRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Events'!

!CSMethodRemoved methodsFor: 'covered entities' stamp: 'bs 1/15/2010 13:03'!
affectedMethods
	^ self removedMethod isTestMethod
		ifTrue: [ { } ]
		ifFalse: [ { self removedMethod } ]! !

!CSMethodRemoved methodsFor: 'system event accessing' stamp: 'bs 1/16/2010 00:17'!
removedMethod
	^ self systemEvent item! !

!CSMethodRemoved methodsFor: 'system event accessing' stamp: 'bs 1/15/2010 11:33'!
removedMethods
	^ { self removedMethod }! !

!CSRemovedEvent methodsFor: 'test-driving' stamp: 'bs 1/15/2010 12:28'!
recordEffectsOn: aTestDriver
	self removedMethods do: [ :eachMethod | 
		eachMethod isTestMethod
			ifTrue: [ aTestDriver testMethodRemoved: eachMethod ]
			ifFalse: [ aTestDriver nonTestMethodRemoved: eachMethod ] ]! !

!CSRemovedEvent methodsFor: 'system event accessing' stamp: 'bs 1/15/2010 12:53'!
removedMethods
	self subclassResponsibility! !

!CSRemovedEvent methodsFor: 'system event accessing' stamp: 'bs 1/15/2010 16:14'!
removedTestMethods
	^ self removedMethods select: [ :ea | ea isTestMethod ]! !

!CSRemovedEvent methodsFor: 'covered entities' stamp: 'bs 1/17/2010 22:12'!
resetCoverageOfAffectedMethods
	super resetCoverageOfAffectedMethods.
	self removedTestMethods do: [ :ea | ea resetCoveredMethodsStatistics ].! !

CSModificationEvent subclass: #CSTestMethodAddedOrModified
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Events'!

!CSTestMethodAddedOrModified methodsFor: 'covered entities' stamp: 'bs 1/16/2010 00:19'!
affectedMethods
	^ Set new! !

!CSTestMethodAddedOrModified methodsFor: 'test-running' stamp: 'bs 1/23/2010 16:01'!
afterRunningTestsOn: aTestRunner
	(aTestRunner result isDefect: self testMethod)
		ifTrue: [ aTestRunner tddMonitor newBehaviorSpecified: self testMethod ]
		ifFalse: [ aTestRunner tddMonitor testsTurnedGreen: {self testMethod} ].! !

!CSTestMethodAddedOrModified methodsFor: 'test-driving' stamp: 'bs 1/23/2010 15:18'!
collectTestMethodsToRun
	^ Set with: self testMethod! !

!CSTestMethodAddedOrModified methodsFor: 'system event accessing' stamp: 'bs 1/17/2010 21:41'!
testMethod
	^ self systemEvent item! !

CSEvent subclass: #CSNoOpEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Events'!

!CSNoOpEvent methodsFor: 'handling' stamp: 'bs 3/1/2010 16:26:26.536'!
handle: codeSight
	super handle: codeSight! !

Object subclass: #CSEventHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Events'!

!CSEventHandler methodsFor: 'system event handling' stamp: 'replica 2/23/2010 15:36:12.918'!
categoryAdded: anAddedEvent
	^ nil! !

!CSEventHandler methodsFor: 'system event handling' stamp: 'replica 2/23/2010 15:36:08.189'!
categoryRemoved: aRemovedEvent
	^ nil! !

!CSEventHandler methodsFor: 'system event handling' stamp: 'replica 2/23/2010 15:36:04.333'!
categoryRenamed: aRenamedEvent
	^ nil! !

!CSEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 13:59'!
classAdded: anAddedEvent
	^ nil! !

!CSEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 13:59'!
classModified: aModifiedEvent
	^ nil! !

!CSEventHandler methodsFor: 'system event handling' stamp: 'replica 2/23/2010 15:35:18.688'!
classRecategorized: aRecategorizedEvent
	^ nil! !

!CSEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 13:59'!
classRemoved: aRemovedEvent
	^ nil! !

!CSEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 13:59'!
classRenamed: aRenamedEvent
	^ nil! !

!CSEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 13:59'!
classReorganized: aReorganizedEvent
	^ nil! !

!CSEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 13:59'!
handle: anEvent
	^ self perform: anEvent csEventHandlerSelector with: anEvent.! !

!CSEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 13:59'!
methodAdded: anAddedEvent
	^ nil! !

!CSEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 13:59'!
methodModified: aModifiedEvent
	^ nil! !

!CSEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 14:00'!
methodRecategorized: aRecategorizedEvent
	^ nil! !

!CSEventHandler methodsFor: 'system event handling' stamp: 'bs 1/17/2010 14:00'!
methodRemoved: aRemovedEvent
	^ nil! !

CSEventHandler subclass: #CSInstrumentor
	instanceVariableNames: 'classes packages methods handlesSystemEvents codeSight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracing'!

!CSInstrumentor methodsFor: 'instrumenting' stamp: 'bs 1/22/2010 18:11'!
canInstrument: selector inClass: aClass
	self subclassResponsibility! !

!CSInstrumentor methodsFor: 'system event handling' stamp: 'bs 3/2/2010 08:13:37.525'!
classAdded: anAddedEvent
	|aClass aClassPackage|
	aClass := anAddedEvent item.
	aClassPackage := PackageOrganizer default
		packageOfClass: aClass
		ifNone: [PackageInfo named: (Smalltalk organization categoryOfElement: aClass name)].
	
	(self instrumentedPackages includes: aClassPackage)
		ifTrue: [self instrumentClass: aClass].! !

!CSInstrumentor methodsFor: 'system event handling' stamp: 'bs 1/5/2010 15:10'!
classModified: aModifiedEvent
	|aClass|
	aClass := aModifiedEvent item.
	(self instrumentedClasses includes: aClass) 
		ifTrue: [
			self uninstrumentClass: aClass.
			self instrumentClass: aClass].! !

!CSInstrumentor methodsFor: 'system event handling' stamp: 'bs 3/8/2010 17:52:11.817'!
classRemoved: aRemovedEvent
	self uninstrumentClass: aRemovedEvent item.! !

!CSInstrumentor methodsFor: 'initialize-release' stamp: 'bs 1/4/2010 11:53'!
cleanUp
	self uninstrumentAllAndReset.! !

!CSInstrumentor methodsFor: 'accessing' stamp: 'bs 1/8/2010 16:17'!
codeSight
	^ codeSight! !

!CSInstrumentor methodsFor: 'accessing' stamp: 'bs 1/8/2010 16:17'!
codeSight: anObject
	codeSight := anObject! !

!CSInstrumentor methodsFor: 'initialize-release' stamp: 'bs 1/4/2010 11:53'!
finalize
	self cleanUp! !

!CSInstrumentor methodsFor: 'system event handling' stamp: 'bs 1/5/2010 16:10'!
handleEvent: anEvent
	self perform: anEvent csEventHandlerSelector with: anEvent.! !

!CSInstrumentor methodsFor: 'system event handling' stamp: 'bs 10/28/2009 21:25'!
handlesSystemEvents
	^ handlesSystemEvents ifNil: [handlesSystemEvents := false].! !

!CSInstrumentor methodsFor: 'system event handling' stamp: 'bs 10/28/2009 13:37'!
handlesSystemEvents: aBoolean
	^ handlesSystemEvents := aBoolean! !

!CSInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 1/22/2010 22:43'!
installInstrumentation: selector inClass: aClass
	| method extension |
	method := aClass >> selector.
	method hasManagedMethodExtension
		ifFalse: [
			extension := CSNonTestMethodExtension new.
			extension codeSight: self codeSight.
			extension clientMethod: method.
			method methodExtension: extension ].! !

!CSInstrumentor methodsFor: 'registration' stamp: 'bs 1/16/2010 20:54'!
instrumentClass: aClass
	|metaClass|
	metaClass := aClass class.
	(self instrumentedClasses includes: aClass) ifFalse: [
		{aClass. metaClass} do: [:c |
			self instrumentedClasses add: c.
			c selectors do: [:selector | self instrumentMethod: selector inClass: c ]]].! !

!CSInstrumentor methodsFor: 'registration' stamp: 'bs 3/8/2010 17:51:30.005'!
instrumentMethod: selector inClass: aClass
	| |
	(aClass >> selector) isTestMethod
		ifFalse: [
			(self isMethodInstrumented: selector inClass: aClass) 
				ifFalse: [
					(self canInstrument: selector inClass: aClass)
						ifTrue: [
							self installInstrumentation: selector inClass: aClass.
							(self instrumentedMethodsAt: aClass) add: selector ] ] ].! !

!CSInstrumentor methodsFor: 'instrumenting' stamp: 'bs 3/2/2010 22:43:48.408'!
instrumentPackage: aPackage
	(self instrumentedPackages includes: aPackage) 
		ifFalse: [
			(self mayPackageBeInstrumented: aPackage)
			 	ifTrue: [
					self instrumentedPackages add: aPackage.
					aPackage classes do: [:aClass | self instrumentClass: aClass ].
					^ true ] ].
	^ false.! !

!CSInstrumentor methodsFor: 'registration' stamp: 'bs 10/28/2009 14:09'!
instrumentedClasses
	"classes := nil"
	^ classes ifNil: [classes := WeakSet new]! !

!CSInstrumentor methodsFor: 'registration' stamp: 'bs 10/28/2009 14:09'!
instrumentedMethods
	^ methods ifNil: [methods := WeakKeyDictionary new] ! !

!CSInstrumentor methodsFor: 'registration' stamp: 'bs 10/28/2009 13:17'!
instrumentedMethodsAt: aClass
	^ self instrumentedMethods at: aClass ifAbsentPut: [Set new]
	
	"(self registeredPackages includes: aPackage) ifFalse: [
		self registeredPackages add: aPackage.
		aPackage classes reject: [:aClass | aClass inheritsFrom: TestCase]
							  thenDo: [:class | class selectors do: [:selector | 
				(self on: selector inClass: class) ifNotNilDo: [:wrapper | wrapper install]]]]"! !

!CSInstrumentor methodsFor: 'instrumenting' stamp: 'bs 10/28/2009 14:09'!
instrumentedPackages
	"packages := nil"
	^ packages ifNil: [packages := WeakSet new]! !

!CSInstrumentor methodsFor: 'testing' stamp: 'bs 1/4/2010 16:26'!
isClassInstrumented: aClass
	^ self instrumentedClasses includes: aClass! !

!CSInstrumentor methodsFor: 'registration' stamp: 'bs 3/8/2010 17:47:22.759'!
isMethodInstrumented: selector inClass: aClass
	^ (self instrumentedMethods at: aClass ifAbsent: [Array empty]) includes: selector
	! !

!CSInstrumentor methodsFor: 'instrumenting' stamp: 'bs 1/16/2010 11:00'!
mayPackageBeInstrumented: aPackage
	^ (aPackage name startsWith: 'CodeSight')
		ifTrue: [ (self instrumentedPackages anySatisfy: [ :ea | ea name startsWith: 'CodeSight' ]) not ]
		ifFalse: [ true ]! !

!CSInstrumentor methodsFor: 'system event handling' stamp: 'bs 3/2/2010 13:41:50.157'!
methodAdded: anAddedEvent
	| selector class |
	selector := anAddedEvent itemSelector.
	class := anAddedEvent itemClass.
	
	(self instrumentedClasses includes: class) ifTrue: [
		self instrumentMethod: selector inClass: class].! !

!CSInstrumentor methodsFor: 'system event handling' stamp: 'bs 3/1/2010 14:42:17.734'!
methodModified: aModifiedEvent
	| selector class |
	
	selector := aModifiedEvent itemSelector.
	class := aModifiedEvent itemClass.
	
	(self isMethodInstrumented: selector inClass: class) ifTrue: [
		self uninstrumentMethod: aModifiedEvent oldItem.
		self instrumentMethod: selector inClass: class ].! !

!CSInstrumentor methodsFor: 'system event handling' stamp: 'bs 3/2/2010 13:41:14.823'!
methodRemoved: aRemovedEvent
	| removedMethod selector class |
	removedMethod := aRemovedEvent item.
	selector := aRemovedEvent itemSelector.
	class := aRemovedEvent itemClass.
	
	(self isMethodInstrumented: selector inClass: class) ifTrue: [
		self uninstrumentMethod: removedMethod ].! !

!CSInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 3/2/2010 23:07:08.158'!
uninstallInstrumentation: aCompiledMethod
	self subclassResponsibility! !

!CSInstrumentor methodsFor: 'instrumenting' stamp: 'bs 3/4/2010 22:06:36.389'!
uninstrumentAllAndReset
	self instrumentedPackages do: [:ea | self uninstrumentPackage: ea].
	self instrumentedClasses do: [:ea | self uninstrumentClass: ea].
	self instrumentedMethods keysAndValuesDo: [ :aClass :selectors | 
		selectors do: [:s | self uninstrumentMethod: (aClass >> s) ] ].
	self instrumentedMethods keysAndValuesRemove: [:k :v| true].! !

!CSInstrumentor methodsFor: 'registration' stamp: 'bs 1/22/2010 23:27'!
uninstrumentClass: aClass
	| metaClass |
	metaClass := aClass class.
	(self instrumentedClasses includes: aClass)
		ifTrue: [
			self instrumentedClasses remove: aClass.
			self instrumentedClasses remove: metaClass ifAbsent:[]].
	
	{aClass. metaClass} do: [:c |
		c methodDict values do: [:method | self uninstrumentMethod: method ]].! !

!CSInstrumentor methodsFor: 'registration' stamp: 'bs 3/8/2010 17:49:14.942'!
uninstrumentMethod: aCompiledMethod
	| registeredMethods aClass selector |
	aClass := aCompiledMethod methodClass.
	selector := aCompiledMethod selector.
	(self isMethodInstrumented: selector inClass: aClass) 
		ifTrue: [
			registeredMethods := self instrumentedMethodsAt: aClass.
			self uninstallInstrumentation: aCompiledMethod.
			registeredMethods remove: selector.
			registeredMethods ifEmpty: [self instrumentedMethods removeKey: aClass] ].! !

!CSInstrumentor methodsFor: 'instrumenting' stamp: 'bs 3/2/2010 22:40:41.239'!
uninstrumentPackage: aPackage
	(self instrumentedPackages includes: aPackage) 
		ifTrue: [
			aPackage classes do: [:aClass | self uninstrumentClass: aClass].
			self instrumentedPackages remove: aPackage ]! !

CSInstrumentor subclass: #CSWeavingInstrumentor
	instanceVariableNames: ''
	classVariableNames: 'MethodIndices'
	poolDictionaries: ''
	category: 'CodeSight-Tracing'!

!CSWeavingInstrumentor class methodsFor: 'method extension indexing' stamp: 'replica 3/1/2010 09:16:37.941'!
indexForMethodExtension: aMethodExtension
	(self orderedMethodExtensions includes: aMethodExtension)
		ifFalse: [ self orderedMethodExtensions add: aMethodExtension ].
	^ self orderedMethodExtensions indexOf: aMethodExtension.! !

!CSWeavingInstrumentor class methodsFor: 'method extension indexing' stamp: 'replica 3/1/2010 09:16:42.5'!
methodExtensionAtIndex: anIndex
	^ self orderedMethodExtensions at: anIndex! !

!CSWeavingInstrumentor class methodsFor: 'method extension indexing' stamp: 'bs 3/2/2010 13:02:42.231'!
orderedMethodExtensions
	^ MethodIndices ifNil: [ MethodIndices := IndexedIdentityCollection new ]! !

!CSWeavingInstrumentor class methodsFor: 'method extension indexing' stamp: 'bs 3/2/2010 23:02:34.353'!
removeIndexForMethodExtension: aMethodExtension
	self orderedMethodExtensions remove: aMethodExtension ifAbsent: []! !

!CSWeavingInstrumentor class methodsFor: 'method extension indexing' stamp: 'replica 3/1/2010 09:16:57.575'!
resetMethodExtensionIndex
	MethodIndices := nil! !

!CSWeavingInstrumentor methodsFor: 'instrumenting' stamp: 'bs 1/22/2010 18:40'!
canInstrument: selector inClass: aClass
	
	(self canInstrumentClass: aClass) ifFalse: [ ^ false ].
	(aClass respondsTo: #canInstrument:) 
		ifTrue: [ ^ aClass canInstrument: selector ]
		ifFalse: [ ^ true ]! !

!CSWeavingInstrumentor methodsFor: 'instrumenting' stamp: 'bs 1/22/2010 18:32'!
canInstrumentClass: aClass
	| classesNotToBeInstrumented |
	classesNotToBeInstrumented := {CSTestStatistic. CSInstrumentor. CSInstrumentor class. CSWrappingInstrumentor. CSWrappingInstrumentor class. CSWeavingInstrumentor. CSWeavingInstrumentor class.}.
	
	^ (classesNotToBeInstrumented includes: aClass) not! !

!CSWeavingInstrumentor methodsFor: 'generation' stamp: 'bs 3/5/2010 09:37:29.638'!
createTraceCallFor: aCompiledMethod
	| extIndex traceCallString tmpMethodNode |
	extIndex := CSWeavingInstrumentor indexForMethodExtension: aCompiledMethod methodExtension.
	
	traceCallString := 
		'(' , CSWeavingInstrumentor asString , ' methodExtensionAtIndex: ' , extIndex asString , ')' ,
		'     calledByRunningTestWithReceiver: self'.

	tmpMethodNode := Parser new parse: 'foo ' , traceCallString class: Object.
	^ tmpMethodNode body statements first! !

!CSWeavingInstrumentor methodsFor: 'generation' stamp: 'bs 3/5/2010 09:31:06.12'!
generateTracingAdaptationOf: aCompiledMethod
	| methodNode traceCallNode instrumentedMethod |
	
	methodNode := self parseSource: aCompiledMethod.
	
	traceCallNode := self createTraceCallFor: aCompiledMethod.
	methodNode body statements addFirst: traceCallNode.
	
	instrumentedMethod := methodNode generate. 
	instrumentedMethod uninstrumentedMethod: aCompiledMethod.
		
	^ instrumentedMethod! !

!CSWeavingInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 3/5/2010 11:34:53.025'!
installInstrumentation: selector inClass: aClass
	| original adaptation |
	super installInstrumentation: selector inClass: aClass.
	original := aClass >> selector.
	adaptation := self generateTracingAdaptationOf: original.
	adaptation methodExtension: original methodExtension.
	adaptation installSilently.! !

!CSWeavingInstrumentor methodsFor: 'generation' stamp: 'bs 3/5/2010 09:32:21.454'!
parseSource: aCompiledMethod
	| source |
	source := aCompiledMethod getSource.
	^ Parser new parse: source class: aCompiledMethod methodClass.
	! !

!CSWeavingInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 3/5/2010 11:28:41.501'!
uninstallInstrumentation: aCompiledMethod
	(aCompiledMethod isInstrumentedMethod) 
		ifTrue: [
			CSWeavingInstrumentor removeIndexForMethodExtension: aCompiledMethod methodExtension.
			aCompiledMethod resetAllCoverageData..
			aCompiledMethod isInstalled
				ifTrue: [ aCompiledMethod reinstallUninstrumentedMethodSilently ] ].! !

CSInstrumentor subclass: #CSWrappingInstrumentor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracing'!

!CSWrappingInstrumentor methodsFor: 'instrumenting' stamp: 'bs 3/2/2010 13:36:53.328'!
canInstrument: selector inClass: aClass
	^ CSCoverageTracingWrapper canWrap: selector inClass: aClass.! !

!CSWrappingInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 3/2/2010 13:36:56.849'!
installInstrumentation: selector inClass: aClass
	| wrapper |
	super installInstrumentation: selector inClass: aClass.
	SystemChangeNotifier uniqueInstance doSilently: [
		wrapper := CSCoverageTracingWrapper on: selector inClass: aClass.
		wrapper install ]! !

!CSWrappingInstrumentor methodsFor: 'install-uninstall' stamp: 'bs 3/5/2010 11:21:52.916'!
uninstallInstrumentation: aCompiledMethod
	aCompiledMethod isMwMethodWrapper 
		ifTrue: [	
			aCompiledMethod resetAllCoverageData.
			aCompiledMethod isInstalled 
				ifTrue: [ aCompiledMethod uninstall ] ].! !

CSEventHandler subclass: #CSReplicaCommandCreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Distribution'!

!CSReplicaCommandCreator methodsFor: 'system event handling' stamp: 'bs 1/28/2010 21:29:26.234'!
classAdded: anAddedEvent! !

CSEventHandler subclass: #CSReplicaService
	instanceVariableNames: 'listenSocket servingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Distribution'!

!CSReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 2/20/2010 21:52:29.538'!
receiveAndProcess: aSocket
	| receivedMessage |
	receivedMessage := CSReplicateMessage receiveFrom: aSocket.
	receivedMessage applyCommand.
	self codeSight 
		ifNotNil: [ self codeSight csTestRunner result copy ]! !

!CSReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 1/31/2010 08:59:23.349'!
runLoop
	"Run the server's connection accept loop."
	| newConnectionSocket |
	
	[listenSocket isValid]
		whileTrue: 
			[[newConnectionSocket := listenSocket waitForAcceptFor: 10]
				on: ConnectionTimedOut
				do: [:ex | newConnectionSocket := nil].
			 newConnectionSocket isNil
				ifFalse:
					[ self serve: newConnectionSocket ] ]! !

!CSReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 2/21/2010 10:09:28.483'!
serve: aSocket
	| receivedMessage |
	[aSocket isValid and: [aSocket isConnected] ] 
		whileTrue: [
			aSocket waitForDataIfClosed: [ ].
			receivedMessage := CSReplicateMessage receiveFrom: aSocket.
			receivedMessage applyCommand ] 
	! !

!CSReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 1/30/2010 16:38:39.339'!
servicePriority
	^ Processor lowIOPriority! !

!CSReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 2/21/2010 09:43:23.521'!
startOn: portNumber
	
	listenSocket := Socket newTCP.
	listenSocket listenOn: portNumber backlogSize: 2.
	listenSocket isValid ifFalse: [^self error: 'Could not create server socket'].
	servingProcess := [self runLoop] forkAt: self servicePriority.! !

!CSReplicaService methodsFor: 'as yet unclassified' stamp: 'bs 1/30/2010 19:21:28.985'!
stop
	servingProcess terminate.
	listenSocket closeAndDestroy.! !

CSEventHandler subclass: #CSReplicator
	instanceVariableNames: 'replicaName servicePort clientSocket replicaProcess actorId'
	classVariableNames: 'Instances'
	poolDictionaries: ''
	category: 'CodeSight-Distribution'!

!CSReplicator class methodsFor: 'instance creation' stamp: 'bs 2/8/2010 20:06:14.991'!
existsInstanceWithName: aName orPort: anInteger
	^ self instances 
		anySatisfy: [ :aReplicator | 
			(aReplicator replicaName = aName) 
				or: [ aReplicator servicePort = anInteger ] ]! !

!CSReplicator class methodsFor: 'class initialization' stamp: 'bs 1/27/2010 22:08:28.259'!
initialize
	" self initialize "
	super initialize.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!CSReplicator class methodsFor: 'accessing' stamp: 'bs 2/8/2010 18:14:39.907'!
instances
	" Instances := nil "
	^ Instances ifNil: [ Instances := WeakSet new ]! !

!CSReplicator class methodsFor: 'instance creation' stamp: 'bs 1/27/2010 22:29:37.5'!
new
	self error: 'only use newWithReplicaName: '! !

!CSReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:58:09.773'!
newMaintenanceReplica
	^ self newMaintenanceReplicaOnPort: 9998.! !

!CSReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:58:15.342'!
newMaintenanceReplicaOnPort: anInteger
	^ self 
		newReplicaNamed: 'maintenance'
		servingOnPort: anInteger.! !

!CSReplicator class methodsFor: 'instance creation' stamp: 'bs 2/8/2010 20:06:49.034'!
newReplicaNamed: aName servingOnPort: anInteger
	(self existsInstanceWithName: aName orPort: anInteger)
		ifTrue: [ self error: ('there already exists a replicated image ',
					'with name: {1} or port: {2}' format: {aName asString. anInteger asString}) ].
	
	^ self instances add: ( 
		super new 
			replicaName: aName; 
			servicePort: anInteger;
			yourself ).
			! !

!CSReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:56:40.482'!
newTestReplica
	^ self newTestReplicaOnPort: 9999! !

!CSReplicator class methodsFor: 'instance creation' stamp: 'bs 2/23/2010 11:56:10.667'!
newTestReplicaOnPort: anInteger
	^ self 
		newReplicaNamed: 'testFeedback'
		servingOnPort: anInteger! !

!CSReplicator class methodsFor: 'instance creation' stamp: 'bs 2/8/2010 20:04:59.818'!
remove: aReplicator
	self instances remove: aReplicator ifAbsent: []! !

!CSReplicator class methodsFor: 'system startup' stamp: 'bs 1/27/2010 22:07:53.751'!
shutDown: aboutToQuit
	Transcript cr; show: 'shutDown: ', aboutToQuit asString.! !

!CSReplicator class methodsFor: 'system startup' stamp: 'bs 1/27/2010 22:07:38.281'!
startUp: resuming
	Transcript cr; show: 'startUp: ', resuming asString.! !

!CSReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:02:26.951'!
categoryAdded: anAddedEvent
	| categoryName |
	categoryName := anAddedEvent item.
	^ 'Smalltalk organization addCategory: ''{1}''' format: {categoryName}! !

!CSReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:49:16.088'!
categoryRemoved: aRemovedEvent
	| categoryName |
	categoryName := aRemovedEvent item.
	^ 'Smalltalk organization removeCategory: ''{1}''' format: {categoryName}! !

!CSReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:50:29.154'!
categoryRenamed: aRenamedEvent

	^ 'Smalltalk organization renameCategory: ''{1}'' toBe: ''{2}''' 
		format: {aRenamedEvent oldName. aRenamedEvent newName.}! !

!CSReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:30:52.584'!
changeExtension
	^ self extensionForSuffix: FileDirectory changeSuffix.! !

!CSReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 16:11:24.896'!
classAdded: anAddedEvent
	^ self classAddedOrModified: anAddedEvent! !

!CSReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 16:11:08.601'!
classAddedOrModified: anEvent
	| addedOrModifiedClass | 
	addedOrModifiedClass := anEvent item.
	^ addedOrModifiedClass definition.! !

!CSReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 09:48:24.449'!
classModified: aModifiedEvent
	^ self classAddedOrModified: aModifiedEvent! !

!CSReplicator methodsFor: 'system event handling' stamp: 'bs 2/20/2010 19:26:21.287'!
classRecategorized: aRecategorizedEvent
	| aClass |
	aClass := aRecategorizedEvent item.
	^ '{1} category: ''{2}''' format: {aClass. aClass category}! !

!CSReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 16:13:32.5'!
classRemoved: aRemovedEvent
	| removedClass | 
	removedClass := aRemovedEvent item.
	^ '{1} removeFromSystem' format: {removedClass name}! !

!CSReplicator methodsFor: 'system event handling' stamp: 'bs 2/8/2010 17:24:47.292'!
classRenamed: aRenamedEvent

	^ '{1} rename: ''{2}''' 
		format: {aRenamedEvent oldName. aRenamedEvent newName}! !

!CSReplicator methodsFor: 'system event handling' stamp: 'bs 2/20/2010 20:01:02.201'!
classReorganized: aReorganizedEvent
	| aClass |
	aClass := aReorganizedEvent item.
	^ '{1} do: [ :eachCategory | {2} organization addCategory: eachCategory ]'
		format: {aClass organization categories. aClass}! !

!CSReplicator methodsFor: 'start / stop' stamp: 'bs 2/23/2010 13:49:48.655'!
createAndStartReplica
	self 
		createCopyOfThisImage;
		startReplicaInNewProcess! !

!CSReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:08:22.907'!
createCopyOfThisImage
	
	self deleteReplicaImage.
	
	self squeakFileExtensions do: [ :extension | 
		FileDirectory default
			copyFileNamed: self nameOfThisImage, extension 
			toFileNamed: self nameOfReplicaImage, extension. ].! !

!CSReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:09:31.959'!
deleteReplicaImage

	self squeakFileExtensions do: [ :extension | 
		FileDirectory default 
			deleteFileNamed: self nameOfReplicaImage, extension ifAbsent: [] ]! !

!CSReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:29:49.375'!
extensionForSuffix: aSuffix
	^ FileDirectory dot, aSuffix
	! !

!CSReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:30:47.418'!
imageExtension
	^ self extensionForSuffix: FileDirectory imageSuffix.! !

!CSReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 10:04:10.971'!
methodAdded: anAddedEvent
	^ self methodAddedOrModified: anAddedEvent! !

!CSReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 13:35:06.984'!
methodAddedOrModified: anEvent
	| source sourceWithDoubleEscapedStrings |
	source := anEvent item getSource asString.
	sourceWithDoubleEscapedStrings := source copyReplaceAll: '''' with: ''''''.
	^ '{1} compile: ''{2}''' 
		format: {anEvent itemClass. sourceWithDoubleEscapedStrings}! !

!CSReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 10:04:18.132'!
methodModified: anAddedEvent
	^ self methodAddedOrModified: anAddedEvent! !

!CSReplicator methodsFor: 'system event handling' stamp: 'bs 2/9/2010 12:50:29.172'!
methodRemoved: aRemovedEvent
	^ '{1} removeSelector: #{2}' 
		format: {aRemovedEvent itemClass. aRemovedEvent itemSelector}! !

!CSReplicator methodsFor: 'image accessing' stamp: 'bs 1/26/2010 22:05:12.719'!
nameOfReplicaImage
	^ self nameOfThisImage, '-replicated-', self replicaName! !

!CSReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 16:38:57.122'!
nameOfThisImage
	| imageFilePath imageFileName |
	imageFilePath := SmalltalkImage current imageName.
	imageFileName := self workingDirectory localNameFor: imageFilePath.
	^ FileDirectory baseNameFor: imageFileName.	! !

!CSReplicator methodsFor: 'start / stop' stamp: 'bs 1/29/2010 18:40:52.767'!
parentProcessId
	^ ThisOSProcess thisOSProcess ppid.! !

!CSReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 17:24:46.072'!
replicaImageName
	^ self nameOfReplicaImage! !

!CSReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 17:32:03.545'!
replicaImagePath
	^ self workingDirectory fullNameFor: (self replicaImageName, self imageExtension)! !

!CSReplicator methodsFor: 'accessing' stamp: 'bs 1/26/2010 21:52:51.519'!
replicaName
	^ replicaName! !

!CSReplicator methodsFor: 'accessing' stamp: 'bs 1/26/2010 21:52:51.52'!
replicaName: anObject
	replicaName := anObject! !

!CSReplicator methodsFor: 'accessing' stamp: 'bs 1/29/2010 18:15:05.076'!
replicaProcess
	^ replicaProcess! !

!CSReplicator methodsFor: 'accessing' stamp: 'bs 1/29/2010 18:15:05.077'!
replicaProcess: anObject
	replicaProcess := anObject! !

!CSReplicator methodsFor: 'start / stop' stamp: 'bs 1/29/2010 21:30:34.71'!
runningProcessId
	^ ThisOSProcess thisOSProcess pid.! !

!CSReplicator methodsFor: 'accessing' stamp: 'bs 2/8/2010 19:55:06.275'!
servicePort
	^ servicePort! !

!CSReplicator methodsFor: 'accessing' stamp: 'bs 2/8/2010 19:55:06.276'!
servicePort: anObject
	servicePort := anObject! !

!CSReplicator methodsFor: 'image files' stamp: 'bs 1/29/2010 17:31:15.856'!
squeakFileExtensions
	^ { self imageExtension. self changeExtension } ! !

!CSReplicator methodsFor: 'start / stop' stamp: 'bs 3/2/2010 21:42:11.538'!
startReplicaInNewProcess
	| squeakVmPath |
	squeakVmPath := OSProcess programName.
	self replicaProcess: (
		ExternalOSProcess concreteClass 
			programName: squeakVmPath 
			arguments: { "'-headless'." self replicaImagePath. } 
			initialEnvironment: nil ).
	self replicaProcess value.! !

!CSReplicator methodsFor: 'start / stop' stamp: 'bs 2/25/2010 10:56:34.6'!
stopReplicaAndCleanUp
	self class remove: self.
	self 
		stopReplicaProcess;
		deleteReplicaImage! !

!CSReplicator methodsFor: 'start / stop' stamp: 'replica 2/24/2010 22:09:37.556'!
stopReplicaProcess
	self replicaProcess 
		ifNotNil: [ self replicaProcess terminate ].
	! !

!CSReplicator methodsFor: 'image accessing' stamp: 'bs 1/29/2010 16:38:41.204'!
workingDirectory
	^ FileDirectory default! !

CSEventHandler subclass: #CSSystemEventAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Events'!

!CSSystemEventAnalyzer methodsFor: 'system event handling' stamp: 'replica 2/23/2010 15:47:59.183'!
analyze: aSystemEvent
	| anEventFactory |
	anEventFactory := (self handle: aSystemEvent) ifNil: [ CSNoOpEvent ].
	^ anEventFactory systemEvent: aSystemEvent.! !

!CSSystemEventAnalyzer methodsFor: 'system event handling' stamp: 'replica 2/23/2010 15:39:26.514'!
classModified: aModifiedEvent	
	^ CSClassModified! !

!CSSystemEventAnalyzer methodsFor: 'system event handling' stamp: 'replica 2/23/2010 15:39:30.633'!
classRemoved: aRemovedEvent
	^ CSClassRemoved! !

!CSSystemEventAnalyzer methodsFor: 'system event handling' stamp: 'replica 2/23/2010 15:39:46.871'!
methodAdded: anAddedEvent 
	^ anAddedEvent item isTestMethod 
		ifTrue: [ CSTestMethodAddedOrModified ]
		ifFalse: [ CSMethodAdded ].! !

!CSSystemEventAnalyzer methodsFor: 'system event handling' stamp: 'replica 2/23/2010 15:39:56.977'!
methodModified: aModifiedEvent
	^ aModifiedEvent oldItem isTestMethod 
		ifTrue: [ CSTestMethodAddedOrModified ]
		ifFalse: [ CSMethodModified ].! !

!CSSystemEventAnalyzer methodsFor: 'system event handling' stamp: 'replica 2/23/2010 15:40:01.367'!
methodRemoved: aRemovedEvent
	^ CSMethodRemoved! !

Object subclass: #CSFailedExpressionStyler
	instanceVariableNames: ''
	classVariableNames: 'RegisteredInstance'
	poolDictionaries: ''
	category: 'CodeSight-Text'!

!CSFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:30'!
initialize
	"self initialize"
	super initialize.
	self load.! !

!CSFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:33'!
load
	self registeredInstance: self new.
	SwaSourceTextStyler instance registerStyler: self registeredInstance.! !

!CSFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:29'!
registeredInstance
	^ RegisteredInstance! !

!CSFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:29'!
registeredInstance: anInstance
	^ RegisteredInstance := anInstance! !

!CSFailedExpressionStyler class methodsFor: 'initialize-release' stamp: 'bs 12/22/2009 10:30'!
unload
	SwaSourceTextStyler instance unregisterStyler: self registeredInstance.
	self registeredInstance: nil.! !

!CSFailedExpressionStyler methodsFor: 'styling' stamp: 'bs 12/22/2009 10:15'!
createFailedExpressionAttribute
	^ CSTextBackgroundColor new
		color: Color red darker;
		yourself! !

!CSFailedExpressionStyler methodsFor: 'styling' stamp: 'bs 12/31/2009 16:24'!
styleSource: aText of: aCompiledMethod
	| styledSourceText failedExpressionTextInterval |
	styledSourceText := aText.
	(aCompiledMethod isTestMethod and: [aCompiledMethod hasTestFailed])
		ifTrue: [
			failedExpressionTextInterval := aCompiledMethod failedExpressionInterval.
			styledSourceText 
				addAttribute: self createFailedExpressionAttribute
				from: failedExpressionTextInterval first
				to: failedExpressionTextInterval last ].
	^ styledSourceText.! !

Object subclass: #CSFixedAnalyzer
	instanceVariableNames: 'package codeRevisionsCoverage installer filenames methodModificationsOverTime methodAdditionsOverTime fixedRelationshipOverTime fixedCoverageDeltas codeSight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Analyzing'!

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:18'!
addedMethodsAt: revision
	^ self methodAdditionsOverTime at: revision! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:18'!
addedMethodsAt: revision put: methodNames
	^ self methodAdditionsOverTime at: revision put: methodNames! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 3/8/2010 21:04:06.838'!
analyzeCoverageForVersion: aVersionNumber	
	self codeSight addToManagedPackages: self package.
	self codeSight activateTracing.
	self runAllTestsOfPackage.
	self codeSight deactivateTracing.
	self gatherCoverageDataAndStoreAsVersion: aVersionNumber.
	self codeSight removeFromManagedPackages: self package.
	! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:45'!
analyzeCoverageOverTime
	| alreadyRunThrough |
	alreadyRunThrough := 0.
	self filenames withIndexDo: [:filename :index |
		(index > alreadyRunThrough) ifTrue: [
			Transcript cr; show: index asString, ' started ... '.
			self installer uninstallPackage.
			Transcript show: 'uninstalled ...'.
			self installer installFromCache: filename.
			Transcript show: 'installed ...'.
			self analyzeCoverageForVersion: index.
			Transcript clear. ] ].! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2010 11:23:37.678'!
analyzeFixedRelationshipsOverTime
	|  madeItRunInRevisions revision methodsAdded methodsModified madeItRun fixedTests previousRevision previousCoveringTestMethods coverageDifference previousMadeItRun newTests newlyCoveringTests notNewButNewlyCoveringTests newAndNewlyCoveringTests |
	
	madeItRunInRevisions := fixedRelationshipOverTime := Dictionary new.
	filenames withIndexDo: [:filename :index |
		Transcript show: filename, ' started ... '.
		revision := self codeRevisionsCoverage at: index.
		methodsAdded := self addedMethodsAt: index.
		methodsModified := self modifiedMethodsAt: index.
	
		madeItRun := madeItRunInRevisions at: index put: Dictionary new.
	 
		revision keysAndValuesDo: [:appMethod :coveringTestMethods |
			fixedTests := madeItRun at: appMethod put: Set new.
			(methodsAdded includes: appMethod)
				ifTrue: [
					fixedTests addAll: coveringTestMethods.
					"entweder ist der test neu, falls nicht, muss ich aber von einem verschieben von funktionalitt ausgehen" ]
				ifFalse: [
					newTests := nil. "all tests that are in new this revision"
					previousRevision := self codeRevisionsCoverage at: (index - 1).
					previousCoveringTestMethods := previousRevision at: appMethod.
					coverageDifference := coveringTestMethods difference: previousCoveringTestMethods.
					
					previousMadeItRun := (madeItRunInRevisions at: (index - 1)) at: appMethod.
					fixedTests addAll: (previousMadeItRun intersection: coveringTestMethods).
					
					newlyCoveringTests := coveringTestMethods difference: previousCoveringTestMethods.
					notNewButNewlyCoveringTests := newlyCoveringTests difference: newTests.
					"von diesen - notNewButNewlyCoveringTests; 
					 alle tests, die vor der erstellung dieser methode schon existiert haben,
					 da mglicherweise ein verschieben von funktionalitt statt gefunden hat"
					
					(methodsModified includes: appMethod)
						ifTrue: [ 
							newAndNewlyCoveringTests := newlyCoveringTests intersection: newTests.
							fixedTests addAll: newAndNewlyCoveringTests ]
						"ifFalse: [
							previousCoveringTestMethods isEmpty
								ifTrue: [
									fixedTests addAll: coverageDifference ]
								ifFalse: [
									previousMadeItRun := (madeItRunInRevisions at: (index - 1)) at: appMethod.
									fixedTests addAll: (previousMadeItRun intersection: coveringTestMethods) ].
						 	]."
				 	].
			]. 
		Transcript clear ].! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 11:35'!
analyzeForMethodModifications
	| modifiedMethodNames previousRevision currentRevision patch modifications |
	previousRevision := nil.
	self filenames withIndexDo: [:filename :index |
		Transcript show: filename, ' started ... '.
		currentRevision := self installer readVersionFromCache: filename.
		modifiedMethodNames := self modifiedMethodsAt: index put: Set new.
		previousRevision ifNotNil: [
			patch := previousRevision package snapshot patchRelativeToBase: currentRevision snapshot.
			modifications := patch operations select: [:ea | ea isModification and: [ea obsoletion isMethodDefinition]].
			modifications do: [:ea | 
				modifiedMethodNames add: (ea obsoletion className, ' >> #', ea obsoletion selector) ] ].
		previousRevision := currentRevision.
		Transcript clear. ].! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 13:02'!
analyzeForMethodsAdded
	| coverage previousCoverage addedMethodNames |
	self filenames withIndexDo: [:filename :index |
		Transcript show: filename, ' started ... '.
		coverage := self codeRevisionsCoverage at: index.
		(index = 1) 
			ifTrue: [ self addedMethodsAt: index put: coverage keys ]
			ifFalse: [
				previousCoverage := self codeRevisionsCoverage at: (index - 1).
				addedMethodNames := coverage keys reject: [:ea | previousCoverage includesKey: ea].
				self addedMethodsAt: index put: addedMethodNames ].
		Transcript clear. ].! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:41'!
analyzeModificationsOverTime

	self 
		analyzeForMethodModifications;
		analyzeForMethodsAdded.! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:45'!
analyzePackage: aPackageInfo
	package := aPackageInfo..
	self 
		fetchVersionsToLocalCache;
		analyzeCoverageOverTime;
		analyzeModificationsOverTime;
		analyzeFixedRelationshipsOverTime.! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 13:12'!
analyzePackage: aPackageInfo asVersion: aVersionNumber
	
	package := aPackageInfo.
	
	self 
		instrumentPackage;
		runAllTestsOfPackage;
		uninstrumentPackage;
		gatherCoverageDataAndStoreAsVersion: aVersionNumber
	! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 10:35'!
classesAndMetaclasses
	^ package classes gather: [ :aClass | {aClass. aClass class} ]! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 13:08'!
codeRevisionsCoverage
	^ codeRevisionsCoverage ifNil: [ codeRevisionsCoverage := Dictionary new. ]
	! !

!CSFixedAnalyzer methodsFor: 'accessing' stamp: 'bs 3/8/2010 21:03:18.173'!
codeSight
	codeSight 
		ifNil: [
			codeSight := CSCodeSight new.
			codeSight instrumentor: CSWeavingInstrumentor new.
			codeSight instrumentor codeSight: codeSight ].
	^ codeSight! !

!CSFixedAnalyzer methodsFor: 'accessing' stamp: 'bs 3/8/2010 20:57:50.644'!
codeSight: anObject
	codeSight := anObject! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 11:14'!
computeFixedCoverageDeltas
	| deltasInRev coveringTests |
	self codeRevisionsCoverage keysAndValuesDo: [:revisionIndex :coverageInRev |
		deltasInRev := self fixedCoverageDeltas at: revisionIndex put: Dictionary new.
		(self fixedRelationshipAt: revisionIndex) keysAndValuesDo: [:appMethod :fixedTests | 
			coveringTests := coverageInRev at: appMethod.
			coveringTests ifNotEmpty: [
				deltasInRev at: appMethod put: (fixedTests size / coveringTests size) ].
	 	].
	].! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:41'!
deltas
	^ deltas ifNil: [deltas := Dictionary new.]! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:04'!
fetchVersionsToLocalCache
	
	self filenames: self installer fetchVersionsToLocalCache.! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:04'!
filenames
	^ filenames! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:04'!
filenames: aCollection
	filenames := aCollection! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:44'!
fixedCoverageDeltas
	^ fixedCoverageDeltas ifNil: [fixedCoverageDeltas := Dictionary new.]! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:49'!
fixedCoverageDeltasAvg
	| deltasRevisionAvg |
	deltasRevisionAvg := Dictionary new.
	self fixedCoverageDeltas keysAndValuesDo: [:revisionIndex :deltasInRev |
		deltasRevisionAvg at: revisionIndex put: (deltasInRev values sum / deltasInRev values size) asFloat ].
	^ deltasRevisionAvg.! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:54'!
fixedRelationshipAt: revisionIndex
	^ self fixedRelationshipOverTime at: revisionIndex! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:55'!
fixedRelationshipAt: revisionIndex put: methodToFixedTestsDict
	^ self fixedRelationshipOverTime at: revisionIndex put: methodToFixedTestsDict.! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:53'!
fixedRelationshipOverTime
	^ fixedRelationshipOverTime ifNil: [ fixedRelationshipOverTime := Dictionary new. ]! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 13:11'!
gatherCoverageDataAndStoreAsVersion: aVersionNumber
	| codeCoverage |
	codeCoverage := self codeRevisionsCoverage at: aVersionNumber put: Dictionary new.
	self nonTestMethods do: [ :aCompiledMethod |
		codeCoverage 
			at: (aCompiledMethod qualifiedName)
			put: (aCompiledMethod coveringTestMethods collect: [:ea | ea qualifiedName]) ].! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:09'!
installer 
	^ installer ifNil: [ installer := CSMczInstaller newForPackageNamed: self package packageName ].! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 1/22/2010 15:22'!
instrumentPackage
	
	CSWrappingInstrumentor systemInstrumentor instrumentPackage: package.! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:12'!
methodAdditionsOverTime
	^ methodAdditionsOverTime ifNil: [ methodAdditionsOverTime := Dictionary new. ]! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:11'!
methodModificationsOverTime
	^ methodModificationsOverTime ifNil: [ methodModificationsOverTime := Dictionary new. ]! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:19'!
modifiedMethodsAt: revision
	^ self methodModificationsOverTime at: revision! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 09:19'!
modifiedMethodsAt: revision put: methodNames
	^ self methodModificationsOverTime at: revision put: methodNames! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 10:59'!
nonTestMethods
	^ self classesAndMetaclasses gather: [ :aClass | 
		aClass methodDict values reject: [:aCompiledMethod | 
			aCompiledMethod selector isTestSelector ] ]! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:00'!
package
	^ package! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/26/2009 10:00'!
package: aPackageInfo
	package := aPackageInfo! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 3/8/2010 20:56:37.804'!
runAllTestsOfPackage	
	| aTestRunner aSuite |
	aTestRunner := CSTestRunner new.
	aSuite := TestSuite new.
	self testClasses do: [ :aTestClass | 
		aTestClass selectors 
			select: [:ea | ea isTestSelector ] 
			thenDo: [:ea | aSuite addTest: (aTestClass selector: ea) ]].
	aTestRunner runSuite: aSuite.! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 10:21'!
testClasses
	^ package classes select: [ :aClass | aClass inheritsFrom: TestCase ]! !

!CSFixedAnalyzer methodsFor: 'as yet unclassified' stamp: 'bs 1/22/2010 15:22'!
uninstrumentPackage
	
	CSWrappingInstrumentor systemInstrumentor uninstrumentPackage: package.! !

Object subclass: #CSInfo
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!CSInfo class methodsFor: 'instance creation' stamp: 'bs 1/14/2010 12:45'!
do! !

!CSInfo class methodsFor: 'system instance' stamp: 'bs 1/14/2010 12:57'!
instance
	"Instance := nil"
	^ Instance ifNil: [ Instance := CSZeroInfo new ]! !

!CSInfo class methodsFor: 'system instance' stamp: 'bs 1/14/2010 13:50'!
instance: anInfoObject
	Instance dependents do:  [ :ea | anInfoObject addDependent: ea ].
	Instance breakDependents.
	Instance := anInfoObject.
	Instance changed: #newTestResult.
	! !

!CSInfo class methodsFor: 'system instance' stamp: 'bs 1/14/2010 12:57'!
resetToZeroInfo
	" self resetToZeroInfo "
	self instance: CSZeroInfo new.! !

!CSInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:57'!
isActive
	self subclassResponsibility! !

!CSInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 14:44'!
isClassManaged: aClass
	self subclassResponsibility! !

!CSInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:56'!
isRunning
	self subclassResponsibility! !

!CSInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:56'!
openTestRunner
	self subclassResponsibility! !

!CSInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:56'!
testResult
	self subclassResponsibility! !

CSInfo subclass: #CSRealInfo
	instanceVariableNames: 'codeSight isRunning'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!CSRealInfo methodsFor: 'accessing' stamp: 'bs 1/14/2010 12:49'!
codeSight
	^ codeSight! !

!CSRealInfo methodsFor: 'accessing' stamp: 'bs 1/14/2010 13:37'!
codeSight: anObject
	codeSight := anObject.! !

!CSRealInfo methodsFor: 'accessing' stamp: 'bs 1/14/2010 12:49'!
csTestRunner
	^ self codeSight csTestRunner! !

!CSRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:50'!
isActive
	^ true! !

!CSRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 14:47'!
isClassManaged: aClass
	^ self codeSight isClassManaged: aClass! !

!CSRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 13:03'!
isRunning
	^ isRunning ifNil: [ isRunning := false ]! !

!CSRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 13:43'!
openTestRunner
	self codeSight openTestRunner! !

!CSRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 13:42'!
testResult
	^ self csTestRunner result! !

!CSRealInfo methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 12:56:32.951'!
update: aSymbol
	super update: aSymbol.
	(#(newTestResult startTestRun endTestRun) includes: aSymbol) ifFalse: [^ self].
	aSymbol = #startTestRun ifTrue: [isRunning := true].
	aSymbol = #endTestRun ifTrue: [isRunning := false].
	self changed: aSymbol.! !

CSInfo subclass: #CSZeroInfo
	instanceVariableNames: 'emptyTestResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!CSZeroInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:57'!
isActive
	^ false! !

!CSZeroInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 14:44'!
isClassManaged: aClass
	^ false! !

!CSZeroInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:57'!
isRunning
	^ false! !

!CSZeroInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 13:43'!
openTestRunner
	self shouldNotImplement.! !

!CSZeroInfo methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 12:55'!
testResult
	^ emptyTestResult ifNil: [ emptyTestResult := TestResult new ] ! !

Object subclass: #CSMczCache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Analyzing'!

!CSMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 14:28'!
addMczToCache: aStream at: aMczFileName
	"Need to write a clean zip."
	
	^ ZipArchive new
		readFrom: aStream;
		writeToFileNamed: (self cacheDirectory fullNameFor: aMczFileName).! !

!CSMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 14:35'!
cacheAt: aFileName

	^ ZipArchive new
		readFrom: (self cacheDirectory readOnlyFileNamed: aFileName)! !

!CSMczCache class methodsFor: 'caching' stamp: 'mt 5/26/2009 18:48'!
cacheAt: aFileName ifNoneGetFrom: anHttpRepository
	"Return a zip archive for the mcz file."

	^ (self includes: aFileName)
		ifTrue: [self cacheAt: aFileName]
		ifFalse: [
			anHttpRepository
				readStreamForFileNamed: aFileName
				do: [:strm | self addMczToCache: strm at: aFileName]]! !

!CSMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 12:45'!
cacheDirectory

	^ (FileDirectory default directoryNamed: 'codetalk-cache')
		assureExistence;
		yourself! !

!CSMczCache class methodsFor: 'private' stamp: 'mt 5/15/2009 13:25'!
includes: aFileName

	^ self cacheDirectory includesKey: aFileName! !

Object subclass: #CSMczInspectorOld
	instanceVariableNames: 'isRunning process reader currentMethodDefinition followAncestors currentAncestors classFilter selectorFilter lastDefinition currentStep maxSteps repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Analyzing'!

CSMczInspectorOld class
	instanceVariableNames: 'exampleCache'!

CSMczInspectorOld class
	instanceVariableNames: 'exampleCache'!

!CSMczInspectorOld class methodsFor: 'examples' stamp: 'bs 11/20/2009 16:39'!
exampleVersions
	| instance result repo |
	exampleCache ifNotNilDo: [ :c | ^ c ].
	result := OrderedCollection new.
	instance := self newForPackageNamed: 'Xpf-CodeTalk'.
	repo := instance repositories first key.
	(repo readableFileNames select: [ :filename | filename startsWith: 'Xpf-CodeTalk' ]) 
		do: 
			[ :filename | 
			instance zip: (CSMczCache 
					cacheAt: filename
					ifNoneGetFrom: repo).
			instance loadVersionInfo.
			(instance zip memberNamed: 'snapshot.bin') ifNotNilDo: 
				[ :bin | 
				
				[ (DataStream on: bin contentStream) next definitions 
					select: 
						[ :def | 
						def isMethodDefinition and: [ def className = 'XpfCodeTalk' and: [ def selector = #todo ] ] ]
					thenDo: 
						[ :def | 
						result add: (CSRemoteMethodVersion 
								repository: repo
								info: instance info
								definition: def) ] ] 
					on: Error
					do: 
						[ :fallThrough | 
						"Unknown content in snapshot.bin!!"
						 ] ] ]
		displayingProgress: 'Preparing...'.
	exampleCache := result.
	^ result! !

!CSMczInspectorOld methodsFor: 'adding repos' stamp: 'rkrk 9/19/2009 19:04'!
addRepository: anHttpRepository include: somePackageNames
	"Add the given repo and decide which packages
	to use when looking at the contents of the repo later."
	
	self repositories add: (anHttpRepository -> somePackageNames).! !

!CSMczInspectorOld methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:03'!
currentAncestors

	^ currentAncestors ifNil: [currentAncestors := Set new].! !

!CSMczInspectorOld methodsFor: 'inspecting' stamp: 'bs 11/20/2009 17:15'!
filenames
	| packageName aHttpRepository | 
	
	packageName := self repositories first value.
	aHttpRepository := self repositories first key.
	^ self
		filterFileNames: aHttpRepository readableFileNames
		packages: packageName.! !

!CSMczInspectorOld methodsFor: 'inspecting' stamp: 'rkrk 9/19/2009 23:37'!
filterFileNames: someFileNames packages: somePackageNames

	| result fileNamesMatching |
	fileNamesMatching := someFileNames select: [:filename |
		somePackageNames anySatisfy: [:name |
			self packageName: name matchesFileName: filename]].
	result := fileNamesMatching sortBy: [:f1 :f2 |
		(f1 findTokens: $.) second asNumber > (f2 findTokens: $.) second asNumber].
	^ self followAncestors
		ifTrue: [result]
		ifFalse: [result reversed]! !

!CSMczInspectorOld methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:02'!
followAncestors

	^ followAncestors ifNil: [followAncestors := false].! !

!CSMczInspectorOld methodsFor: 'accessing' stamp: 'mt 5/13/2009 14:13'!
followAncestors: anObject

	followAncestors := anObject.! !

!CSMczInspectorOld methodsFor: 'inspecting - methods' stamp: 'rkrk 9/19/2009 22:53'!
inspectDefinitions

	| definition updateObject |
	definition := self reader definitions
		detect: [:def | def isMethodDefinition
			and: [classFilter = def actualClass]
			and: [selectorFilter = def selector]]
		ifNone: [^ self].
	lastDefinition = definition ifTrue: [^ self].
	updateObject := Dictionary newFrom: {
		#repository -> self reader repository.
		#definition -> definition.
		#info -> self reader info}.
	self changed: #matchingVersionFound with: updateObject.
	lastDefinition := definition.! !

!CSMczInspectorOld methodsFor: 'inspecting' stamp: 'bs 11/20/2009 18:06'!
inspectRepository: anHttpRepository include: somePackageNames

	| filenames shouldInspectDefs |
	filenames := self
		filterFileNames: anHttpRepository readableFileNames
		packages: somePackageNames.
	self maxSteps: filenames size.		
	filenames withIndexDo: [:filename :i |	
		self currentStep: i.
		self reader readFile: filename from: anHttpRepository.
		self inspectVersion.
		shouldInspectDefs := self followAncestors not
			or: [self currentAncestors isEmpty]
			or: [self currentAncestors anySatisfy: [:anc | anc name = self reader info name]].
		shouldInspectDefs ifTrue: [self inspectDefinitions].
		self followAncestors ifTrue: [self updateCurrentAncestry]].! !

!CSMczInspectorOld methodsFor: 'inspecting - methods' stamp: 'rkrk 9/19/2009 19:29'!
inspectSourceText: aText

	| result |
	result := aText attributesOfKind: XpfComplexAttribute.

	self changed: #resultFound with: (Dictionary newFrom: {
		#repository -> self reader repository.
		#definition -> currentMethodDefinition.
		#info -> self reader info.
		#attributes -> result}).! !

!CSMczInspectorOld methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 19:36'!
inspectVersion

	self changed: #versionFound with: self reader info.! !

!CSMczInspectorOld methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:03'!
isRunning

	isRunning ifNil: [self isRunning: false].
	^ isRunning! !

!CSMczInspectorOld methodsFor: 'accessing' stamp: 'mt 5/9/2009 12:03'!
isRunning: anObject

	isRunning := anObject.
	self changed: #isRunning.! !

!CSMczInspectorOld methodsFor: 'testing' stamp: 'rkrk 9/19/2009 23:40'!
packageName: packageName matchesFileName: fileName

	"match only those packages which really include packageNames and not only start
	with that name.
	E.g. when somePackageNames = {Xpf-CodeTalk} don't match Xpf-CodeTalkExtension'"
	| packageNameDelimiter versionDelimiter followingChar |
	packageNameDelimiter := $-.
	versionDelimiter := $..
	(fileName beginsWith: packageName) ifFalse: [^ false].
	fileName size = packageName size ifTrue: [true].
	followingChar := fileName at: packageName size + 1.
	^ followingChar = packageNameDelimiter or: [followingChar = versionDelimiter].
! !

!CSMczInspectorOld methodsFor: 'debugging' stamp: 'mt 5/26/2009 13:48'!
print

	Transcript show: ('Next Result: {1}>>{2} ({3}) - {4}' format: {
		currentMethodDefinition className.
		currentMethodDefinition selector.
		currentMethodDefinition category.
		self reader info name}); cr.! !

!CSMczInspectorOld methodsFor: 'accessing' stamp: 'rkrk 9/19/2009 19:04'!
repositories

	^ repositories ifNil: [repositories := OrderedCollection new].! !

!CSMczInspectorOld methodsFor: 'controlling' stamp: 'rkrk 9/19/2009 23:16'!
start

	process ifNotNil: [self stop].
	process := [
		[self isRunning: true.
		self repositories do: [:repo |
			self
				inspectRepository: repo key
				include: repo value.
			currentAncestors := nil].
		] ensure: [
			self
				isRunning: false;
				changed: #done]
	] fork priority: 20.! !

!CSMczInspectorOld methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 23:09'!
startInspectVersions

	self
		followAncestors: true;
		start.! !

!CSMczInspectorOld methodsFor: 'inspecting - versions' stamp: 'rkrk 9/19/2009 23:09'!
startInspectVersionsFor: aSelector in: aClass

	classFilter := aClass.
	selectorFilter := aSelector.
	self startInspectVersions.! !

!CSMczInspectorOld methodsFor: 'controlling' stamp: 'mt 5/9/2009 12:13'!
stop

	process ifNotNilDo: [:p | p terminate].
	process := nil.
	self isRunning: false.! !

!CSMczInspectorOld methodsFor: 'inspecting' stamp: 'mt 6/3/2009 11:05'!
updateCurrentAncestry

	self reader info ancestors ifNotNilDo: [:newAnc |
		self currentAncestors addAll: newAnc].! !

Object subclass: #CSMczInstaller
	instanceVariableNames: 'repository packageName currentStep maxSteps currentAncestors reader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Analyzing'!

!CSMczInstaller class methodsFor: 'instance creation' stamp: 'bs 11/26/2009 10:14'!
newForPackageNamed: aString

	| aPackage instance repos httpRepo |
	aPackage := MCPackage named: aString.
	aPackage hasWorkingCopy ifFalse: [^ nil].
	repos := aPackage workingCopy repositoryGroup repositories.
	httpRepo := repos detect: [:r | r isKindOf: MCHttpRepository ].
	
	instance := self new.
	instance 
		repository: httpRepo;
		packageName: aPackage name.
	^ instance ! !

!CSMczInstaller class methodsFor: 'instance creation' stamp: 'bs 11/20/2009 17:29'!
newForPackagesNamed: packageName inRepo: mcRepository

	| instance |
	instance := self new.
	instance
		repository: mcRepository;
		packageName: packageName.
	^ instance! !

!CSMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 20:36'!
cacheAt: aFileName

	^ self cacheDirectory readOnlyFileNamed: aFileName! !

!CSMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 20:35'!
cacheDirectory

	^ (FileDirectory default directoryNamed: 'codetalk-cache')
		assureExistence;
		yourself! !

!CSMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 21:09'!
fetchVersionsToLocalCache
	| filenames |
	filenames := (self filterFileNames: self repository readableFileNames).	
	filenames do: [:filename |	
		self reader readFile: filename from: self repository ].
	^ filenames! !

!CSMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/21/2009 21:09'!
filterFileNames: someFileNames
	| result fileNamesMatching |
	fileNamesMatching := someFileNames select: [:filename | self packageMatchesFileName: filename].
	result := fileNamesMatching sortBy: [:f1 :f2 |
		(f1 findTokens: $.) second asNumber > (f2 findTokens: $.) second asNumber].
	^ result reversed! !

!CSMczInstaller methodsFor: 'accessing' stamp: 'bs 3/8/2010 20:53:45.547'!
installFromCache: aFileName
	MczInstaller installStream: (self cacheAt: aFileName).! !

!CSMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 17:29'!
packageMatchesFileName: fileName

	"match only those packages which really include packageNames and not only start
	with that name.
	E.g. when somePackageNames = {Xpf-CodeTalk} don't match Xpf-CodeTalkExtension'"
	| packageNameDelimiter versionDelimiter followingChar |
	packageNameDelimiter := $-.
	versionDelimiter := $..
	(fileName beginsWith: self packageName) ifFalse: [^ false].
	fileName size = self packageName size ifTrue: [true].
	followingChar := fileName at: self packageName size + 1.
	^ followingChar = packageNameDelimiter or: [followingChar = versionDelimiter].
! !

!CSMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:29'!
packageName

	^ packageName! !

!CSMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:29'!
packageName: aName

	^ packageName := aName! !

!CSMczInstaller methodsFor: 'as yet unclassified' stamp: 'bs 11/20/2009 17:28'!
packageName: packageName matchesFileName: fileName

	"match only those packages which really include packageNames and not only start
	with that name.
	E.g. when somePackageNames = {Xpf-CodeTalk} don't match Xpf-CodeTalkExtension'"
	| packageNameDelimiter versionDelimiter followingChar |
	packageNameDelimiter := $-.
	versionDelimiter := $..
	(fileName beginsWith: packageName) ifFalse: [^ false].
	fileName size = packageName size ifTrue: [true].
	followingChar := fileName at: packageName size + 1.
	^ followingChar = packageNameDelimiter or: [followingChar = versionDelimiter].
! !

!CSMczInstaller methodsFor: 'accessing' stamp: 'bs 11/23/2009 21:36'!
readVersionFromCache: aFileName
	^ MCMczReader versionFromStream: (self cacheAt: aFileName)! !

!CSMczInstaller methodsFor: 'accessing' stamp: 'bs 11/21/2009 21:10'!
reader
	^ reader ifNil: [ reader := CSMczReader new ]! !

!CSMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:25'!
repository

	^ repository! !

!CSMczInstaller methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:25'!
repository: aHttpRepo
	repository := aHttpRepo.! !

!CSMczInstaller methodsFor: 'accessing' stamp: 'bs 11/21/2009 20:52'!
uninstallPackage
	
	(PackageInfo named: self packageName) classes do: [:aClass | aClass removeFromSystem ]! !

Object subclass: #CSMczReader
	instanceVariableNames: 'zip info definitions repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Analyzing'!

!CSMczReader commentStamp: 'mt 6/3/2009 11:04' prior: 0!
This is a simplified version of the McMczReader.!

!CSMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
associate: tokens

	| result |
	result := Dictionary new.
	tokens pairsDo: [:key :value | 
					value isString ifFalse: [value := value collect: [:ea | self associate: ea]].
					result at: key put: value].
	^ result! !

!CSMczReader methodsFor: 'accessing' stamp: 'bs 11/20/2009 16:59'!
definitions

	"if it does not work, look at loadDefinitions"
	^ definitions ifNil: [
		(self zip memberNamed: 'snapshot.bin') ifNotNilDo: [:bin |
			[definitions := (DataStream on: bin contentStream) next definitions]
				on: Error
				do: [:fallThrough | definitions := OrderedCollection new]]].! !

!CSMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
extractInfoFrom: dict

	^ MCVersionInfo
		name: (dict at: #name ifAbsent: [''])
		id: (UUID fromString: (dict at: #id))
		message: (dict at: #message ifAbsent: [''])
		date: ([Date fromString: (dict at: #date) ] on: Error do: [ :ex | ex return: nil ])
		time: ([ Time fromString:(dict at: #time)] on: Error do: [ :ex | ex return: nil ])
		author: (dict at: #author ifAbsent: [''])
		ancestors: ((dict at: #ancestors ifAbsent: [#()]) collect: [:ea | self extractInfoFrom: ea])
		stepChildren: ((dict at: #stepChildren ifAbsent: [#()]) collect: [:ea | self extractInfoFrom: ea])! !

!CSMczReader methodsFor: 'public' stamp: 'mt 5/26/2009 13:58'!
getDefinitionByClass: aClass selector: aSelector

	^ self definitions
		detect: [:def |
			def actualClass = aClass
				and: [def selector = aSelector]]
		ifNone: []! !

!CSMczReader methodsFor: 'accessing' stamp: 'bs 11/20/2009 17:00'!
info

	^ info ifNil: [info := self extractInfoFrom: (self parseMember: 'version')]! !

!CSMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
info: anObject

	info := anObject.! !

!CSMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:17'!
loadDefinitions

	(self zip memberNamed: 'snapshot.bin') ifNotNilDo: [:bin |
		[self	definitions:
			(DataStream on: bin contentStream) next definitions]
		on: Error
		do: [:fallThrough |
			self definitions: OrderedCollection new.
			Transcript show: 'Unknown content in snapshot.bin!!'; cr]].! !

!CSMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:11'!
loadVersionInfo

	info := self extractInfoFrom: (self parseMember: 'version')! !

!CSMczReader methodsFor: 'reading' stamp: 'mt 5/26/2009 13:12'!
parseMember: fileName

	| tokens |
	tokens := (MCScanner scanTokens: (zip contentsOf: fileName)) first.
	^ self associate: tokens! !

!CSMczReader methodsFor: 'public' stamp: 'bs 11/20/2009 17:01'!
readFile: aFilename from: aRepository 
	self
		repository: aRepository;
		zip: (CSMczCache 
				cacheAt: aFilename
				ifNoneGetFrom: aRepository)! !

!CSMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:32'!
repository

	^ repository! !

!CSMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:32'!
repository: anObject

	repository := anObject.! !

!CSMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
zip

	^ zip! !

!CSMczReader methodsFor: 'accessing' stamp: 'mt 5/26/2009 13:09'!
zip: anObject

	zip := anObject.! !

Object subclass: #CSMethodExtension
	instanceVariableNames: 'clientMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracing'!

!CSMethodExtension methodsFor: 'accessing' stamp: 'bs 1/16/2010 21:02'!
clientMethod
	^ clientMethod! !

!CSMethodExtension methodsFor: 'accessing' stamp: 'bs 1/16/2010 21:02'!
clientMethod: anObject
	clientMethod := anObject! !

!CSMethodExtension methodsFor: 'accessing' stamp: 'bs 1/16/2010 21:02'!
pvtCodeSightMonitor
	^ CSCodeSight sourceCodeMonitor! !

!CSMethodExtension methodsFor: 'accessing' stamp: 'bs 1/16/2010 21:03'!
unwrappedMethod
	^ self clientMethod unwrappedMethod! !

CSMethodExtension subclass: #CSNonTestMethodExtension
	instanceVariableNames: 'codeSight coveringTestMethods fixedTestMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracing'!

!CSNonTestMethodExtension methodsFor: 'evaluating' stamp: 'bs 1/16/2010 21:00'!
beforeMethod

	self flag: #rkrk. "for benchmarking"
	self ifActive: [
		self codeSight runningTestMethod called: self clientMethod ]! !

!CSNonTestMethodExtension methodsFor: 'evaluating' stamp: 'bs 3/2/2010 09:42:08.022'!
beforeMethodWithReceiver: anObject 
	"self ifActive: ["
		self codeSight runningTestMethod 
			ifNotNilDo: [:testMethod | 
				testMethod 
					called: self unwrappedMethod
					receiver: anObject ] 
				"]."! !

!CSNonTestMethodExtension methodsFor: 'coverage tracing' stamp: 'replica 2/24/2010 19:53:18.368'!
calledBy: aTestMethod receiver: anObject 
	self pvtCoveringTestMethods add: aTestMethod.
	aTestMethod privateCovered: clientMethod withReceiver: anObject! !

!CSNonTestMethodExtension methodsFor: 'evaluating' stamp: 'bs 1/26/2010 09:03:11.75'!
calledByRunningTestWithReceiver: anObject
	| runningTestMethod |
	"was: self isActive"
	codeSight isTracingActivated
		ifTrue: [ runningTestMethod := codeSight runningTestMethod.
			self pvtCoveringTestMethods add: runningTestMethod.
			runningTestMethod privateCovered: clientMethod withReceiver: anObject ]! !

!CSNonTestMethodExtension methodsFor: 'accessing' stamp: 'bs 1/16/2010 21:00'!
codeSight
	^ codeSight! !

!CSNonTestMethodExtension methodsFor: 'accessing' stamp: 'bs 1/16/2010 21:00'!
codeSight: anObject
	codeSight := anObject! !

!CSNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
coveringAndNotFixedTestMethods
	| result |
	self pvtCodeSightMonitor critical: [
		result := self pvtCoveringTestMethods copy.
		"fixed link might be established and coverage not yet"
		result removeAllFoundIn: self pvtFixedTestMethods ].
	^ result ! !

!CSNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
coveringTestMethods
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtCoveringTestMethods copy ].
	^ result! !

!CSNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/17/2010 14:32'!
coveringTestMethodsWhenReceiverWasOfKind: aClass 
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtCoveringTestMethods 
			select: [ :testMethod | 
				(testMethod privateStatisticsForCoveredMethod: self unwrappedMethod) 
					receiverClasses includes: aClass ] ].
	^ result! !

!CSNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
fixedTestMethods
	| result |
	self pvtCodeSightMonitor critical: 
		[ result := self pvtFixedTestMethods copy ].
	^ result! !

!CSNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
fixes: aCompiledTestMethod 
	self fixesAll: {aCompiledTestMethod}! !

!CSNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
fixesAll: compiledTestMethods 
	self pvtCodeSightMonitor critical: [
		self pvtFixedTestMethods addAll: compiledTestMethods ]! !

!CSNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
hasCoveringTestMethods
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtCoveringTestMethods isEmpty not ].
	^ result! !

!CSNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
hasFixedTestMethods
	| result |
	self pvtCodeSightMonitor critical: [
		result := self pvtFixedTestMethods isEmpty not ].
	^ result! !

!CSNonTestMethodExtension methodsFor: 'evaluating' stamp: 'bs 1/16/2010 22:24'!
ifActive: aBlock
	self isActive ifTrue: [aBlock value]! !

!CSNonTestMethodExtension methodsFor: 'initialize-release' stamp: 'bs 2/23/2010 10:13:19.001'!
initialize
	super initialize.
	coveringTestMethods := KeyedIdentitySet
				keyBlock: [:t1 | t1 scaledIdentityHash]! !

!CSNonTestMethodExtension methodsFor: 'evaluating' stamp: 'bs 1/16/2010 22:24'!
isActive
	^ self codeSight isTracingActivated! !

!CSNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
privateAddCoveringTestMethod: aCompiledTestMethod
	^ self pvtCoveringTestMethods add: aCompiledTestMethod! !

!CSNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/21/2010 13:29'!
privateRemoveCoveringTestMethod: aTestCaseMethod
	"the other direction is removed by the sender"
	self pvtCoveringTestMethods remove: aTestCaseMethod ifAbsent: []! !

!CSNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 2/23/2010 10:06:56.071'!
pvtCoveringTestMethods
	^ coveringTestMethods 
		ifNil: [ coveringTestMethods := KeyedIdentitySet keyBlock: [ :e | e scaledIdentityHash ] ]! !

!CSNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/22/2010 10:15'!
pvtFixedTestMethods
	^ fixedTestMethods 
		ifNil: [fixedTestMethods := KeyedIdentitySet keyBlock: [ :e | e scaledIdentityHash ]]! !

!CSNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
pvtRemoveCoveringTestMethod: aTestCaseMethod
	"the other direction is removed by the sender"
	self pvtCoveringTestMethods remove: aTestCaseMethod! !

!CSNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
pvtResetCoveringTestMethods
	coveringTestMethods := nil! !

!CSNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
pvtResetFixedTestMethods
	fixedTestMethods := nil! !

!CSNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
removeCoveringTestMethod: aTestCaseMethod
	self pvtCodeSightMonitor critical: [
		"the other direction is removed by the sender"
		self privateRemoveCoveringTestMethod: aTestCaseMethod ]! !

!CSNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:00'!
removeFixedTestMethodIfNotCoveringAnymore: aTestCaseMethod
	self pvtCodeSightMonitor critical: [
		(self pvtFixedTestMethods includes: aTestCaseMethod) ifFalse: [^ self].
		(self pvtCoveringTestMethods includes: aTestCaseMethod) ifTrue: [^ self].
		self pvtFixedTestMethods remove: aTestCaseMethod ]
	! !

!CSNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:10'!
resetAllCoverageData
	self 
		resetCoveringTestMethods;
		resetFixedTestMethods.! !

!CSNonTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/17/2010 14:11'!
resetCoveringTestMethods
	self pvtCodeSightMonitor critical: [
		self pvtCoveringTestMethods do: [:testMethod |
			testMethod privateRemoveCoveredMethod: self unwrappedMethod ].
		self pvtResetCoveringTestMethods ].! !

!CSNonTestMethodExtension methodsFor: 'fixed data accessing' stamp: 'bs 1/16/2010 21:00'!
resetFixedTestMethods
	self pvtCodeSightMonitor critical: [
		self pvtResetFixedTestMethods ].! !

CSNonTestMethodExtension subclass: #CSUnmanagedNonTestMethodExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracing'!

!CSUnmanagedNonTestMethodExtension methodsFor: 'accessing' stamp: 'bs 1/17/2010 14:46'!
codeSight
	self shouldNotImplement! !

CSMethodExtension subclass: #CSTestMethodExtension
	instanceVariableNames: 'coveredMethodsStatistics calledMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracing'!

!CSTestMethodExtension methodsFor: 'coverage tracing' stamp: 'replica 2/24/2010 20:53:25.565'!
called: aCompiledMethod

	self flag: #rkrk. "for benchmarking"
	self pvtCodeSightMonitor critical: [
		self pvtCalled: aCompiledMethod receiverClasses: { }  ]! !

!CSTestMethodExtension methodsFor: 'coverage tracing' stamp: 'replica 2/24/2010 20:52:43.762'!
called: aCompiledMethod receiver: anObject 
	
	self pvtCodeSightMonitor critical: [
		self pvtCalled: aCompiledMethod receiverClasses: { anObject class }  ].! !

!CSTestMethodExtension methodsFor: 'coverage tracing' stamp: 'replica 2/24/2010 20:51:41.557'!
called: aCompiledMethod receiverClasses: classes 

	self pvtCodeSightMonitor critical: [
		self pvtCalled: aCompiledMethod receiverClasses: classes ].! !

!CSTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/24/2010 20:52'!
calledMethods
	^ calledMethods ifNil: [ calledMethods := OrderedIdentityCollection new  ]! !

!CSTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:12'!
coveredMethods
	| result |
	self pvtCodeSightMonitor critical: 
		[ result := self pvtCoveredMethodsStatistics keys ].
	^ result! !

!CSTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:05'!
coveredMethodsStatistics
	| result |
	self pvtCodeSightMonitor critical: 
		[ result := self pvtCoveredMethodsStatistics copy ].
	^ result! !

!CSTestMethodExtension methodsFor: 'initialize-release' stamp: 'bs 2/23/2010 10:12:21.388'!
initialize
	super initialize.
	coveredMethodsStatistics := OrderedKeysIdentityDictionary new! !

!CSTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'replica 2/24/2010 20:49:17.896'!
privateCovered: aCompiledAppMethod withReceiver: anObject
	| statistic |
	statistic := self pvtCoveredMethodsStatistics 
				at: aCompiledAppMethod
				ifAbsentPut: [ CSTestStatistic new ].
	statistic addReceiverClass: anObject class.
	self calledMethods add: aCompiledAppMethod.! !

!CSTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/21/2010 13:28'!
privateRemoveCoveredMethod: aCompiledAppMethod
	self pvtCoveredMethodsStatistics removeKey: aCompiledAppMethod! !

!CSTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:06'!
privateStatisticsForCoveredMethod: aCompiledMethod 
	^ self pvtCoveredMethodsStatistics at: aCompiledMethod ! !

!CSTestMethodExtension methodsFor: 'coverage tracing' stamp: 'replica 2/24/2010 20:48:04.514'!
pvtCalled: aCompiledMethod receiverClasses: classes 
	| statistic |
	aCompiledMethod privateAddCoveringTestMethod: self unwrappedMethod.
		
	statistic := self pvtCoveredMethodsStatistics 
			at: aCompiledMethod
			ifAbsentPut: [ CSTestStatistic new ].
	statistic addReceiverClasses: classes.! !

!CSTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 2/23/2010 10:09:05.391'!
pvtCoveredMethodsStatistics
	^  coveredMethodsStatistics 
		ifNil: [ coveredMethodsStatistics := OrderedKeysIdentityDictionary new ]! !

!CSTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:07'!
pvtRemoveCoveredMethod: aCompiledAppMethod
	self pvtCoveredMethodsStatistics removeKey: aCompiledAppMethod! !

!CSTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:07'!
pvtResetCoveredMethodsStatistics
	coveredMethodsStatistics := nil! !

!CSTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:07'!
removeCoveredMethod: aCompiledAppMethod
	self pvtCodeSightMonitor critical: [
		self privateRemoveCoveredMethod: aCompiledAppMethod ]! !

!CSTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:08'!
resetAllCoverageData
	self resetCoveredMethodsStatistics! !

!CSTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/24/2010 20:46'!
resetCoveredMethodsStatistics
	| result |
	self pvtCodeSightMonitor critical: [
		self pvtCoveredMethodsStatistics keysDo: [ :coveredMethod | 
				coveredMethod privateRemoveCoveringTestMethod: self unwrappedMethod. ].
	
		result := self pvtResetCoveredMethodsStatistics. 
		calledMethods := nil ].
	^ result! !

!CSTestMethodExtension methodsFor: 'coverage data accessing' stamp: 'bs 1/16/2010 21:09'!
statisticsForCoveredMethod: aCompiledMethod 
	| result |
	self pvtCodeSightMonitor critical: [
		result := self privateStatisticsForCoveredMethod: aCompiledMethod  ].
	^ result! !

Object subclass: #CSPackageChooser
	instanceVariableNames: 'list listSelections codeSight window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSPackageChooser class methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
build
	^ ToolBuilder build: self new! !

!CSPackageChooser class methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
initialize
	"CSTraceChooser initialize"
	self registerInToolsFlap! !

!CSPackageChooser class methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
open
	^ self new open! !

!CSPackageChooser class methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( CSTraceChooser build 'Test Traces' 'Choose your packages for test tracing.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!CSPackageChooser methodsFor: 'ui-building' stamp: 'bs 1/14/2010 09:39'!
buildWith: builder
	| windowSpec listSpec buttonSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec 
		model: self;
		label: 'Package Chooser';
		children: OrderedCollection new;
		closeAction: #close.
		
	listSpec := builder pluggableMultiSelectionListSpec new.
	listSpec 
		model: self;
		list: #list;
		getSelectionList: #listSelectionAt:;
		setSelectionList: #listSelectionAt:put:;
		frame: (0@0corner: 1@0.8).
	windowSpec children add: listSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec
		model: self;
		label: 'Refresh';
		action: #refresh;
		frame: (0@0.8 corner: 1@1).
	windowSpec children add: buttonSpec.
	
	^builder build: windowSpec! !

!CSPackageChooser methodsFor: 'ui-open/close' stamp: 'bs 1/14/2010 10:13'!
close
	window := nil! !

!CSPackageChooser methodsFor: 'accessing' stamp: 'bs 1/14/2010 09:34'!
codeSight
	^ codeSight! !

!CSPackageChooser methodsFor: 'accessing' stamp: 'bs 1/14/2010 09:34'!
codeSight: anObject
	codeSight := anObject! !

!CSPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
list
	^ list ifNil: [ list := self packageNamesSorted ]! !

!CSPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
listSelectionAt: index
	^ self listSelections at: index! !

!CSPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
listSelectionAt: index put: isMarked
	| selectedPackage newValue successfullyRegistered | 
	selectedPackage := self packageAt: index.
	newValue := isMarked.
	isMarked 
		ifTrue: [
			successfullyRegistered := self registerPackage: selectedPackage.
			successfullyRegistered 
				ifFalse: [ newValue := isMarked not ] ]
		ifFalse: [ self unregisterPackage: selectedPackage ].
	self changed: #list.
	^ self listSelections at: index put: newValue.! !

!CSPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
listSelections
	listSelections ifNil: [
		self list ifNotNil: [
			listSelections := Array new: self list size withAll: false.
			self list doWithIndex: [ :each :index |
				(self registeredPackages includes: each) ifTrue: [
					listSelections at: index put: true ]]]].
	^ listSelections! !

!CSPackageChooser methodsFor: 'ui-open/close' stamp: 'bs 1/14/2010 10:13'!
open
	window
		ifNil: [ window := ToolBuilder open: self ]
		ifNotNil: [ 
			window comeToFront.
			window isCollapsed ifTrue: [ window expand ] ].
	^ window.! !

!CSPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
packageAt: index
	| packageName |
	packageName := self list at: index.
	^ self packageNamed: packageName! !

!CSPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
packageNamed: aName
	^ PackageOrganizer default packageNamed: aName ifAbsent: [].! !

!CSPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
packageNamesSorted
	| packageNames criticalPackages |
	packageNames := PackageOrganizer default packages 
			collect: [ :packageInfo | packageInfo packageName ].
	
	criticalPackages := {'Collections'. 'CollectionsTests'.
								'Kernel'. 'KernelTests'.
								'Graphics'. 'GraphicsTests'.
								'ST80'. 'SUnit'. 'System' }.
	^ (packageNames reject: [:package | 
			criticalPackages anySatisfy: [:critical | 
				critical = package] ]) sort! !

!CSPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 09:34'!
refresh
	list := nil.
	listSelections := nil.! !

!CSPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 2/23/2010 09:59:53.122'!
registerPackage: aPackage
	^ self codeSight addToManagedPackages: aPackage! !

!CSPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 2/23/2010 10:00:39.835'!
registeredPackages
	^ self codeSight managedPackages! !

!CSPackageChooser methodsFor: 'as yet unclassified' stamp: 'bs 2/23/2010 10:00:25.812'!
unregisterPackage: aPackage
	^ self codeSight removeFromManagedPackages: aPackage! !

Object subclass: #CSPartialTracingBenchmarker
	instanceVariableNames: 'packageToBenchmark codeSight coveredMethodTestTimes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Analyzing'!

!CSPartialTracingBenchmarker class methodsFor: 'instance creation' stamp: 'bs 1/24/2010 15:04'!
benchmarkPackage: aPackageInfo
	| codeSight |
	self packageToBenchmark: aPackageInfo.
	codeSight := CSCodeSight new.
	codeSight instrumentor: CSWeavingInstrumentor new.
	codeSight instrumentor codeSight: codeSight.
	codeSight instrumentor instrumentPackage: aPackageInfo.
	codeSight instrumentor uninstrumentPackage: aPackageInfo.! !

!CSPartialTracingBenchmarker class methodsFor: 'instance creation' stamp: 'bs 1/24/2010 15:02'!
benchmarkPackageNamed: aPackageName
	^ self benchmarkPackage: (PackageInfo named: aPackageName)! !

!CSPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/24/2010 15:02'!
benchmarkPackage: aPackageInfo
	| codeSight |
	self packageToBenchmark: aPackageInfo.
	codeSight := CSCodeSight new.
	codeSight instrumentor: CSWeavingInstrumentor new.
	codeSight instrumentor codeSight: codeSight.
	codeSight instrumentor instrumentPackage: aPackageInfo.
	codeSight instrumentor uninstrumentPackage: aPackageInfo.! !

!CSPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/24/2010 14:39'!
benchmarkPackageNamed: aPackageName
	^ self benchmarkPackage: (PackageInfo named: aPackageName)! !

!CSPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'replica 3/1/2010 09:21:47.837'!
benchmarkPartialTracingTimes
	| result testTime activationInstr |
	self halt.
	self codeSight instrumentor instrumentPackage: self packageToBenchmark.
	result := IdentityDictionary new.
	testTime := nil.
	self coveredMethods withIndexDo: [ :m :index |
		Transcript show: index asString; cr.
		Transcript show: 'covering: ',  m coveringTestMethods size asString; cr.
		testTime :=
			(self codeSight instrumentor canInstrument: m selector inClass: m methodClass)
				ifFalse: [ (m coveringTestMethods collect: [ :tm | self coveredMethodTestTimes at: m ]) sum ]
				ifTrue: [
					[ activationInstr := CSInstrumentedMethod activationOn: m selector inClass: m methodClass.
					activationInstr install.
					self halt.
					codeSight csTestRunner reset; runTestMethods: m coveringTestMethods.
					activationInstr uninstall. ] timeToRunWithoutGC ].
		result at: m put: testTime. ].
	codeSight instrumentor uninstrumentPackage: self packageToBenchmark.
	^ result.! !

!CSPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/25/2010 16:46:02.492'!
classesAndMetaclasses
	^ self packageToBenchmark classes flatCollect: [ :c | {c. c class} ]! !

!CSPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:07'!
codeSight
	^ codeSight! !

!CSPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:07'!
codeSight: anObject
	codeSight := anObject! !

!CSPartialTracingBenchmarker methodsFor: 'test-running' stamp: 'bs 1/24/2010 15:45'!
collectAllTestMethods
	^ (self packageToBenchmark classes
		select: [ :c | c isTestCaseClass ])
			flatCollect: [ :c | c testMethods ] ! !

!CSPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/25/2010 16:52:44.559'!
coveredMethodTestTimes
	^ coveredMethodTestTimes! !

!CSPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/25/2010 16:52:44.56'!
coveredMethodTestTimes: anObject
	coveredMethodTestTimes := anObject! !

!CSPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/25/2010 16:46:54.897'!
coveredMethods
	^ self nonTestMethods select: [ :m | m hasCoveringTestMethods ].! !

!CSPartialTracingBenchmarker methodsFor: 'initialize-release' stamp: 'bs 1/24/2010 15:08'!
initialize
	super initialize.
	self codeSight: CSCodeSight new.
	self codeSight instrumentor: CSWeavingInstrumentor new.
	self codeSight instrumentor codeSight: codeSight.! !

!CSPartialTracingBenchmarker methodsFor: 'as yet unclassified' stamp: 'bs 1/25/2010 16:46:23.258'!
nonTestMethods
	^ (self classesAndMetaclasses flatCollect: [ :c | c methodDict values ]) select: [ :m | m isTestMethod not ].! !

!CSPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:05'!
packageToBenchmark
	^ packageToBenchmark! !

!CSPartialTracingBenchmarker methodsFor: 'accessing' stamp: 'bs 1/24/2010 15:01'!
packageToBenchmark: anObject
	packageToBenchmark := anObject! !

!CSPartialTracingBenchmarker methodsFor: 'test-running' stamp: 'bs 1/24/2010 16:12'!
runAndTraceAllTests
	self codeSight activateTracing.
	self codeSight csTestRunner runTestMethods: self collectAllTestMethods.
	self codeSight deactivateTracing.! !

Object subclass: #CSRegisteredTrace
	instanceVariableNames: 'identifier timestamp startEntries returnValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

!CSRegisteredTrace class methodsFor: 'as yet unclassified' stamp: 'mp 2/10/2009 10:57'!
with: anIdentifier

	^ self new
		identifier: anIdentifier! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:02'!
identifier
	"Answer the value of identifier"

	^ identifier! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:02'!
identifier: anObject
	"Set the value of identifier"

	identifier := anObject! !

!CSRegisteredTrace methodsFor: 'initialize-release' stamp: 'mp 2/10/2009 10:57'!
initialize
	
	self 
		timestamp: DateAndTime now;
		startEntries: OrderedCollection new.! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/7/2009 16:38'!
returnValue
	"Answer the value of returnValue"

	^ returnValue! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/7/2009 16:38'!
returnValue: anObject
	"Set the value of returnValue"

	returnValue := anObject! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/6/2009 15:16'!
startEntries
	"Answer the value of startEntries"

	^ startEntries! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/6/2009 15:16'!
startEntries: anObject
	"Set the value of startEntries"

	startEntries := anObject! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:02'!
timestamp
	"Answer the value of timestamp"

	^ timestamp! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:02'!
timestamp: anObject
	"Set the value of timestamp"

	timestamp := anObject! !

Object subclass: #CSReplicateMessage
	instanceVariableNames: 'command headerBytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Distribution'!

!CSReplicateMessage class methodsFor: 'as yet unclassified' stamp: 'bs 2/1/2010 20:47:20.627'!
receiveFrom: aSocket
	^ self new 
		receiveFrom: aSocket;
		yourself! !

!CSReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/8/2010 20:15:20.805'!
applyCommand
	Compiler evaluate: self commandAsString.! !

!CSReplicateMessage methodsFor: 'accessing' stamp: 'bs 1/31/2010 13:02:34.162'!
command
	^ command! !

!CSReplicateMessage methodsFor: 'accessing' stamp: 'bs 1/31/2010 13:02:34.162'!
command: anObject
	command := anObject! !

!CSReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 1/31/2010 13:08:26.15'!
commandAsString
	^ self command! !

!CSReplicateMessage methodsFor: 'accessing' stamp: 'bs 2/1/2010 21:02:30.074'!
headerBytes
	^ headerBytes ifNil: [headerBytes := ByteArray new: self numberOfHeaderBytes]! !

!CSReplicateMessage methodsFor: 'accessing' stamp: 'bs 2/1/2010 21:02:20.283'!
numberOfHeaderBytes
	^ 4.! !

!CSReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/9/2010 13:37:46.473'!
receiveFrom: aSocket
	| bytesToRead bytesOfCommandString |
	bytesToRead := self receiveMessageLengthHeader: aSocket.
	bytesOfCommandString := ByteArray new: bytesToRead.
	aSocket receiveDataInto: bytesOfCommandString.
	self command: bytesOfCommandString asString.
	Transcript show: 'received command: ', self commandAsString; cr.! !

!CSReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/9/2010 13:36:12.351'!
receiveMessageLengthHeader: aSocket

	aSocket receiveDataInto: self headerBytes.
	^ self headerBytes unsignedLongAt: 1 bigEndian: true.! !

!CSReplicateMessage methodsFor: 'as yet unclassified' stamp: 'bs 2/1/2010 20:59:14.146'!
sendOn: aSocket
	| commandString |
	commandString := self commandAsString.
	self headerBytes unsignedLongAt: 1 put: (commandString byteSize) bigEndian: true.
	aSocket sendData: self headerBytes, commandString asByteArray! !

Object subclass: #CSStepper
	instanceVariableNames: 'blockToExecute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:01'!
executeInNextStep: aBlock
	blockToExecute := aBlock.
	ActiveWorld startStepping: self at: Time millisecondClockValue selector: #step arguments: nil stepTime: nil.! !

!CSStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:02'!
shouldGetStepsFrom: aWorld
	^ActiveWorld == aWorld! !

!CSStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:01'!
step
	blockToExecute value.
	ActiveWorld stopStepping: self selector: #step.! !

Object subclass: #CSSystemEventMock
	instanceVariableNames: 'item kind'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSSystemEventMock methodsFor: 'accessing' stamp: 'bs 1/17/2010 19:58'!
item
	^ item! !

!CSSystemEventMock methodsFor: 'accessing' stamp: 'bs 1/17/2010 19:58'!
item: anObject
	item := anObject! !

!CSSystemEventMock methodsFor: 'accessing' stamp: 'bs 1/17/2010 19:57'!
kind
	^ kind! !

!CSSystemEventMock methodsFor: 'accessing' stamp: 'bs 1/17/2010 19:57'!
kind: anObject
	kind := anObject! !

!CSSystemEventMock methodsFor: 'accessing' stamp: 'bs 1/17/2010 19:58'!
oldItem
	^ item! !

Object subclass: #CSTestStatistic
	instanceVariableNames: 'receiverClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSTestStatistic methodsFor: 'initialize-release' stamp: 'bs 10/28/2009 15:19'!
addCallInDepth: aNumber
	self flag: #rkrk. "for benchmarking"! !

!CSTestStatistic methodsFor: 'public' stamp: 'replica 2/24/2010 20:47:09.92'!
addReceiverClass: aClass
	self receiverClasses add: aClass.! !

!CSTestStatistic methodsFor: 'public' stamp: 'replica 2/24/2010 20:47:22.937'!
addReceiverClasses: classes
	self receiverClasses addAll: classes.! !

!CSTestStatistic methodsFor: 'as yet unclassified' stamp: 'bs 10/28/2009 15:18'!
printOn: stream

	stream
		nextPutAll: 'CSTestStatistic<Trace:';
		nextPutAll: 'Receivers:';
		print: self receiverClasses;
		nextPut: $>.! !

!CSTestStatistic methodsFor: 'accessing' stamp: 'bs 1/16/2010 22:30'!
receiverClasses
	^ receiverClasses 
		ifNil: [receiverClasses := KeyedIdentitySet keyBlock: [ :e | e scaledIdentityHash ] ]! !

Object subclass: #CSTraceEntry
	instanceVariableNames: 'methodClass methodSelector depth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

CSTraceEntry subclass: #CSTraceCallEntry
	instanceVariableNames: 'receiver arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

!CSTraceCallEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:53'!
arguments
	"Answer the value of arguments"

	^ arguments! !

!CSTraceCallEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:53'!
arguments: anObject
	"Set the value of arguments"

	arguments := anObject! !

!CSTraceCallEntry methodsFor: 'iterating' stamp: 'mp 2/8/2009 12:18'!
getNextMethodPropertiesFor: anIdentifier

	^ (self methodClass methodDict at: self methodSelector) 
		properties at: anIdentifier! !

!CSTraceCallEntry methodsFor: 'testing' stamp: 'mp 2/4/2009 17:56'!
isCall

	^ true! !

!CSTraceCallEntry methodsFor: 'iterating' stamp: 'mp 2/9/2009 15:55'!
iterateNextMethodTrace: anIdentifier	withNextCallBlock: aCallBlock andReturnBlock: aReturnBlock
	
	(self getNextMethodPropertiesFor: anIdentifier)	
		do: [:each | 
			each
				predecessor: self
				ifNextCall: aCallBlock
				ifReturn: aReturnBlock]! !

!CSTraceCallEntry methodsFor: 'testing' stamp: 'mp 2/10/2009 10:48'!
predecessor: aCallEntry ifNextCall: aCallBlock ifReturn: aReturnBlock
	
	(self depth size = (aCallEntry depth size + 1) and: [self depth beginsWith: aCallEntry depth])
		ifTrue: [aCallBlock value: self].! !

!CSTraceCallEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:53'!
receiver
	"Answer the value of receiver"

	^ receiver! !

!CSTraceCallEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:53'!
receiver: anObject
	"Set the value of receiver"

	receiver := anObject! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 18:21'!
depth
	"Answer the value of depth"

	^ depth! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 18:21'!
depth: anObject
	"Set the value of depth"

	depth := anObject! !

!CSTraceEntry methodsFor: 'initialize-release' stamp: 'mp 2/11/2009 13:01'!
initialize

	self depth: OrderedCollection new.! !

!CSTraceEntry methodsFor: 'testing' stamp: 'mp 2/4/2009 17:56'!
isCall
	
	^ false! !

!CSTraceEntry methodsFor: 'testing' stamp: 'mp 2/4/2009 17:56'!
isReturn

	^ false! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/13/2009 13:24'!
methodClass
	"Answer the value of methodClass"

	^ methodClass! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/13/2009 13:24'!
methodClass: anObject
	"Set the value of methodClass"

	methodClass := anObject! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/13/2009 13:24'!
methodSelector
	"Answer the value of methodSelector"

	^ methodSelector! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/13/2009 13:24'!
methodSelector: anObject
	"Set the value of methodSelector"

	methodSelector := anObject! !

!CSTraceEntry methodsFor: 'testing' stamp: 'mp 2/8/2009 12:42'!
predecessor: aCallEntry ifNextCall: aCallBlock ifReturn: aReturnBlock

	self subclassResponsibility.! !

CSTraceEntry subclass: #CSTraceReturnEntry
	instanceVariableNames: 'returnValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

!CSTraceReturnEntry methodsFor: 'testing' stamp: 'mp 2/4/2009 17:56'!
isReturn

	^ true! !

!CSTraceReturnEntry methodsFor: 'testing' stamp: 'mp 2/9/2009 15:55'!
predecessor: aCallEntry ifNextCall: aCallBlock ifReturn: aReturnBlock

	self depth = aCallEntry depth
		ifTrue: [aReturnBlock value: self].! !

!CSTraceReturnEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:54'!
returnValue
	"Answer the value of returnValue"

	^ returnValue! !

!CSTraceReturnEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:54'!
returnValue: anObject
	"Set the value of returnValue"

	returnValue := anObject! !

Object subclass: #CSTraceRegistry
	instanceVariableNames: 'traces'
	classVariableNames: 'UniqueInstance'
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

!CSTraceRegistry class methodsFor: 'queries' stamp: 'mp 2/13/2009 11:24'!
cleanAllAnnotations

	CSTraceRegistry current traces keys do: [:key | self cleanAnnotationsFor: key].
	CSTraceRegistry current initialize.
	Smalltalk garbageCollect.! !

!CSTraceRegistry class methodsFor: 'queries' stamp: 'mp 2/13/2009 11:25'!
cleanAnnotationsFor: anIdentifier

	Smalltalk do: [:each | 
		[each methodDict 
			do: [:method | [method properties removeKey: anIdentifier] ifError: []].
		each class methodDict 
			do: [:method | [method properties removeKey: anIdentifier] ifError: []]]
		ifError: []].
	[CSTraceRegistry current traces removeKey: anIdentifier] ifError: [].! !

!CSTraceRegistry class methodsFor: 'instance creation' stamp: 'mp 2/5/2009 10:14'!
current

	UniqueInstance ifNil: [UniqueInstance := self basicNew initialize].
	^ UniqueInstance! !

!CSTraceRegistry class methodsFor: 'instance creation' stamp: 'mp 2/5/2009 10:12'!
new

	self error: 'Use current to get an instance of Class ' , self name.! !

!CSTraceRegistry methodsFor: 'tracing' stamp: 'mp 2/10/2009 10:56'!
addNewTrace: anIdentifier

	self traces 
		at: anIdentifier ifPresent: [:each | self error: 'Trace key already exist.'];
		at: anIdentifier put: (CSRegisteredTrace with: anIdentifier).
! !

!CSTraceRegistry methodsFor: 'tracing' stamp: 'mp 2/7/2009 16:39'!
at: anIdentifier putReturnValue: anObject

	(self traces at: anIdentifier) returnValue: anObject.! !

!CSTraceRegistry methodsFor: 'tracing' stamp: 'mp 2/6/2009 15:18'!
at: anIdentifier putStartEntry: aTraceEntry

	(self traces at: anIdentifier) startEntries addLast: aTraceEntry.! !

!CSTraceRegistry methodsFor: 'initialize-release' stamp: 'mp 2/5/2009 10:14'!
initialize

	self traces: IdentityDictionary new.! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 13:05'!
printCall: aCallEntry forTrace: anIdentifier on: aStream

	self printCallEntry: aCallEntry on: aStream.	
	aCallEntry 
		iterateNextMethodTrace: anIdentifier
		withNextCallBlock: [:call | 
			self printCall: call forTrace: anIdentifier on: aStream] 
		andReturnBlock: [:return | 
			self printReturnEntry: return on: aStream].! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 11:56'!
printCallEntry: aCallEntry on: aStream
			
	aStream cr.
	aCallEntry depth size timesRepeat: [aStream space].
	aStream	
		nextPutAll: aCallEntry methodClass asString;
		nextPutAll: '>>#';
		nextPutAll: aCallEntry methodSelector asString.! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 13:05'!
printReturnEntry: aReturnEntry on: aStream

	aStream cr.
	aReturnEntry depth size timesRepeat: [aStream space].
	aStream
		nextPut: $^;	
		nextPutAll: aReturnEntry returnValue asString.

	! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 11:52'!
printTrace: anIdentifier
		
	self printTrace: anIdentifier on: Transcript.
	! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 12:01'!
printTrace: anIdentifier on: aStream
		
	self 
		printTraceIdentifier: anIdentifier on: aStream;
		printTraceStartEntries: anIdentifier on: aStream;
		printTraceResult: anIdentifier on: aStream.
	aStream flush.
	! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 11:53'!
printTraceIdentifier: anIdentifier on: aStream

	aStream 
		cr;
		nextPut: $#;
		nextPutAll: anIdentifier asString.! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 18:40'!
printTraceResult: anIdentifier on: aStream

	aStream 
		cr;
		nextPut: $^; 
		nextPutAll: (self traces at: anIdentifier) returnValue returnValue asString.! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 11:55'!
printTraceStartEntries: anIdentifier on: aStream
	
	(self traces at: anIdentifier) startEntries do: [:each | 
		each isCall 
			ifTrue: [self printCall: each forTrace: anIdentifier on: aStream]
			ifFalse: [self error: 'Should not be possible. Trace is corrupted.']].! !

!CSTraceRegistry methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 14:14'!
removeCall: aCallEntry forTrace: anIdentifier

	aCallEntry
		iterateNextMethodTrace: anIdentifier
		withNextCallBlock: [:call | 
			self removeCall: call forTrace: anIdentifier] 
		andReturnBlock: [:return | 
			((aCallEntry getNextMethodPropertiesFor: anIdentifier) last == return)
				ifTrue: [self removeData: aCallEntry fromTrace: anIdentifier]].	! !

!CSTraceRegistry methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 14:16'!
removeData: aCallEntry fromTrace: anIdentifier

	(aCallEntry methodClass methodDict at: aCallEntry methodSelector) 
		properties removeKey: anIdentifier.! !

!CSTraceRegistry methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 15:24'!
removeTrace: anIdentifier

	(self traces at: anIdentifier) startEntries do: [:each | 
		each isCall 
			ifTrue: [self removeCall: each forTrace: anIdentifier]
			ifFalse: [self error: 'Should not be possible. Trace is corrupted.']].
	self traces removeKey: anIdentifier.! !

!CSTraceRegistry methodsFor: 'accessing' stamp: 'mp 2/5/2009 10:14'!
traces
	"Answer the value of traces"

	^ traces! !

!CSTraceRegistry methodsFor: 'accessing' stamp: 'mp 2/5/2009 10:14'!
traces: anObject
	"Set the value of traces"

	traces := anObject! !

Object subclass: #CSTracer
	instanceVariableNames: 'identifier traceBlock depth currentDepth printFlag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

!CSTracer class methodsFor: 'initialization' stamp: 'mp 2/10/2009 12:40'!
identifier: aSymbol
	
	^ self new
		identifier: aSymbol! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/7/2009 16:32'!
addCallFrom: aCurrentContext to: aPrevContext

	| entry |
	entry := self getCallEntry: aCurrentContext.
	aPrevContext == self traceBlock
		ifTrue: [self registry 
					at: self identifier 
					putStartEntry: entry]
		ifFalse: [self addEntry: entry to: aPrevContext].	! !

!CSTracer methodsFor: 'private-adding' stamp: 'test 9/17/2009 23:18'!
addEntry: entry to: aPrevContext

	| entries |
	entries := aPrevContext method properties 
				at: self identifier 
				ifAbsent: [OrderedCollection new].
	aPrevContext method properties 
		at: self identifier 
		put: (entries addLast: entry; yourself).! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/13/2009 13:39'!
addReturnFrom: aCurrentContext to: aPrevContext

	| entry |
	entry := self getReturnEntry: aCurrentContext.
	self addEntry: entry to: aPrevContext.! !

!CSTracer methodsFor: 'private-tracing' stamp: 'mp 2/7/2009 17:41'!
categoriesFromReceiver: anObject

	| receiverClass |
	receiverClass := anObject class.
	receiverClass isMeta
		ifTrue: [receiverClass := anObject].
	^ receiverClass category! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/6/2009 14:07'!
currentDepth
	"Answer the value of currentDepth"

	^ currentDepth! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/6/2009 14:07'!
currentDepth: anObject
	"Set the value of currentDepth"

	currentDepth := anObject! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/6/2009 10:06'!
depth
	"Answer the value of depth"

	^ depth! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/6/2009 10:06'!
depth: anObject
	"Set the value of depth"

	depth := anObject! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/7/2009 16:13'!
getCallEntry: aContext
							
	^ CSTraceCallEntry new
		depth: self depth veryDeepCopy;
		methodClass: aContext methodClass;
		methodSelector: aContext selector;
		"receiver: aContext receiver printString;"
		yourself! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/13/2009 18:16'!
getReturnEntry: aContext

	^ CSTraceReturnEntry new
		depth: self depth veryDeepCopy;
		returnValue: aContext top veryDeepCopy;
		methodClass: aContext methodClass;
		methodSelector: aContext selector;
		yourself! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:58'!
identifier
	"Answer the value of identifier"

	^ identifier! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:58'!
identifier: anObject
	"Set the value of identifier"

	identifier := anObject! !

!CSTracer methodsFor: 'private-depth' stamp: 'mp 2/6/2009 14:16'!
increaseDepth
		
	| entry |
	entry := self depth at: self currentDepth ifAbsent: nil.
	entry
		ifNil: [self depth at: self currentDepth ifAbsentPut: 1]
		ifNotNil: [self depth at: self currentDepth put: entry + 1].! !

!CSTracer methodsFor: 'initialize-release' stamp: 'mp 2/11/2009 14:43'!
initialize
	
	self 
		identifier: DateAndTime now asString asSymbol;
		depth: OrderedCollection new;
		printFlag: false.! !

!CSTracer methodsFor: 'private-printing' stamp: 'mp 2/11/2009 14:44'!
printCallFrom: aContext

	self printFlag 
		ifTrue:[
			Transcript cr.
			self currentDepth timesRepeat: [Transcript space].
			Transcript 
				nextPutAll: aContext receiver printString;
				space; 
				nextPutAll: aContext selector; 
				space; 
				nextPutAll: self depth asString; 
				flush].! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/11/2009 14:43'!
printFlag
	"Answer the value of printFlag"

	^ printFlag! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/11/2009 14:43'!
printFlag: anObject
	"Set the value of printFlag"

	printFlag := anObject! !

!CSTracer methodsFor: 'private-printing' stamp: 'mp 2/11/2009 14:45'!
printReturnFrom: aContext

	self printFlag 
		ifTrue:[
			Transcript cr.
			self currentDepth timesRepeat: [Transcript space].
			Transcript 
				space; 
				nextPut: $^;
				nextPutAll: aContext top printString;
				space; 
				nextPutAll: self depth asString;
				flush].! !

!CSTracer methodsFor: 'private-depth' stamp: 'mp 2/6/2009 14:15'!
reduceDepth

	self depth size = (self currentDepth + 2)
		ifTrue: [self depth removeLast.].! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/10/2009 10:56'!
registerTrace

	self registry addNewTrace: self identifier.! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:09'!
registry
	
	^ CSTraceRegistry current! !

!CSTracer methodsFor: 'tracing' stamp: 'mp 2/11/2009 14:49'!
trace: aBlock

	| previousContext result |
	self 
		registerTrace;
		traceBlock: aBlock.
	previousContext := self traceBlock.
	result := thisContext sender
		runSimulated: self traceBlock
		contextAtEachStep:
			[:currentContext |
			"Sensor anyButtonPressed ifTrue: [^ nil]."
			currentContext == previousContext
				ifFalse:
					[previousContext := self traceWith: currentContext and: previousContext]].
		self registry 
			at: self identifier 
			putReturnValue: (CSTraceReturnEntry new
								returnValue: result).
		^ result! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:28'!
traceBlock
	"Answer the value of traceBlock"

	^ traceBlock! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:28'!
traceBlock: anObject
	"Set the value of traceBlock"

	traceBlock := anObject! !

!CSTracer methodsFor: 'private-tracing' stamp: 'mp 2/7/2009 18:12'!
traceMethodCallWith: aCurrentContext and: aPreviousContext
	
	self 
		increaseDepth;
		addCallFrom: aCurrentContext to: aPreviousContext;
		printCallFrom: aCurrentContext.! !

!CSTracer methodsFor: 'private-tracing' stamp: 'mp 2/7/2009 18:12'!
traceReturnWith: aCurrentContext and: aPreviousContext
	
	self 
		reduceDepth;
		addReturnFrom: aCurrentContext to: aPreviousContext;
		printReturnFrom: aCurrentContext.! !

!CSTracer methodsFor: 'private-tracing' stamp: 'mp 2/10/2009 10:48'!
traceWith: aCurrentContext and: aPreviousContext

	self currentDepth: (aCurrentContext depthBelow: self traceBlock).
	aPreviousContext sender
		ifNil: [self traceReturnWith: aCurrentContext and: aPreviousContext]
		ifNotNil: [self traceMethodCallWith: aCurrentContext and: aPreviousContext].
	^ aCurrentContext! !

Object subclass: #CodeSightSarBuilder
	instanceVariableNames: 'zip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Install'!

!CodeSightSarBuilder class methodsFor: 'service' stamp: 'rkrk 11/27/2009 15:14'!
create

	"self create"
	^ self new create! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'bs 1/25/2010 10:19:49.792'!
addFiles

	| paths |
	paths := {self downloadLatestSwaUtilVersion.
	self downloadMethodWrapperMczs.
	self downloadLatestCodeSightVersion.
	self	downloadLatestCodeSightTestExamplesVersion} gather: [:ea |
		(ea isCollection and: [ea isString not]) ifTrue: [ea] ifFalse: [{ea}]]. "flatten"
	paths do: [:path | 
		zip addFile: path as: (path subStrings: '/\') last].! !

!CodeSightSarBuilder methodsFor: 'postscript' stamp: 'rkrk 11/27/2009 13:28'!
addPostScript

	zip addString: self postscript as: 'install/postscript'.! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 11/27/2009 13:28'!
addPreamble

	zip addString: self preamble as: 'install/preamble'.! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'rkrk 11/27/2009 15:12'!
create

	self
		createZip;
		addPreamble;
		addPostScript;
		addFiles;
		writeAndCloseZip.! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'rkrk 11/27/2009 13:30'!
createZip

	zip := ZipArchive new.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:21'!
downloadLatestCodeSightTestExamplesVersion

	^ self fromCodeSightRepoDownload: 'CodeSightTestExamples-'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:21'!
downloadLatestCodeSightVersion

	^ self fromCodeSightRepoDownload: 'CodeSight-'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'bs 1/25/2010 10:17:57.281'!
downloadLatestSwaUtilVersion

	^ self fromSwaUtilitiesRepoDownload: 'SwaUtil-'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 11/27/2009 15:45'!
downloadMethodWrapperFromSqueakMap

	| squeakMap package |
	squeakMap := SMSqueakMap default.
	squeakMap objects ifNil: [
		squeakMap inspect.
		self error: 'There is a problem with the SqueakMap instance, inst var objects should be a dictionary but is nil. Please fix it and restart the build process!!'].
	package := squeakMap packageWithNameBeginning: 'MethodWrappers'.
	^ (SMInstaller forPackageRelease: package lastRelease)
		download;
		fullFileName.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 11/27/2009 15:59'!
downloadMethodWrapperMcz

	^ self fromCodeSightRepoDownload: 'MethodWrappers'.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:30'!
downloadMethodWrapperMczs

	^ {self fromCodeSightRepoDownload: 'MethodWrappers-'. "newest"
	self fromCodeSightRepoDownload: 'Methodwrappers-rkrk.1'. "for non trunk images"}
	! !

!CodeSightSarBuilder methodsFor: 'default' stamp: 'rkrk 11/27/2009 15:14'!
filename

	^ 'CodeSight-' , Date today yyyymmdd , '.sar'! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:58'!
fromCodeSightRepoDownload: packageOrVersionName

	^ self
		fromRepo: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/CodeSight'
		download: packageOrVersionName.! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'rkrk 1/4/2010 02:58'!
fromRepo: repoUrl download: packageOrVersionName

	| repo versionName filename mimeDoc |
	repo := MCHttpRepository
		location: repoUrl
		user: ''
		password: ''.
	versionName := repo allVersionNames detect: [:ea | ea startsWith: packageOrVersionName]. "assume latest first. Seems to work..."
	filename := versionName , '.mcz'.
	mimeDoc := (Url absoluteFromText:  (repo urlForFileNamed: filename)) retrieveContents.
	^ FileStream
		forceNewFileNamed: filename
		do: [:s | s binary. s nextPutAll: mimeDoc content. s fullName].! !

!CodeSightSarBuilder methodsFor: 'download' stamp: 'bs 1/25/2010 10:17:23.85'!
fromSwaUtilitiesRepoDownload: packageOrVersionName

	^ self
		fromRepo: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/SwaUtilities'
		download: packageOrVersionName.! !

!CodeSightSarBuilder methodsFor: 'postscript' stamp: 'rkrk 11/27/2009 15:10'!
postscript

	^ 'CSCoverageTracingWrapper initialize'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'bs 1/25/2010 10:20:59.759'!
preamble

	^ String streamContents: [:s |
		s
			nextPutAll: self preambleSwaUtilInstall; cr;
			nextPutAll: self preambleMethodWrapperInstall; cr;
			nextPutAll: self preambleCodeSightInstall; cr;
			nextPutAll: self preambleCodeSightTestExamplesInstall; cr].! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 11/27/2009 15:04'!
preambleCodeSightInstall

	^ '(self membersMatching: ''CodeSight-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 1/4/2010 02:17'!
preambleCodeSightTestExamplesInstall

	^ '(self membersMatching: ''CodeSightTestExamples-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 1/4/2010 02:45'!
preambleMethodWrapperInstall

	^ '"For trunk image choose newest version, for olde images choose 1.mcz"
	SystemVersion current highestUpdate <= 7179
		ifTrue: [self installMember: (self memberNamed: ''Methodwrappers-rkrk.1.mcz'')]
		ifFalse: [(self membersMatching: ''MethodWrappers-*.mcz'') do: [:ea |
					ea fileName ~= ''Methodwrappers-rkrk.1.mcz'' ifTrue: [
						self installMember: ea]]].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'rkrk 1/4/2010 03:01'!
preambleSWAUtilInstall

	^ '(self membersMatching: ''SwaUtil-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'preamble' stamp: 'bs 1/25/2010 10:20:24.481'!
preambleSwaUtilInstall

	^ '(self membersMatching: ''SwaUtil-*.mcz'') do: [:ea | self installMember: ea].'! !

!CodeSightSarBuilder methodsFor: 'sar creation' stamp: 'rkrk 11/27/2009 15:15'!
writeAndCloseZip

	zip
		writeToFileNamed: self filename;
		close.! !

Object subclass: #DummyMonitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!DummyMonitor methodsFor: 'as yet unclassified' stamp: 'bs 1/16/2010 11:10'!
critical: aBlock
	^ aBlock value! !

!Object methodsFor: '*CodeSight' stamp: 'bs 4/28/2009 18:20'!
debugAndUninstallBreakpointBefore
	(Debugger context: thisContext)
		debug: 'Debugger' executeBefore: [:debugger | 
			debugger down.
			BreakpointManager unInstall: debugger selectedContext method.
			debugger restartAfterMethodChanged.].
	Processor activeProcess suspend.! !

!MenuIcons class methodsFor: '*codesight' stamp: 'mt 5/3/2009 20:40'!
csAcceptIcon

	^ Icons
			at: #'csAccept'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self csAcceptIconContents readStream) ].! !

!MenuIcons class methodsFor: '*codesight' stamp: 'mt 5/3/2009 20:39'!
csAcceptIconContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAKfSURBVDjLpZPrS1NhHMf9O3bO
dmwDCWREIYKEUHsVJBI7mg3FvCxL09290jZj2EyLMnJexkgpLbPUanNOberU5taUMnHZUULM
velCtWF0sW/n7MVMEiN64AsPD8/n83uucQDi/id/DBT4Dolypw/qsz0pTMbj/WHpiDgsdSUy
UmeiPt2+V7SrIM+bSss8ySGdR4abQQv6lrui6VxsRonrGCS9VEjSQ9E7CtiqdOZ4UuTqnBHO
1X7YXl6Daa4yGq7vWO1D40wVDtj4kWQbn94myPGkCDPdSesczE2sCZShwl8CzcwZ6NiUs6n2
nYX99T1cnKqA2EKui6+TwphA5k4yqMayopU5mANV3lNQTBdCMVUA9VQh3GuDMHiVcLCS3J4j
SLhCGmKCjBEx0xlshjXYhApfMZRP5CyYD+UkG08+xt+4wLVQZA1tzxthm2tEfD3JxARH7Qkb
D1ZuozaggdZbxK5kAIsf5qGaKMTY2lAU/rH5HW3PLsEwUYy+YCcERmIjJpDcpzb6l7th9KtQ
69fi09ePUej9l7cx2DJbD7UrG3r3afQHOyCo+V3QQzE35pvQvnAZukk5zL5qRL59jsKbPzdh
eXoBZc4saFhBS6AO7V4zqCpiawuptwQG+UAa7Ct3UT0hh9p9EnXT5Vh6t4C22QaUDh6HwnEC
OmcO7K+6kW49DKqS2DrEZCtfuI+9GrNHg4fMHVSO5kE7nAPVkAxKBxcOzsajpS4Yh4ohUPPW
KTUh3PaQEptIOr6BiJjcZXCwktaAGfrRIpwblqOV3YKdhfXOIvBLeREWpnd8ynsaSJoyESFp
hwTtfjN6X1jRO2+FxWtCWksqBApeiFIR9K6fiTpPiigDoadqCEag5YUFKl6Yrciw0VOlhOiv
v/Ff8wtn0KzlebrUYwAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*codesight' stamp: 'rkrk 9/22/2009 07:08'!
csBlankBarIcon

	^ Form extent: 57@24.! !

!MenuIcons class methodsFor: '*codesight' stamp: 'rkrk 9/22/2009 06:55'!
csGreenBarIcon

	^ Icons
			at: #'csGreenBar'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self csGreenBarIconContents readStream) ].! !

!MenuIcons class methodsFor: '*codesight' stamp: 'rkrk 9/22/2009 06:54'!
csGreenBarIconContents

	^  'iVBORw0KGgoAAAANSUhEUgAAADkAAAAYCAYAAABA6FUWAAAACXBIWXMAAAsTAAALEwEAmpwY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'! !

!MenuIcons class methodsFor: '*codesight' stamp: 'rkrk 9/30/2009 05:17'!
csHourGlassIcon

	^ Icons
			at: #'csHourGlassIcon'
			ifAbsentPut: [((CursorWithMask
	extent: 16@16
	depth: 1
	fromArray: #( 0 2147352576 1073872896 537133056 268959744 242221056 132120576 62914560 62914560 77594624 143654912 281542656 568590336 1207566336 2147352576 0)
	offset: -1@-1) setMaskForm: (Form
	extent: 16@16
	depth: 1
	fromArray: #( 4294901760 4294901760 4294901760 4162781184 2147352576 1073479680 536346624 267386880 267386880 536346624 1073479680 2147352576 4294901760 4294901760 4294901760 4294901760)
	offset: 0@0)) as8BitColorForm].! !

!MenuIcons class methodsFor: '*codesight' stamp: 'rkrk 9/22/2009 06:56'!
csRedBarIcon

	^ Icons
			at: #'csRedBar'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self csRedBarIconContents readStream) ].! !

!MenuIcons class methodsFor: '*codesight' stamp: 'rkrk 9/22/2009 06:56'!
csRedBarIconContents

	^   'iVBORw0KGgoAAAANSUhEUgAAADkAAAAYCAYAAABA6FUWAAAACXBIWXMAAAsTAAALEwEAmpwY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'! !

OBCommand subclass: #CSCmdShowTestResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!CSCmdShowTestResult methodsFor: 'user interface' stamp: 'rkrk 12/8/2009 13:51'!
addItemToMenu: aMenu

	"don't add to menu'"! !

!CSCmdShowTestResult methodsFor: 'data' stamp: 'bs 1/14/2010 12:53'!
allTestsPassed

	^ self testResult hasPassed! !

!CSCmdShowTestResult methodsFor: 'accessing' stamp: 'rkrk 9/30/2009 01:56'!
browser

	^ requestor browser! !

!CSCmdShowTestResult methodsFor: 'icon assembly' stamp: 'bs 1/14/2010 11:14'!
buttonLabelWithSpaces

	| fillColor frame canvas |
	fillColor := self allTestsPassed
		ifTrue: [Color green]
		ifFalse: [Color red].
	frame := 0@0 corner: 60@25.
	canvas := self canvasFits: frame colored: fillColor.
	self isRunning ifTrue: [
		self
			drawHourglassOn: canvas
			colored: fillColor
			at: 10@5].
	self defectCount isZero ifFalse: [
		self
			drawString: self defectCount asString
			on: canvas
			fitting: (30@5 corner: 55@20)].
	^ canvas form asMorph.! !

!CSCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 9/30/2009 05:27'!
canvasFits: frame colored: fillColor

	| canvas rounding roundingLeft roundingRight |
	canvas :=(FormCanvas extent: frame extent depth: 16) asAlphaBlendingCanvas: 1.
	
	rounding := 20.
	roundingLeft := frame topLeft corner: (frame right-rounding)@frame bottom.
	canvas fillOval: roundingLeft color: fillColor.
	roundingRight := (frame left+rounding)@frame top corner: frame bottomRight.
	canvas fillOval: roundingRight color: fillColor.
	canvas
		fillRectangle: (roundingRight topLeft corner: roundingLeft bottomRight)
		color: fillColor.

	^ canvas.! !

!CSCmdShowTestResult methodsFor: 'data' stamp: 'bs 1/14/2010 11:06'!
csInfo
	^ self browser csInfo! !

!CSCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 9/30/2009 02:33'!
defectCount

	^ self testResult failureCount + self testResult errorCount! !

!CSCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 9/30/2009 05:28'!
drawHourglassOn: canvas colored: fillColor at: pt

	| hourglass |
	hourglass := MenuIcons csHourGlassIcon deepCopy
		mapColor: Color white
		to: fillColor.
	canvas translucentImage: hourglass at: pt.! !

!CSCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 9/30/2009 04:37'!
drawString: string on: canvas fitting: rect

	canvas drawString: string in: rect.! !

!CSCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 10/7/2009 11:15'!
dummyLabelGreen: isGreen running: isRunning defectCount: defects

	| fillColor frame canvas |
	fillColor := isGreen
		ifTrue: [Color green]
		ifFalse: [Color red].
	frame := 0@0 corner: 60@25.
	canvas := self canvasFits: frame colored: fillColor.
	isRunning ifTrue: [
		self
			drawHourglassOn: canvas
			colored: fillColor
			at: 10@5].
	defects isZero ifFalse: [
		self
			drawString: defects asString
			on: canvas
			fitting: (30@5 corner: 55@20)].
	^ canvas form asMorph.! !

!CSCmdShowTestResult methodsFor: 'execution' stamp: 'bs 1/14/2010 11:18'!
execute

	self csInfo openTestRunner! !

!CSCmdShowTestResult methodsFor: 'accessing' stamp: 'rkrk 9/22/2009 02:20'!
group
	^ #codesight! !

!CSCmdShowTestResult methodsFor: 'testing' stamp: 'bs 1/14/2010 11:09'!
isActive
	^ self csInfo isActive! !

!CSCmdShowTestResult methodsFor: 'data' stamp: 'bs 1/14/2010 11:11'!
isRunning

	^ self csInfo isRunning! !

!CSCmdShowTestResult methodsFor: 'accessing' stamp: 'rkrk 12/8/2009 13:52'!
label

	^ 'this should not appear anywhere'! !

!CSCmdShowTestResult methodsFor: 'data' stamp: 'bs 1/14/2010 11:15'!
testResult

	^ self csInfo testResult! !

!CSCmdShowTestResult methodsFor: 'testing' stamp: 'rkrk 9/22/2009 02:19'!
wantsButton

	^ true
! !

!OBClassAwareNode methodsFor: '*codesight' stamp: 'bs 1/14/2010 14:48'!
csInfo
	^ CSInfo instance! !

OBClassAwareNode subclass: #OBCoveringTestCaseBaseNode
	instanceVariableNames: 'coveredMethodNode definition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!OBCoveringTestCaseBaseNode methodsFor: 'accessing' stamp: 'test 9/22/2009 16:38'!
coveredMethod
	^ coveredMethodNode compiledMethod! !

!OBCoveringTestCaseBaseNode methodsFor: 'accessing' stamp: 'test 9/22/2009 16:38'!
coveredMethodNode
	^ coveredMethodNode ! !

!OBCoveringTestCaseBaseNode methodsFor: 'accessing' stamp: 'test 9/22/2009 16:37'!
coveredMethodNode: anObject
	coveredMethodNode := anObject.
	definition := coveredMethodNode definition.! !

!OBCoveringTestCaseBaseNode methodsFor: 'accessing' stamp: 'test 9/22/2009 16:38'!
definition
	^ definition! !

OBCoveringTestCaseBaseNode subclass: #OBCoveringTestCaseNode
	instanceVariableNames: 'testMethod statistics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!OBCoveringTestCaseNode class methodsFor: 'as yet unclassified' stamp: 'bs 1/3/2010 22:37'!
on: testMethod coveredMethodNode: aCoveredMethodNode
	^ self new 
		testMethod: testMethod;
		coveredMethodNode: aCoveredMethodNode.! !

!OBCoveringTestCaseNode methodsFor: 'as yet unclassified' stamp: 'test 9/22/2009 18:15'!
name
	^ self testMethod methodClass name, ' >> #',self testMethod selector! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 20:53'!
testMethod
	^ testMethod! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 20:53'!
testMethod: anObject
	testMethod := anObject! !

OBCoveringTestCaseBaseNode subclass: #OBCoveringTestCaseSeparatorNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!OBCoveringTestCaseSeparatorNode class methodsFor: 'as yet unclassified' stamp: 'test 9/22/2009 16:36'!
coveredMethodNode: aCoveredMethodNode
	^ self new 
		coveredMethodNode: aCoveredMethodNode.! !

!OBCoveringTestCaseSeparatorNode methodsFor: 'as yet unclassified' stamp: 'test 9/22/2009 21:21'!
name
	^ ('---------', String crlf, '---') asText! !

OBPackageBrowser subclass: #CSBrowser
	instanceVariableNames: 'isRunning'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!CSBrowser class methodsFor: 'as yet unclassified' stamp: 'bs 5/2/2009 23:32'!
buildMetagraphOn: root class: classSel comment: commentSel metaclass: metaclassSel 
     | metaGraph |
     metaGraph := CSMetagraphBuilder
		               on: root class: classSel comment: commentSel metaclass: metaclassSel.
	metaGraph classMetaNode doubleClickCommandClass: OBEnhancementCmdBrowseHierarchy.
	metaGraph metaclassMetaNode doubleClickCommandClass: OBEnhancementCmdBrowseHierarchy.
	"metaGraph methodMetaNode doubleClickCommandClass: OBCmdSelectMethodCategory."
	^metaGraph execute ! !

!CSBrowser class methodsFor: 'as yet unclassified' stamp: 'bs 5/2/2009 20:52'!
defaultMetaNode
     | env smartGroup package cats classes builder |
	env := OBMetaNode named: 'Environment'.
	package := OBMetaNode named: 'Package'.
	package
	      displaySelector: #indentedName;
	      ancestrySelector: #isDescendantOfPackage:.
	cats := OBMetaNode named: 'Cats'.
	cats
	      displaySelector: #nameWithoutPrefix;	
	      ancestrySelector: #isDescendantOfClassCat:.	
	(package childAt: #classCategories put: cats) navigateTree.
	
	self buildMetagraphOn: package.
	"self buildMetagraphOn: cats."
     (package edges reject: [:edge | edge selector = #classCategories]) do: [:edge | cats addEdge: edge].
	package filters do: [:filter | cats addFilter: filter].

	classes := OBMetaNode named: 'Classes'.
	classes
		displaySelector: #indentedName;
		ancestrySelector: #isDescendantOfClass:.
	builder := CSMetagraphBuilder
		         on: classes 
	              class: #packagesForClassClass 
	              comment: #packagesForClassComment 
	              metaclass: #packagesForClassMetaclass.
	builder execute.
	builder classMetaNode removeFilter: OBClassInheritanceFilter new; displaySelector: #indentedName.		
	builder metaclassMetaNode removeFilter: OBClassInheritanceFilter new; displaySelector: #indentedName.		
	builder classCommentMetaNode removeFilter: OBClassInheritanceFilter new; displaySelector: #indentedName.							
	classes removeFilter: OBQueryingClassSortFilter new.
	
     smartGroup := OBMetaNode named: 'SmartGroup'.
     smartGroup
		displaySelector: #indentedName.
	(package edges reject: [:edge | edge selector = #classCategories]) do: [:edge | smartGroup addEdge: edge].
	smartGroup addFilter: OBModalFilter new;
		          addFilter: OBClassSortFilter new.
	
     env
		childAt: #packages
			labeled: 'pkgs'
			put: package;
		childAt: #classesHierarchically
			labeled: 'hier.'
			put: classes;				
		childAt: #smartGroups
			labeled: 'smart groups'
			put: smartGroup;
		addFilter: OBModalFilter new.
     ^env! !

!CSBrowser class methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 23:12'!
paneCount
	^ 5! !

!CSBrowser class methodsFor: 'as yet unclassified' stamp: 'rkrk 10/6/2009 13:35'!
title
	^ 'Browser'! !

!CSBrowser methodsFor: 'commands' stamp: 'rkrk 9/22/2009 02:15'!
cmdShowTestResult
	^ CSCmdShowTestResult! !

!CSBrowser methodsFor: 'test infos' stamp: 'bs 1/14/2010 11:06'!
csInfo
	^ CSInfo instance! !

!CSBrowser methodsFor: 'debugging into tests' stamp: 'bs 5/4/2009 21:43'!
selectionChanged: announcement
	
	| node testMethod testClass testSelector testSuite |	
	node := announcement node.
	(node isNil not and: [ node isKindOf: OBCoveringTestCaseNode]) ifTrue: [
		testMethod := node testMethod.
		testClass := testMethod methodClass.
		testSelector := testMethod selector.
		testSuite := testClass suiteWithSelectorsMatching: testSelector.
		[
		BreakpointManager installSelfRemovingBreakpointInClass: (node coveredMethod methodClass) selector: (node coveredMethod selector).
		[ testSuite run ] ensure: [ 
			BreakpointManager unInstallInClass: (node coveredMethod methodClass) selector: (node coveredMethod selector). ].
		] forkAt: Processor activePriority.].! !

!CSBrowser methodsFor: 'subscribing' stamp: 'bs 1/14/2010 11:47'!
subscribe
	super subscribe.
	self csInfo addDependent: self.
	self announcer
		observe: OBSelectionChanged send: #selectionChanged: to: self.! !

!CSBrowser methodsFor: 'test infos' stamp: 'bs 2/25/2010 12:19:47.021'!
update: aSymbol
	super update: aSymbol.
	(#(newTestResult startTestRun endTestRun coverageUpdated) includes: aSymbol) ifFalse: [^ self].
	self announce: OBNodeChanged
	! !

OBEnhancementMetagraphBuilder subclass: #CSMetagraphBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!CSMetagraphBuilder methodsFor: 'as yet unclassified' stamp: 'bs 5/2/2009 23:41'!
createMethodMetaNode
	| methodMetaNode testMetaNode |
	testMetaNode := OBEnhancementMetaNode named: #CoveringTestCases.
	methodMetaNode := OBEnhancementMetaNode named: #Method.
	methodMetaNode childAt: #coveringTestMethods put: testMetaNode.
	^ methodMetaNode! !

!CSMetagraphBuilder methodsFor: 'as yet unclassified' stamp: 'bs 5/3/2009 09:57'!
methodMetaNode
   ^(self metaNodes
		at: #Method
		ifAbsentPut: [OBEnhancementMetaNode named: #Method])! !

!CSMetagraphBuilder methodsFor: 'as yet unclassified' stamp: 'bs 5/3/2009 10:00'!
populateMethodNode
	| testMetaNode |
	super populateMethodNode.
	testMetaNode := OBEnhancementMetaNode named: #CoveringTestCases.
	self methodMetaNode
		childAt: #coveringTestMethods put: testMetaNode.
! !

!OBClassNode methodsFor: '*codesight' stamp: 'bs 1/14/2010 14:49'!
backgroundColor

	(self csInfo isClassManaged: theClass)
		ifFalse: [^ super backgroundColor].
	theClass methodDict values do: [:method |
		(method hasCoveringTestMethods
			or: [method selector isTestSelector
				and: [theClass inheritsFrom: TestCase]])
					ifFalse: [^ Color lightOrange]].
	^ super backgroundColor.! !

!Debugger methodsFor: '*codesight' stamp: 'bs 4/16/2009 12:06'!
debug: label executeBefore: aBlock
	"Open a full DebuggerView."
	Smalltalk isMorphic
		ifTrue:
			[self openFullMorphicLabel: label.
			 CSStepper new executeInNextStep: [aBlock value: self].
			 errorWasInUIProcess := Project spawnNewProcessIfThisIsUI: interruptedProcess.
			 ^self].
! !

!Debugger methodsFor: '*codesight' stamp: 'bs 4/16/2009 11:16'!
restartAfterMethodChanged 
	"The retrieved information has changed and its source must now be  
	updated. In this case, the retrieved information is the method of the  
	selected context."
	| selector classOfMethod category h ctxt |
	
	h := self selectedContext finalBlockHome.
	self resetContext: h.
	classOfMethod := self selectedClass.
	category := self selectedMessageCategoryName.
	selector := self selectedMessageName.
	
	contents := classOfMethod sourceCodeAt: selector.
	ctxt := interruptedProcess popTo: self selectedContext.
	interruptedProcess suspendedContext privRefreshWith: (classOfMethod compiledMethodAt: selector).
	"interruptedProcess
		restartTopWith: (classOfMethod compiledMethodAt: selector)."
	contextVariablesInspector object: nil.
	theMethodNode := Preferences browseWithPrettyPrint
		ifTrue: [ctxt methodNodeFormattedAndDecorated: Preferences colorWhenPrettyPrinting]
		ifFalse: [ctxt methodNode].
	sourceMap := theMethodNode sourceMap.
	tempNames := theMethodNode tempNames.
		
	self resetContext: ctxt.
	self changed.
	^ true! !

!OBMorphicIcons methodsFor: '*codesight' stamp: 'mt 5/3/2009 20:44'!
csAccept

	^ MenuIcons csAcceptIcon! !

TestResult subclass: #CSTestResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSTestResult methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:22:31.615'!
addToPassed: aTestCase
	passed add: aTestCase! !

!TestResult methodsFor: '*CodeSight' stamp: 'bs 1/15/2010 21:48'!
defectTestMethods
	^ (self defects collect: [ :aTestCase | aTestCase class >> aTestCase selector ]) asIdentitySet! !

!TestResult methodsFor: '*CodeSight' stamp: 'bs 12/22/2009 18:34'!
isDefect: aTestMethod
	|selector class|
	selector := aTestMethod selector.
	class := aTestMethod methodClass.
	
	^ self defects 
		anySatisfy: [ :testCase | 
			(testCase selector == selector) and: [testCase class == class] ]! !

!TestResult methodsFor: '*CodeSight' stamp: 'bs 2/20/2010 21:23:04.994'!
postCopy
	failures := failures collect: [ :ea | ea class selector: ea selector ].
	errors := errors collect: [ :ea | ea class selector: ea selector ].
	passed := passed collect: [ :ea | ea class selector: ea selector ].! !

!TestResult methodsFor: '*CodeSight' stamp: 'bs 12/22/2009 15:25'!
removeIfPresent: aTestMethod
	|selector class|
	selector := aTestMethod selector.
	class := aTestMethod methodClass.
	{errors. failures. passed} do: [ :aTestSet | 
		aTestSet 
			select: [ :testCase | (testCase selector == selector) and: [testCase class == class] ]
			thenDo: [ :testCase | aTestSet remove: testCase. ] ].! !

!TestResult methodsFor: '*CodeSight-override' stamp: 'bs 12/21/2009 12:36'!
runCase: aTestCase
	| testCasePassed |
	testCasePassed := true.
	[[aTestCase runCase] 
			on: self class failure
			do: 
				[:signal | 
				failures add: aTestCase.
				testCasePassed := false.
				aTestCase recordRunFailedWith: signal.
				signal return: false]]
					on: self class error
					do:
						[:signal |
						errors add: aTestCase.
						testCasePassed := false.
						aTestCase recordRunFailedWith: signal.
						signal return: false].
	testCasePassed 
		ifTrue: [
			passed add: aTestCase.
			aTestCase recordRunWasSuccessful]! !

TestRunner subclass: #CSTestRunner
	instanceVariableNames: 'isInTddAutoRunMode runsTestsInBackground modifiedMethods tddMonitor codeSight window'
	classVariableNames: 'RunInBackgroundMonitor'
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

CSTestRunner class
	instanceVariableNames: 'classesToBeTraced'!

CSTestRunner class
	instanceVariableNames: 'classesToBeTraced'!

!CSTestRunner class methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 15:28'!
initialize
	"CSTestRunner initialize"
	self registerInWorldMenu; registerInToolsFlap.! !

!CSTestRunner class methodsFor: 'synchronizing' stamp: 'bs 1/4/2010 13:35'!
measureExecutionTimesForPackagesWith: aString
	"CSTestRunner measureExecutionTimes"
	|packages classes testCase time testClasses testCaseTimes result coveredMethods coveringTestMethods coveredMethodsTestTimeDeltas classTestTime aTestRunner aSuite |
	packages := PackageOrganizer default packages select: [:p | p packageName startsWith: aString].
	packages do: [:p | self instrumentor instrumentPackage: p].
	classes := (packages gather: [:p | p classes]) asSet.

	aTestRunner := CSTestRunner new.
	testCase := nil.
	time := nil.

	testClasses := classes select: [:class | class inheritsFrom: TestCase].
	testCaseTimes := Dictionary new.
	testClasses do: [:testClass | 
		testClass selectors select: [:s | s isTestSelector] thenDo: [:s | 
			aSuite := TestSuite new.
			aSuite addTest: (testClass selector: s).
			time := [aTestRunner runSuite: aSuite] timeToRun.
			testCaseTimes at: (testClass >> s) put: time]].

	result := Dictionary new.	
	coveredMethods := nil.
	coveredMethodsTestTimeDeltas := nil.
	classes select: [:c | c methodDict values contains: [:m | m hasCoveringTestMethods]]
	 		  thenDo: [:aClass |
		coveredMethods := aClass methodDict values select: [:m | m hasCoveringTestMethods ].
		coveringTestMethods := (coveredMethods gather: [:m | m coveringTestMethods]) asSet.
		classTestTime := (coveringTestMethods collect: [:m | testCaseTimes at: m ifAbsent: [0]]) sum.
		
		coveredMethodsTestTimeDeltas := classTestTime - (coveredMethods collect: [:cm | 
			(cm coveringTestMethods collect: [:tm | testCaseTimes at: tm ifAbsent: [0]]) sum]).
		
		coveredMethodsTestTimeDeltas ifNotEmpty: [
			result at: aClass put: {coveredMethods size. coveredMethodsTestTimeDeltas max. coveredMethodsTestTimeDeltas average}]].
	
	packages do: [:p | self instrumentor uninstrumentPackage: p].
	^ result
! !

!CSTestRunner class methodsFor: 'as yet unclassified' stamp: 'bs 4/22/2009 15:14'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( CSTestRunner build 'CodeSight Test Runner' 'A production scale test-runner for XP Forums.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!CSTestRunner class methodsFor: 'as yet unclassified' stamp: 'mab 4/2/2009 20:33'!
registerInWorldMenu
	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'CodeSight Test Runner' 
			with: (Array
				with: self
				with: #open)) ].! !

!CSTestRunner class methodsFor: 'synchronizing' stamp: 'test 9/17/2009 23:32'!
resetSourceCodeAccessMonitor
	^ RunInBackgroundMonitor := nil! !

!CSTestRunner class methodsFor: 'synchronizing' stamp: 'bs 9/14/2009 10:50'!
sourceCodeAccessMonitor
	^ RunInBackgroundMonitor ifNil: [ RunInBackgroundMonitor := Monitor new ]! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 1/24/2010 22:08'!
basicSetUpSuite: aTestSuite 
	| testMethod |
	super basicSetUpSuite: aTestSuite.
	
	"aTestSuite tests do: [ :aTestCase | 
		testMethod := aTestCase class >> aTestCase selector.
		testMethod resetCoveredMethodsStatistics ]."! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 1/21/2010 15:44'!
basicTearDownSuite: aTestSuite
	self codeSight testMethodGoingToRun: nil.
	super basicTearDownSuite: aTestSuite.
	! !

!CSTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:02'!
buildControlPanelWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		layout: #vertical;
		children: {
			self buildButtonsWith: aBuilder.
			self buildTddControlButtonsWith: aBuilder
			};
		yourself.! !

!CSTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:18'!
buildTddControlButtonsWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		model: self;
		layout: #horizontal;
		children: (self tddFlags collect: [ :each |
			aBuilder pluggableActionButtonSpec new
				model: self; 
				label: each first;
				action: each second;
				yourself ]);
		yourself.! !

!CSTestRunner methodsFor: 'ui-building' stamp: 'bs 1/14/2010 10:16'!
buildWith: aBuilder
	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; label: self label; extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildCategoriesWith: aBuilder)
				frame: (0.00 @ 0.00 corner: 0.25 @ 0.84 );
				yourself);				
			add: ((self buildClassesWith: aBuilder)
				frame: (0.25 @ 0.00 corner: 0.50 @ 0.84 );
				yourself);
			add: ((self buildStatusWith: aBuilder)
				frame: (0.50 @ 0.00 corner: 1.00 @ 0.08);
				yourself);
			add: ((self buildFailureListWith: aBuilder)
				frame: (0.50 @ 0.08 corner: 1.00 @ 0.50);
				yourself);
			add: ((self buildErrorListWith: aBuilder)
				frame: (0.50 @ 0.50 corner: 1.00 @ 0.84);
				yourself);
			add: ((self buildControlPanelWith: aBuilder)
				frame: (0.00 @ 0.84 corner: 1.00 @ 1.00);
				yourself);
			yourself);
		closeAction: #close;
		yourself.
	^ aBuilder build: window.! !

!CSTestRunner methodsFor: 'initialize-release' stamp: 'bs 1/14/2010 10:11'!
cleanUp

	self
		disableRunningTestsInBackground;
		tddAutoRunStop.! !

!CSTestRunner methodsFor: 'ui-open/close' stamp: 'bs 1/14/2010 10:15'!
close
	window := nil! !

!CSTestRunner methodsFor: 'accessing' stamp: 'bs 1/4/2010 13:31'!
codeSight
	^ codeSight! !

!CSTestRunner methodsFor: 'accessing' stamp: 'bs 1/4/2010 13:31'!
codeSight: anObject
	codeSight := anObject! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 4/30/2009 12:09'!
debugSuite: aTestSuite
	self basicRunSuite: aTestSuite do: [ :each | self debugTest: each ].! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 1/4/2010 16:07'!
debugTest: aTestCase
	| outerTest | 
	outerTest := self codeSight runningTestMethod.
	self codeSight testMethodGoingToRun: (aTestCase class >> aTestCase selector) unwrappedMethod.
	aTestCase debug.
	self codeSight testMethodGoingToRun: outerTest.! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 1/1/2010 22:40'!
defectTestMethods
	^ self result defectTestMethods! !

!CSTestRunner methodsFor: 'background processing' stamp: 'bs 9/14/2009 16:16'!
disableRunningTestsInBackground
	^ runsTestsInBackground := false! !

!CSTestRunner methodsFor: 'private' stamp: 'bs 1/5/2010 15:30'!
disableTddAutoRunMode
	self isInTddAutoRunMode: false.! !

!CSTestRunner methodsFor: 'background processing' stamp: 'bs 9/14/2009 16:16'!
enableRunningTestsInBackground
	^ runsTestsInBackground := true! !

!CSTestRunner methodsFor: 'private' stamp: 'bs 1/5/2010 15:30'!
enableTddAutoRunMode
	self isInTddAutoRunMode: true.! !

!CSTestRunner methodsFor: 'event handling' stamp: 'bs 1/17/2010 21:55'!
handle: aCsEvent
	self isInTddAutoRunMode 
		ifTrue: [ aCsEvent processOn: self ]! !

!CSTestRunner methodsFor: 'accessing' stamp: 'bs 1/4/2010 15:16'!
instrumentor
	^ self codeSight instrumentor! !

!CSTestRunner methodsFor: 'auto run mode' stamp: 'bs 9/11/2009 14:52'!
isInTddAutoRunMode
	^ isInTddAutoRunMode ifNil: [isInTddAutoRunMode := false].! !

!CSTestRunner methodsFor: 'private' stamp: 'bs 1/3/2010 15:46'!
isInTddAutoRunMode: aBoolean
	isInTddAutoRunMode := aBoolean.
	self changed: #tddAutoRunModeLabel! !

!CSTestRunner methodsFor: 'ui-building' stamp: 'mab 4/2/2009 20:33'!
label
	^ 'CodeSight Test Runner'! !

!CSTestRunner methodsFor: 'event handling' stamp: 'bs 1/15/2010 11:35'!
nonTestMethodRemoved: aTestMethod
	self tddMonitor nonTestMethodRemoved: aTestMethod.! !

!CSTestRunner methodsFor: 'ui-open/close' stamp: 'bs 1/14/2010 10:14'!
open
	window
		ifNil: [ window := ToolBuilder open: self ]
		ifNotNil: [ 
			window comeToFront.
			window isCollapsed ifTrue: [ window expand ] ].
	^ window.! !

!CSTestRunner methodsFor: 'accessing' stamp: 'bs 9/10/2009 13:58'!
resetTestCasesToRun
	^ testCasesToRun := nil.! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 1/1/2010 22:40'!
runFailedTests
	self runTestMethods: self defectTestMethods.! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 3/3/2010 09:02:02.742'!
runSuite: aSuite 
	| runSuiteSynchronized |
	runSuiteSynchronized := [	
		CSTestRunner sourceCodeAccessMonitor critical: [
			self changed: #startTestRun.
			super runSuite: aSuite.
			self updateResultsInHistory.
			self changed: #endTestRun]].

	(self runsTestsInBackground and: [
			ProcessBrowser isUIProcess: Processor activeProcess])
		ifTrue: [ runSuiteSynchronized forkAt: Processor userBackgroundPriority ]
		ifFalse: [ runSuiteSynchronized value ]! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 2/25/2010 10:33:20.757'!
runTest: aTestCase
	| outerTest | 
	outerTest := self codeSight runningTestMethod.
	self codeSight testMethodGoingToRun: (aTestCase class >> aTestCase selector) unwrappedMethod.
	super runTest: aTestCase.
	self codeSight testMethodGoingToRun: outerTest.
	
	self changed: #newTestResult with: result.! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 1/25/2010 16:59:54.329'!
runTestMethods: testMethods
	| aSuite |
	
	testMethods ifNotEmpty: [
		aSuite := TestSuite new.
		aSuite addTests: (testMethods collect: [:ea | ea newTestCase]).
		self runSuite: aSuite ].! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 12/3/2009 22:32'!
runTestsInSuite: testMethods
	| aSuite |
	
	testMethods ifNotEmpty: [
		aSuite := TestSuite new.
		aSuite addTests: (testMethods collect: [:ea | ea newTestCase]).
		self reset; runSuite: aSuite ].! !

!CSTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:11'!
runningTestsInBackgroundLabel
	^ self runsTestsInBackground
		ifTrue: [ 'DisableRunningTestsInBackground' ]
		ifFalse: [ 'EnableRunningTestsInBackground' ]! !

!CSTestRunner methodsFor: 'background processing' stamp: 'bs 9/14/2009 16:17'!
runsTestsInBackground
	^ runsTestsInBackground ifNil: [runsTestsInBackground := false]! !

!CSTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 13:06'!
tddAutoRunModeLabel
	^ self isInTddAutoRunMode 
		ifTrue: [ 'Stop Tdd Auto Run Mode' ]
		ifFalse: [ 'Start Tdd Auto Run Mode' ]! !

!CSTestRunner methodsFor: 'auto run mode' stamp: 'bs 1/14/2010 13:57'!
tddAutoRunStart
	(self isInTddAutoRunMode)
		ifFalse: [
			self enableTddAutoRunMode ]! !

!CSTestRunner methodsFor: 'auto run mode' stamp: 'bs 1/14/2010 13:57'!
tddAutoRunStop
	(self isInTddAutoRunMode)
		ifTrue: [
			self disableTddAutoRunMode ]! !

!CSTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:03'!
tddFlags
	^ #(( #tddAutoRunModeLabel #toggleTddAutoRunMode )
		( #runningTestsInBackgroundLabel #toggleRunningTestsInBackground )).! !

!CSTestRunner methodsFor: 'event handling' stamp: 'bs 1/11/2010 08:37'!
tddMonitor
	^ tddMonitor ifNil: [tddMonitor := CSTddMonitor new]! !

!CSTestRunner methodsFor: 'event handling' stamp: 'bs 12/22/2009 18:36'!
tddMonitor: aTddMonitor
	tddMonitor := aTddMonitor! !

!CSTestRunner methodsFor: 'event handling' stamp: 'bs 1/15/2010 11:27'!
testMethodRemoved: aTestMethod
	self result removeIfPresent: aTestMethod.
	self tddMonitor testMethodRemoved: aTestMethod.! !

!CSTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 12:21'!
toggleRunningTestsInBackground
	self runsTestsInBackground
		ifTrue: [ self disableRunningTestsInBackground. self changed: #runningTestsInBackgroundLabel. ]
		ifFalse: [ self enableRunningTestsInBackground. self changed: #runningTestsInBackgroundLabel. ]! !

!CSTestRunner methodsFor: 'ui-building' stamp: 'bs 9/15/2009 13:07'!
toggleTddAutoRunMode
	self isInTddAutoRunMode 
		ifTrue: [ self tddAutoRunStop. self changed: #tddAutoRunModeLabel. ]
		ifFalse: [ self tddAutoRunStart. self changed: #tddAutoRunModeLabel. ]! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 3/3/2010 09:01:30.036'!
updateResultsInHistory
	(TestResult includesSelector: #updateResultsInHistory) 
		ifTrue: [ self result updateResultsInHistory ].! !

OBTextMorphWithShout subclass: #CSTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!CSTextMorph methodsFor: 'private' stamp: 'bs 12/21/2009 14:39'!
paragraphClass
	^ CSParagraph! !

SwaGeneralScrollBar subclass: #CSActivityScrollBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-View'!

!CSActivityScrollBar methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:55'!
initializeMenuButton
	"Ignore menu button."
	
	menuButton := nil.! !

!OBMethodNode methodsFor: '*codesight' stamp: 'bs 1/14/2010 14:49'!
backgroundColor

	((self csInfo isClassManaged: theClass) not
		or: [selector isTestSelector]
		or: [(theClass includesSelector: selector) not]
		or: [(theClass compiledMethodAt: selector) hasCoveringTestMethods])
			ifTrue: [^ super backgroundColor].
	^ Color lightOrange.! !

!OBMethodNode methodsFor: '*codesight' stamp: 'bs 5/4/2009 21:53'!
compiledMethod
	^ theClass compiledMethodAt: self selector! !

!OBMethodNode methodsFor: '*codesight' stamp: 'bs 1/3/2010 22:42'!
coveringTestMethods

	| testMethodNodes theMethod node createAndAddCoveringNode |
	testMethodNodes := OrderedCollection new.
	(theClass includesSelector: selector) ifTrue: [
		theMethod := self compiledMethod.
		createAndAddCoveringNode := [:testMethod | 
			node := OBCoveringTestCaseNode on: testMethod 
							coveredMethodNode: self.
			testMethodNodes add: node ].
		
		theMethod fixedTestMethods do: createAndAddCoveringNode.
		
		node := OBCoveringTestCaseSeparatorNode coveredMethodNode: self.
		testMethodNodes add: node.
		
		theMethod coveringAndNotFixedTestMethods do: createAndAddCoveringNode ].
	
	^ testMethodNodes.! !

TestCase subclass: #CSBenchmarkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSBenchmarkTest class methodsFor: 'as yet unclassified' stamp: 'bs 10/11/2009 22:12'!
wantsRecompilationProgressReported
	"turn off for this clas because it is modified during tests"

	^ false
! !

!CSBenchmarkTest methodsFor: 'as yet unclassified' stamp: 'bs 10/11/2009 22:12'!
testFirstnameAccessors
	
	| aPerson aName |
	aPerson := CSExamplePerson new.
	aName := 'Bastian'.
	aPerson firstname: aName.
	self assert: aPerson firstname = aName.! !

TestCase subclass: #CSTddMonitorTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSTddMonitorTests methodsFor: 'as yet unclassified' stamp: 'bs 12/22/2009 16:37'!
setUp
	super setUp.
	sut := CSTddMonitor open.! !

!CSTddMonitorTests methodsFor: 'as yet unclassified' stamp: 'bs 12/22/2009 16:37'!
tearDown
	sut delete.
	super tearDown.! !

!CSTddMonitorTests methodsFor: 'as yet unclassified' stamp: 'bs 12/22/2009 18:45'!
testNewBehaviorRespecified
	| testMethod testMethod2 |
	testMethod := CSExampleTest >> #testFailing.
	testMethod2 := CSExampleTest >> #testFirstnameAccessors.
	sut newBehaviorSpecified: testMethod.
	sut newBehaviorSpecified: testMethod2.
	
	CSExampleTest recompile: #testFirstnameAccessors.
	testMethod2 := CSExampleTest >> #testFirstnameAccessors.
	sut newBehaviorSpecified: testMethod2.
	
	self assert: [ sut list activities size == 2 ].
	self assert: [ sut list activities first testMethod = testMethod2 ].! !

!CSTddMonitorTests methodsFor: 'as yet unclassified' stamp: 'bs 12/22/2009 17:03'!
testNewBehaviorSpecified
	| testMethod testMethod2 |
	testMethod := CSExampleTest >> #testFailing.
	testMethod2 := CSExampleTest >> #testFirstnameAccessors.
	sut newBehaviorSpecified: testMethod.
	sut newBehaviorSpecified: testMethod2.
	self assert: [ sut list activities size == 2 ].
	self assert: [ sut list activities first label text asString = testMethod2 qualifiedName ]! !

!CSTddMonitorTests methodsFor: 'as yet unclassified' stamp: 'bs 12/13/2009 20:26'!
testOpenTddMonitor
	| monitorWindow |
	monitorWindow := CSTddMonitor open.
	monitorWindow delete.! !

!CSTddMonitorTests methodsFor: 'as yet unclassified' stamp: 'bs 12/22/2009 17:06'!
testReset
	| testMethod |
	testMethod := CSExampleTest >> #testFailing.
	sut newBehaviorSpecified: testMethod.
	self assert: [ sut list activities size == 1 ].
	sut reset.
	self assert: [ sut list activities size == 0 ].! !

TestCase subclass: #CSTestBase
	instanceVariableNames: 'registeredClasses removedMethods installedMethods createdClasses undoInTearDown registeredPackages unregisteredPackages createdWrappers tddAutoRunTestRunner codeSight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

CSTestBase subclass: #CSAsyncAutoRunTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSAsyncAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 1/11/2010 11:53'!
testRunInBackground

	CSAsyncExampleTest resetCollectedMessages.
	self should: [ CSAsyncExampleTest collectedMessagesAsString = '' ].
	
	self csTestRunner runSuite: CSAsyncExampleTest exampleSuite.
	self should: [ CSAsyncExampleTest collectedMessagesAsString = 'Hello' ].
	
	CSAsyncExampleTest resetCollectedMessages.
	self csTestRunner enableRunningTestsInBackground.
	self csTestRunner runSuite: CSAsyncExampleTest backgroundExampleSuite.
	(Delay forMilliseconds: 200) wait.
	CSTestRunner sourceCodeAccessMonitor critical: [ 
		CSAsyncExampleTest addMessage: 'World'. ].
	self should: [ CSAsyncExampleTest collectedMessagesAsString = 'HelloWorld' ].
	self csTestRunner disableRunningTestsInBackground.! !

!CSAsyncAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 1/8/2010 17:27'!
testRunningExampleSuite
	CSAsyncExampleTest resetCollectedMessages.
	self csTestRunner runSuite: (CSAsyncExampleTest exampleSuite).
	self should: [CSAsyncExampleTest collectedMessagesAsString = 'Hello']. ! !

CSTestBase subclass: #CSAsyncExampleTest
	instanceVariableNames: ''
	classVariableNames: 'CollectedMessages'
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:07'!
addMessage: aString
	self collectedMessages add: aString.! !

!CSAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:43'!
backgroundExampleSuite
	| aSuite |
	aSuite := TestSuite new.
	aSuite addTest: (self selector: #testRunExampleInBackground).
	^ aSuite.! !

!CSAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:02'!
collectedMessages
	^ CollectedMessages ifNil: [CollectedMessages := OrderedCollection new.]! !

!CSAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:05'!
collectedMessagesAsString
	| stream |
	stream := WriteStream with: String new.
	self collectedMessages do: [: elem | stream nextPutAll: elem].
	^ stream contents! !

!CSAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:39'!
exampleSuite
	| aSuite |
	aSuite := TestSuite new.
	aSuite addTest: (self selector: #testExample).
	^ aSuite.! !

!CSAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:03'!
resetCollectedMessages
	CollectedMessages := nil.! !

!CSAsyncExampleTest methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:36'!
testExample
	self class addMessage: 'Hello'! !

!CSAsyncExampleTest methodsFor: 'as yet unclassified' stamp: 'bs 1/8/2010 17:27'!
testRunExampleInBackground
	self csTestRunner enableRunningTestsInBackground.
	self csTestRunner runSuite: (CSAsyncExampleTest exampleSuite).! !

CSTestBase subclass: #CSAutoTddTestBase
	instanceVariableNames: 'exampleMethodSource exampleTestMethodSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSAutoTddTestBase methodsFor: 'accessing' stamp: 'bs 1/8/2010 19:09'!
compileExampleMethod
	CSExamplePerson compile: self exampleMethodSource. ! !

!CSAutoTddTestBase methodsFor: 'accessing' stamp: 'bs 1/10/2010 22:08'!
compileExampleTestMethod
	CSExampleTest compile: self exampleTestMethodSource. ! !

!CSAutoTddTestBase methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 13:40:25.79'!
createSuperCallTestCode
	^ 'testSuperCall', String crlf, String tab, 'CSExamplePersonSubclass new asString'.! !

!CSAutoTddTestBase methodsFor: 'accessing' stamp: 'bs 1/8/2010 18:19'!
exampleMethod
	^ CSExamplePerson >> #firstname:! !

!CSAutoTddTestBase methodsFor: 'accessing' stamp: 'bs 1/8/2010 18:22'!
exampleMethodSource
	^ exampleMethodSource! !

!CSAutoTddTestBase methodsFor: 'accessing' stamp: 'bs 1/8/2010 18:22'!
exampleMethodSource: anObject
	exampleMethodSource := anObject! !

!CSAutoTddTestBase methodsFor: 'accessing' stamp: 'bs 1/8/2010 18:22'!
exampleTestMethod
	^ CSExampleTest >> #testFirstnameAccessors! !

!CSAutoTddTestBase methodsFor: 'accessing' stamp: 'bs 1/8/2010 18:22'!
exampleTestMethodSource
	^ exampleTestMethodSource! !

!CSAutoTddTestBase methodsFor: 'accessing' stamp: 'bs 1/8/2010 18:22'!
exampleTestMethodSource: anObject
	exampleTestMethodSource := anObject! !

!CSAutoTddTestBase methodsFor: 'accessing' stamp: 'bs 1/22/2010 10:48'!
runExampleTests
	self runAndTraceSuite: CSExampleTest suite.! !

!CSAutoTddTestBase methodsFor: 'as yet unclassified' stamp: 'bs 1/8/2010 18:24'!
setUp
	super setUp.
	self csTestRunner 
		tddMonitor: CSTddMonitor new;
		tddAutoRunStart.

	self exampleMethodSource: self exampleMethod getSource.
	self exampleTestMethodSource: self exampleTestMethod getSource.
	
	self undoInTearDownDo: [
		self tracePackage: self codeSightTestExamplesPackage ].! !

!CSAutoTddTestBase methodsFor: 'as yet unclassified' stamp: 'bs 1/8/2010 17:37'!
tearDown
	self csTestRunner 
		tddAutoRunStop;
		disableRunningTestsInBackground.
	
	super tearDown.! !

CSAutoTddTestBase subclass: #CSDistributionRequestTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-DistributionTests'!

!CSDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:42:50.251'!
codeSightClass
	^ CSCodeSightForDistributionRequestTests! !

!CSDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 10:08:35.811'!
testRequestForCoverageMaintenance
	| testMethodsToRun testMethodNames actor coverageData |
	testMethodsToRun := { self exampleTestMethod }.
	testMethodNames := testMethodsToRun collect: [ :m | m qualifiedName ].
	self codeSight activateTracing.
	self codeSight maintainCoverage: testMethodNames.
	
	actor := self codeSight distributionTestsDevelopmentActor.
	self shouldnt: [ actor receivedTestCoverage isEmpty ].
	coverageData := actor receivedTestCoverage at: self exampleTestMethod qualifiedName.
	self should: [ (coverageData at: self exampleMethod qualifiedName) includes: CSExamplePerson name ].
	! !

!CSDistributionRequestTests methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:58:01.772'!
testRequestForTesting
	| testMethodsToRun testMethodNames actor |
	testMethodsToRun := CSExampleTest testMethods.
	testMethodNames := testMethodsToRun collect: [ :m | m qualifiedName ].
	self codeSight runTests: testMethodNames.
	actor := self codeSight distributionTestsDevelopmentActor.
	self shouldnt: [ actor receivedTestResult passed isEmpty ].
	self shouldnt: [ actor receivedTestResult failures isEmpty ].! !

CSAutoTddTestBase subclass: #CSDistributionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-DistributionTests'!

!CSDistributionTests methodsFor: 'as yet unclassified' stamp: 'replica 2/25/2010 08:27:21.659'!
createExampleCoverageData
	| testsToCoverageData coverageData | 
	testsToCoverageData := Dictionary new.
	coverageData := testsToCoverageData 
			at: self exampleTestMethod qualifiedName
			put: Dictionary new.
	coverageData 
		at: (self exampleMethod qualifiedName)
		put: {self exampleMethod methodClass name}.
	
	^ testsToCoverageData.! !

!CSDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 09:22:09.849'!
createExampleTestResult
	| aTestResult |
	aTestResult := CSTestResult new.
	aTestResult addToPassed: (CSExampleTest selector: #testFirstnameAccessors).
	^ aTestResult.! !

!CSDistributionTests methodsFor: 'as yet unclassified' stamp: 'replica 2/24/2010 14:55:18.944'!
ensureCoverageOfExampleCode
	self runAndTraceSuite: CSExampleTest suite. ! !

!CSDistributionTests methodsFor: 'as yet unclassified' stamp: 'replica 2/24/2010 12:42:03.657'!
testNonInstrumentation
	| aSubclass aSelector |
	
	self runAndTraceSuite: CSExampleTest suite.
	self should: [ (CSExamplePerson >> #firstname) isMwMethodWrapper ].
	
	self codeSight turnOffStandaloneMode.
	self shouldnt: [ (CSExamplePerson >> #firstname) isMwMethodWrapper ].
	
	self undoInTearDownDo: [
		aSubclass := self createExamplePersonSubclass.
		aSelector := aSubclass compile: self exampleMethodSource ].
	
	self shouldnt: [ (aSubclass >> aSelector) isMwMethodWrapper ].! !

!CSDistributionTests methodsFor: 'as yet unclassified' stamp: 'replica 2/24/2010 17:53:37.472'!
testOpenEvents
	self ensureCoverageOfExampleCode.
	self codeSight makeDistributed.
	self should: [ self codeSight openEvents isEmpty ].
	
	self compileExampleMethod.
	self shouldnt: [ self codeSight openEvents isEmpty ]! !

!CSDistributionTests methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2010 08:57:10.433'!
testProcessingOfUpdates
	| aTestResult testsToCoverageData |
	self ensureCoverageOfExampleCode.
	self exampleMethod fixes: self exampleTestMethod.
	self codeSight makeDistributed.
	
	aTestResult := self createExampleTestResult.
	testsToCoverageData := self createExampleCoverageData.
	
	self csTestRunner reset.
	self compileExampleMethod.
	self should: [ self csTestRunner result passed isEmpty ].
	self shouldnt: [ self exampleMethod hasCoveringTestMethods ].
	self shouldnt: [ self exampleMethod hasFixedTestMethods ].
	
	self codeSight testResult: aTestResult.	
	self codeSight testCoverage: testsToCoverageData.
	self shouldnt: [ self csTestRunner result passed isEmpty ]. 
	self should: [ self exampleMethod hasCoveringTestMethods ].
	self should: [ self exampleMethod hasFixedTestMethods ].
	
	self csTestRunner reset.
	self compileExampleMethod.
	self codeSight testCoverage: testsToCoverageData.
	self codeSight testResult: aTestResult.
	self should: [ self exampleMethod hasCoveringTestMethods ].
	self should: [ self exampleMethod hasFixedTestMethods ].! !

CSAutoTddTestBase subclass: #CSEvolutionTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

CSEvolutionTestCase subclass: #CSFixedTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSFixedTests methodsFor: 'as yet unclassified' stamp: 'bs 12/9/2009 16:57'!
charIntervalIn: codeString fromLine: from toLine: to
	| start end |
	self assert: [ codeString lineCount >= to and: [ codeString lineCount >= from ] ].
	start := 1.
	(1 to: (from - 1)) do: [:lineNo | 
		start := start + (codeString lineNumber: lineNo) size ].
	
	end := start.
	(to to: codeString lineCount) do: [:lineNo |
		end := end + (codeString lineNumber: lineNo) size ].
	
	^ (start to: end)! !

!CSFixedTests methodsFor: 'as yet unclassified' stamp: 'bs 1/8/2010 19:04'!
testEstablishingFixedRelationship
	
	self undoInTearDownDo: [
		self removeMethod: self exampleMethod ].
	 
	CSExampleTest compile: self exampleTestMethodSource.
	CSExamplePerson compile: self exampleMethodSource. 
	
	self should: [ self exampleMethod hasCoveringTestMethods ].
	self should: [ self exampleMethod hasFixedTestMethods ].
	! !

!CSFixedTests methodsFor: 'as yet unclassified' stamp: 'bs 1/8/2010 19:57'!
testRecompiling

	self runExampleTests.
	self should: [ self exampleMethod hasCoveringTestMethods ].
	self shouldnt: [ self exampleMethod fixedTestMethods includes: self exampleTestMethod ].
	
	(self exampleMethod) fixes: self exampleTestMethod.
	self should: [ self exampleMethod fixedTestMethods includes: self exampleTestMethod ].
	
	self compileExampleMethod.
	self should: [ self exampleMethod hasCoveringTestMethods ]. 
	self should: [ self exampleMethod fixedTestMethods includes: self exampleTestMethod ].! !

!CSFixedTests methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 16:15:38.098'!
testRefactoringVariations
	| code anExamplePerson variationWrapper selectionInterval |
	
	code := (CSExamplePerson sourceCodeAt: #firstname) asString.
	selectionInterval := self charIntervalIn: code fromLine: 2 toLine: 2.
	self assert: [ code lineCount = 2 ].
	
	anExamplePerson := CSExamplePerson new.
	anExamplePerson firstname: 'Paul'.
	self should: [ anExamplePerson firstname = 'Paul' ].
	
	variationWrapper := CSRefactoringVariationWrapper 
							on: #firstname 
							inClass: CSExamplePerson 
							withCode: 'firstname'.
	
	variationWrapper installClosestToMethod.
	self deny: [ anExamplePerson firstname = 'Paul' ].
	
	variationWrapper uninstall.! !

CSEvolutionTestCase subclass: #CSTddMonitoringTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSTddMonitoringTests methodsFor: 'running' stamp: 'bs 1/8/2010 18:48'!
setUp
	super setUp.
	
	self undoInTearDownDo: [
		self removeMethod: self exampleMethod. 
		self removeMethod: self exampleTestMethod ].! !

!CSTddMonitoringTests methodsFor: 'accessing' stamp: 'bs 1/8/2010 17:39'!
tddMonitor
	^ self csTestRunner tddMonitor! !

!CSTddMonitoringTests methodsFor: 'tests' stamp: 'bs 1/4/2010 22:19'!
testDeletionOfTests
	self undoInTearDownDo: [
		self installMethod: 'testFail1 self fail' inClass: CSExampleTest. 
		self installMethod: 'testFail2 self fail' inClass: CSExampleTest. ].
	
	self should: [ self tddMonitor list activities size = 2 ].
	self should: [ (self tddMonitor list activities reject: [ :ea | ea isFinished ]) size = 2 ].
	
	CSExampleTest removeSelector: #testFail1.
	self should: [ self tddMonitor list activities size = 1 ].! !

!CSTddMonitoringTests methodsFor: 'tests' stamp: 'bs 1/15/2010 22:13'!
testRefactoringBehavior
	| activity |
	self 
		compileExampleTestMethod;
		compileExampleMethod;
		should: [ self tddMonitor list activatedActivity isNil ].
		
	self removeMethod: self exampleMethod.
	activity := self tddMonitor list activatedActivity.  
	self should: [ activity notNil ].
	self should: [ activity isRefactoring ].! !

!CSTddMonitoringTests methodsFor: 'tests' stamp: 'bs 1/3/2010 20:43'!
testSpecifyingUnsupportedTest
	| activity |
	CSExampleTest compile: self exampleTestMethodSource.
	activity := self tddMonitor list activatedActivity. 
	self assert: [ activity notNil ].
	self assert: [ activity isNewBehavior and: [ activity testMethod = self exampleTestMethod ]  ].! !

!CSTddMonitoringTests methodsFor: 'tests' stamp: 'bs 1/10/2010 21:58'!
testTestGetsBeingSupported
	| activity |
	CSExampleTest compile: self exampleTestMethodSource.
	activity := self tddMonitor list activatedActivity. 
	self shouldnt: [ activity isFinished ].
	self should: [ activity addedOrModifiedMethods isEmpty ].
	
	CSExamplePerson compile: self exampleMethodSource. 
	self should: [ activity isFinished ].
	self should: [ activity addedOrModifiedMethods includes: self exampleMethod ].! !

!CSTddMonitoringTests methodsFor: 'tests' stamp: 'bs 1/4/2010 10:45'!
testToDos
	
	"was passiert, wenn ich eine methode ndere und dabei ein test wieder rot wird."! !

CSAutoTddTestBase subclass: #CSFailedExpressionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSFailedExpressionTests methodsFor: 'as yet unclassified' stamp: 'bs 12/31/2009 15:41'!
failingTestMethod
	^ CSExampleTest >> #testFailing! !

!CSFailedExpressionTests methodsFor: 'as yet unclassified' stamp: 'bs 1/1/2010 01:30'!
testRecordingOfFailedExpression
	| source class selector |
	class := CSExampleTest. 
	source := 'testRecordingOfFailedExpression', String cr,  'self notExistingMethod'.
	self undoInTearDownDo: [
		selector := self installMethod: source inClass: CSExampleTest ].
	
	self assert: [ (class >> selector) failedExpressionInterval notNil ].
	self assert: [ (class >> selector) failedExpression = 'notExistingMethod' ].
	
	CSExampleTest compile: 'testRecordingOfFailedExpression', String cr.
	self assert: [ (class >> selector) failedExpressionInterval isNil ].! !

CSAutoTddTestBase subclass: #CSFixturesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 11/27/2009 14:28'!
testAdditionOfOverridingMethod
"	| personsubclass selector method superCallTestSelector superCallTestMethod |
	selector := #asString.
	method := (CSExamplePerson >> selector) clientMethod.
	method 
		resetCoveringTestMethods;
		resetFixedTestMethods.
	
	self undoInTearDownDo: [
		personsubclass := self createExamplePersonSubclass.
		self traceClass: personsubclass.
		self traceClass: CSExamplePerson.
		
		superCallTestSelector := self installMethod: self createSuperCallTestCode 
												inClass: CSExampleTest ].
	
	superCallTestMethod := (CSExampleTest >> superCallTestSelector).
	superCallTestMethod called: method receiver: nil.
	method fixes: superCallTestMethod.
	self should: [ method hasFixedTestMethods ].
		
	personsubclass compile: (CSExamplePerson sourceCodeAt: selector).
	self shouldnt: [ testRunner result passed size = 0 ].
	self should: [ (personsubclass >> selector) hasCoveringTestMethods  ].
	self should: [ (personsubclass >> selector) hasFixedTestMethods  ]."! !

!CSFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 11/30/2009 21:44'!
testFixedTestMethods
"	| testMethod appMethod |
	appMethod := (CSExamplePerson >> #firstname) clientMethod.
	testMethod := (CSExampleTest >> #testFirstnameAccessors) clientMethod.
	
	appMethod fixes: testMethod. 
	self should: [ appMethod fixedTestMethods size = 1 ].
	appMethod resetFixedTestMethods.	
	self should: [ appMethod fixedTestMethods size = 0 ]."! !

!CSFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 11/30/2009 21:44'!
testFixesInDoForEachBlock
"	| testMethod appMethod |
	appMethod := (CSExamplePerson >> #firstname) clientMethod.
	testMethod := (CSExampleTest >> #testFirstnameAccessors) clientMethod.
	appMethod resetAllCoverageData.
	testMethod resetAllCoverageData.
	
	testMethod doForEachCoveredMethod: [:blockTestMethod :blockAppMethod |
		blockAppMethod fixes: blockTestMethod ].
	
	testMethod called: appMethod receiver: nil.
	self should: [ appMethod coveringTestMethods size = 1 ].
	self should: [ appMethod fixedTestMethods size = 1 ].
	
	appMethod resetAllCoverageData.
	testMethod resetAllCoverageData."! !

!CSFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 11/30/2009 21:43'!
testRecompiling
"	| testMethod |
	testMethod := (CSExampleTest >> #testFirstnameAccessors) clientMethod.
	
	(CSExamplePerson >> #firstname) fixes: testMethod.
	self should: [ (CSExamplePerson >> #firstname) fixedTestMethods size = 1 ].
	CSExamplePerson compile: (CSExamplePerson sourceCodeAt: #firstname).
	self should: [ (CSExamplePerson >> #firstname) fixedTestMethods size = 1 ]."! !

!CSFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 11/27/2009 14:26'!
testRefactoring
"	| personsubclass selector method superCallTestSelector subMethod |
	selector := #asString.
	method := (CSExamplePerson >> selector) clientMethod.
	method 
		resetCoveringTestMethods;
		resetFixedTestMethods.
	
	self undoInTearDownDo: [
		personsubclass := self createExamplePersonSubclass.
		self traceClass: personsubclass.
		self traceClass: CSExamplePerson.
		
		superCallTestSelector := self installMethod: self createSuperCallTestCode 
												inClass: CSExampleTest ].
	
	testRunner reset.
	personsubclass compile: selector asString.
	self should: [ testRunner result passed size = 1 ].
	
	subMethod := (personsubclass >> selector) clientMethod.
	self should: [ subMethod hasCoveringTestMethods ].
	subMethod fixes: (CSExampleTest >> superCallTestSelector).
	self should: [ subMethod hasFixedTestMethods ].
	
	testRunner reset.
	personsubclass compile: (CSExamplePerson sourceCodeAt: selector).
	self should: [ testRunner result passed size = 1 ].
	self should: [ (CSExamplePerson >> selector) hasCoveringTestMethods ].
	self should: [ (CSExamplePerson >> selector) hasFixedTestMethods ].
	
	testRunner reset.
	personsubclass compile: selector asString.
	self should: [ testRunner result passed size = 1 ].
	self shouldnt: [ (CSExamplePerson >> selector) hasFixedTestMethods ]."! !

!CSFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 11/27/2009 14:27'!
testRemoveOfOverriddenMethod
"	| personsubclass selector method superCallTestSelector |
	selector := #asString.
	method := (CSExamplePerson >> selector) clientMethod.
	method 
		resetCoveringTestMethods;
		resetFixedTestMethods.
	
	self undoInTearDownDo: [
		personsubclass := self createExamplePersonSubclass.
		personsubclass compile: (CSExamplePerson sourceCodeAt: selector).
		self traceClass: personsubclass.
		self traceClass: CSExamplePerson.
		
		superCallTestSelector := self installMethod: self createSuperCallTestCode 
												inClass: CSExampleTest ].
	
	method fixes: (CSExampleTest >> superCallTestSelector).
		
	self undoInTearDownDo: [
		self removeMethod: method inClass: CSExamplePerson].	
	
	self should: [ (personsubclass >> selector) hasFixedTestMethods ]"! !

CSAutoTddTestBase subclass: #CSTddAutoRunTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSTddAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 1/22/2010 11:00'!
createFooBarTestClass
	| aClass |
	aClass := TestCase subclass: #CSFooBarTest
					instanceVariableNames: ''
					classVariableNames: ''
					poolDictionaries: ''
					category: 'CodeSightTestExamples'.
	self undoInTearDown ifTrue: [
		self createdClasses add: aClass].
	^ aClass.! !

!CSTddAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 9/11/2009 23:18'!
createSubclassTestCode
	^ 'testFirstnameAccessorsForPersonAndAllSubclasses
			| aPerson aName |
			CSExamplePerson withAllSubclassesDo: [:aPersonClass | 
			aPerson := aPersonClass new.
			aName := #Bastian asString.
			aPerson firstname: aName.
			self assert: aPerson firstname = aName. ]'! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/8/2010 17:28'!
testAddAndChangeOfNonTestMethodsInTestClasses
	| selector |
	[	selector := #setUp.
		CSExampleTest compile: selector, String crlf.
		self should: [self csTestRunner result passed isEmpty].
		CSExampleTest compile: selector, String crlf.
		CSExampleTest compile: selector, String crlf.
		self should: [self csTestRunner result passed isEmpty]]
	ensure: [
		(CSExampleTest includesSelector: selector) 
			ifTrue: [CSExampleTest removeSelector: selector]].
	! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 3/2/2010 13:51:32.253'!
testAdditionAndRemovalOfOverriddenMethod
	| methodSelector testMethodSelector methodSource personsubclass |
	
	methodSelector := #asString.
	methodSource := (CSExamplePerson >> methodSelector) clientMethod getSource.

	self undoInTearDownDo: [
		personsubclass := self createExamplePersonSubclass.
		personsubclass compile: methodSource.
		testMethodSelector := self installMethod: self createSuperCallTestCode inClass: CSExampleTest ].
	
	self runAndTraceInSuite: (CSExampleTest >> testMethodSelector).
	self shouldnt: [ (CSExamplePerson >> methodSelector) coveringTestMethods isEmpty ].
	self shouldnt: [ (personsubclass >> methodSelector) coveringTestMethods isEmpty ].
		
	self csTestRunner reset.
	self undoInTearDownDo: [
		self removeMethod: (CSExamplePerson >> methodSelector) ].
		
	self should: [ self csTestRunner result passed size = 1 ].
	self shouldnt: [ (personsubclass >> methodSelector) coveringTestMethods isEmpty ].
		
	self csTestRunner reset.
	CSExamplePerson compile: methodSource.
	self should: [ self csTestRunner result passed size = 1].
	self shouldnt: [ (CSExamplePerson >> methodSelector) coveringTestMethods isEmpty ].
	self shouldnt: [ (personsubclass >> methodSelector) coveringTestMethods isEmpty ].! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 3/8/2010 17:37:32.951'!
testAdditionAndRemovalOfSubclassesWithOverridingMethods
	| selector source subclass |
	CSExamplePerson methodsDo: [ :method |
		method 
			resetCoveringTestMethods;
			resetFixedTestMethods ].
	
	selector := #firstname.
	source := CSExamplePerson sourceCodeAt: selector.
	
	self undoInTearDownDo: [
		subclass := self createExamplePersonSubclass.
		self installMethod: self createSubclassTestCode inClass: CSExampleTest ].
	
	self runAndTraceSuite: CSExampleTest suite.
	self should: [ self csTestRunner result passed size = 2 ].
	self should: [ (CSExamplePerson >> #firstname) coveringTestMethods size = 2 ].
	
	self csTestRunner reset.
	subclass compile: source.
	self should: [ self csTestRunner result passed size = 2 ].
	
	self csTestRunner reset.
	subclass removeSelector: selector.
	self should: [ self csTestRunner result passed size = 1 ].
	
	subclass compile: source.
	self csTestRunner reset.
	subclass removeFromSystem.
	self should: [ self csTestRunner result passed size = 1 ].! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/22/2010 11:01'!
testCoverageAdaptationAfterTestClassOrMethodRemoved
	| selector testClass testMethodSelector testMethodSource |
	
	selector := #firstname. 
	testMethodSelector := #testFirstnameAccessors.
	testMethodSource := CSExampleTest sourceCodeAt: testMethodSelector.
	CSExamplePerson methodsDo: [:method | 
		method 
			resetCoveringTestMethods;
			resetFixedTestMethods ].
	
	self undoInTearDownDo: [ 
		testClass := self createFooBarTestClass.
		 ].
	
	testClass compile: testMethodSource.
	
	self should: [self csTestRunner result passed size = 1].
	self should: [(CSExamplePerson >> selector) coveringTestMethods size = 1].
	
	testClass removeSelector: testMethodSelector.
	self should: [(CSExamplePerson >> selector) coveringTestMethods size = 0].
	
	testClass compile: testMethodSource.
	testClass removeFromSystem.
	
	self should: [(CSExamplePerson >> selector) coveringTestMethods size = 0].
	! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/15/2010 17:20'!
testDistinguishingOfTestsHavingEqualHashes
	| failingCode1 failingMethod1 failingCode2 failingMethod2 |

	"test adding"
	self undoInTearDownDo: [
		failingCode1 := 'testFailingTest1 self fail'.
		failingCode2 := 'testFailingTest2 self fail'.
		failingMethod1 := self installMethod: failingCode1 inClass: CSExampleTest.
		failingMethod2 := self installMethod: failingCode2 inClass: CSExampleTest. ].
	
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: CSExampleTest) and: [test selector = failingMethod1 ] ] ].
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: CSExampleTest) and: [test selector = failingMethod2 ] ] ].

	"test modification"
	self installMethod: failingCode1 inClass: CSExampleTest.
	self installMethod: failingCode2 inClass: CSExampleTest.
	
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: CSExampleTest) and: [test selector = failingMethod1 ] ] ].
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: CSExampleTest) and: [test selector = failingMethod2 ] ] ].! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/8/2010 17:30'!
testDontResetResultIfThereIsNothingToRun
	|source|
	self csTestRunner runSuite: CSExampleTest suite.
	self shouldnt: [self csTestRunner result passed = 0].
	
	source := ('fooBar', String crlf).
	self undoInTearDownDo: [
		self installMethod: source inClass: CSExamplePerson.].
	self shouldnt: [self csTestRunner result passed = 0].! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/8/2010 17:30'!
testExecutionOfAddedTestMethod
	| source runTestCase aMethod |
	aMethod := CSExampleTest >> #testFirstnameAccessors.
	source := aMethod getSource.
	
	self undoInTearDownDo: [
		self removeMethod: aMethod ].
	CSExampleTest compile: source.
	
	self should: [self csTestRunner result passed isEmpty not].
	runTestCase := self csTestRunner result passed first.
	self should: [runTestCase isKindOf: CSExampleTest].
	self should: [runTestCase selector = aMethod selector].! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/8/2010 17:30'!
testExecutionOfChangedTestMethod
	| selector runTestCase|
	selector := #testFirstnameAccessors. 
	CSExampleTest compile: (CSExampleTest sourceCodeAt: selector).
	self should: [self csTestRunner result passed isEmpty not].
	runTestCase := self csTestRunner result passed first.
	self should: [runTestCase isKindOf: CSExampleTest].
	self should: [runTestCase selector = selector].! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/22/2010 10:16'!
testExecutionOfCoveringTestsAfterMethodChanged

	self undoInTearDownDo: [
		self registerClass: CSExamplePerson ].
	self runAndTraceSuite: CSExampleTest suite. 
	
	CSExamplePerson compile: (CSExamplePerson sourceCodeAt: #firstname:).
	self should: [self csTestRunner result passed isEmpty not]. 
	self should: [self csTestRunner result passed first isKindOf: CSExampleTest].! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/22/2010 10:17'!
testExecutionOfFailedTestsAfterMethodAddedOrChanged
	| methodSelector appMethodSource method | 
	methodSelector := #firstname.
	appMethodSource := CSExamplePerson sourceCodeAt: methodSelector.
	method := CSExamplePerson >> methodSelector.
	method 
		resetCoveringTestMethods;
		resetFixedTestMethods.
	
	self undoInTearDownDo: [
		self removeMethod: method].
	
	self runAndTraceSuite: CSExampleTest suite.
	self deny: [self csTestRunner result errors isEmpty].
	self should: [self csTestRunner result errors anySatisfy: [:test | 
		(test isKindOf: CSExampleTest) and: [test selector = #testFirstnameAccessors]]].
	
	CSExamplePerson compile: appMethodSource.
	self should: [self csTestRunner result errors isEmpty].
	self deny: [self csTestRunner result passed isEmpty].
	self should: [self csTestRunner result passed first isKindOf: CSExampleTest].! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/8/2010 17:30'!
testExecutionOfFailedTestsAfterTestChanged
	| aSuite failingCode failingMethod2 |
	aSuite := TestSuite new.
	aSuite addTest: (CSExampleTest >> #testFailing) newTestCase.
	self csTestRunner runSuite: aSuite.
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: CSExampleTest) and: [test selector = #testFailing]]].

	self undoInTearDownDo: [
		failingCode := 'testFailing2 self fail'.
		failingMethod2 := self installMethod: failingCode inClass: CSExampleTest ].
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: CSExampleTest) and: [test selector = #testFailing]]].

	CSExampleTest compile: failingCode.
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: CSExampleTest) and: [test selector = #testFailing]]].
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: CSExampleTest) and: [test selector = failingMethod2]]].! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/11/2010 07:41'!
testForEndlessLoopUsingDoForEachCoveredMethod

	"self csTestRunner testCasesToRun add: (CSExampleTest selector: #testFirstnameAccessors).
	self csTestRunner runOpenTestCasesInSuite."
	
	"original version that break a lot of stuff.
	 I assume that using 'self doForEachCoveredMethod' in another doForEach.. Block was not a good idea"
	"CSTestRunner >> #runOpenTestCasesInSuite
	| aSuite testMethod |
	
	aSuite := TestSuite new.
	
	self failedTestCases do: [ :aTestCase |
		aSuite addTest: aTestCase.
		testMethod := aTestCase class >> aTestCase selector.
		testMethod doForEachCoveredMethod: [:aTestMethod :anAppMethod | 
			anAppMethod fixes: aTestMethod.
			self doForEachCoveredMethod valueWithArguments: {aTestMethod. anAppMethod}] ].
	
	
	self testCasesToRun do: [ :aTestCase |
		aSuite addTest: aTestCase.
		testMethod := aTestCase class >> aTestCase selector.
		testMethod doForEachCoveredMethod: [:aTestMethod :anAppMethod | 
			self doForEachCoveredMethod valueWithArguments: {aTestMethod. anAppMethod}]].
	
	self resetTestCasesToRun.
	
	aSuite tests ifNotEmpty: [
		self reset; runSuite: aSuite].
	
	self doForEachCoveredMethod: nil."
	! !

!CSTddAutoRunTests methodsFor: 'test class events' stamp: 'bs 1/22/2010 10:17'!
testModificationOfClass
	| instVarName classVarName |
	instVarName := 'foobar'. 
	classVarName := 'Foobar'.
	[	self instrumentor instrumentClass: CSExamplePerson.
		self runAndTraceSuite: CSExampleTest suite.
		self should: [(CSExamplePerson >> #firstname) hasCoveringTestMethods].

		CSExamplePerson addInstVarName: instVarName.
		self should: [(CSExamplePerson >> #firstname) hasCoveringTestMethods].
		
		CSExamplePerson addClassVarName: classVarName.
		self should: [(CSExamplePerson >> #firstname) hasCoveringTestMethods] ]
	ensure: [
		(CSExamplePerson instVarNames includes: instVarName)
			ifTrue: [CSExamplePerson removeInstVarName: instVarName].
		(CSExamplePerson classVarNames includes: classVarName)
			ifTrue: [CSExamplePerson removeClassVarName: classVarName].
		self instrumentor uninstrumentClass: CSExamplePerson]! !

!CSTddAutoRunTests methodsFor: 'test class events' stamp: 'bs 1/8/2010 17:31'!
testModificationTestOfClass
	|instVarName|
	instVarName := 'foobar'.
	[	self instrumentor instrumentClass: CSExamplePerson.
		CSExampleTest addInstVarName: instVarName.
		self should: [self csTestRunner result passed size = 1].
		self should: [(CSExamplePerson >> #firstname) hasCoveringTestMethods]]
	ensure: [
		(CSExampleTest instVarNames includes: instVarName)
			ifTrue: [CSExampleTest removeInstVarName: instVarName].
		self instrumentor uninstrumentClass: CSExamplePerson]! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/22/2010 11:10'!
testRemovalOfFailedTestCase
	| selector testClass |
	
	self undoInTearDownDo: [
		testClass := self createFooBarTestClass ].
	
	selector := #testFooBar.
	self installMethod:  selector, String crlf, String tab, 'self fail.' inClass: testClass.
	
	self should: [self csTestRunner result failures notEmpty].
	self should: [self csTestRunner result failures anySatisfy: [:test | 
		(test isKindOf: testClass) and: [test selector = selector]]].
	
	testClass removeSelector: selector.
	self should: [self csTestRunner result failures isEmpty].
	self should: [self csTestRunner result errors isEmpty]! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/22/2010 11:14'!
testRemovalOfFailedTestsAfterTestClassOrMethodRemoved
	| testClass fooBarSource testMethodSelector |
	
	self undoInTearDownDo: [
		testClass := self createFooBarTestClass ].
	
	fooBarSource := 'testFooBar', String crlf , String tab , 'self fail'.
		
	testMethodSelector := testClass compile: fooBarSource.
	self should: [ self csTestRunner result failures size = 1 ].
	testClass removeSelector: testMethodSelector.
	self should: [ self csTestRunner result failures isEmpty ].
		
	testMethodSelector := testClass compile: fooBarSource.
	self should: [ self csTestRunner result failures size = 1 ].
	testClass removeFromSystem.
	self should: [ self csTestRunner result failures isEmpty ].! !

!CSTddAutoRunTests methodsFor: 'test class events' stamp: 'bs 1/8/2010 17:31'!
testRemovalOfTestClass
	|testClass testClassName|
	[	testClass := self createFooBarTestClass. 
		testClassName := testClass name.
		testClass compile: 'testFooBar', String crlf, String tab, 'self fail'.
		self should: [self csTestRunner result failures size = 1].
		testClass removeFromSystem.
		self should: [self csTestRunner result failures isEmpty]]
	ensure: [
		(Smalltalk classNamed: testClassName) 
			ifNotNil: [testClass removeFromSystem]]! !

!CSTddAutoRunTests methodsFor: 'test class events' stamp: 'bs 1/22/2010 10:21'!
testRenamingOfClass
	|class oldName|
	[
		self runAndTraceSuite: CSExampleTest suite. 
		self should: [(CSExamplePerson >> #firstname) hasCoveringTestMethods].
		
		class := CSExamplePerson.
		oldName := class name.
		CSExamplePerson rename: (oldName, 'new').
		self should: [(class >> #firstname) hasCoveringTestMethods].]
	ensure: [
		class rename: oldName.
		self instrumentor uninstrumentClass: CSExamplePerson]! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 1/8/2010 17:31'!
testRepro
	| aSuite |
	CSExamplePerson methodsDo: [ :method |
		method 
			resetCoveringTestMethods;
			resetFixedTestMethods ].
	
	
	aSuite := TestSuite new.
	aSuite addTest: (CSExampleTest selector: #testFirstnameAccessors).
	self csTestRunner runSuite: aSuite.
	self should: [ self csTestRunner result passed size = 1 ]! !

CSTestBase subclass: #CSBasicTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSBasicTests methodsFor: 'running' stamp: 'bs 1/23/2010 14:33'!
setUp
	super setUp.
	self codeSight activateTracing.! !

!CSBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 1/22/2010 10:12'!
testConcreteClassCoverage
	| method wrapper |
	method := (CSExamplePerson >> #firstname) unwrappedMethod.
	method resetAllCoverageData.
	self deny: [method hasCoveringTestMethods].
	
	self undoInTearDownDo: [
		wrapper := self createCoverageWrapperOn: #firstname inClass: CSExamplePerson.
		wrapper install.
	].

	self runAndTraceSuite: (CSExampleTest suite).
	
	self assert: [ method hasCoveringTestMethods ].
	self deny: [ (method coveringTestMethodsWhenReceiverWasOfKind: CSExamplePerson) size = 0 ].! !

!CSBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 1/3/2010 17:01'!
testCoverageApi
	| testMethod method |
	method := (CSExamplePerson >> #firstname) clientMethod.
	testMethod := (CSExampleTest >> #testFirstnameAccessors) clientMethod.
	method resetAllCoverageData.
	testMethod resetAllCoverageData.
	testMethod called: method receiver: nil.
	self should: [method hasCoveringTestMethods].
	self should: [method coveringTestMethods size = 1].
	self should: [method fixedTestMethods size = 0].
	self should: [method coveringAndNotFixedTestMethods size = 1].
	self should: [testMethod coveredMethods includes: method].
	self should: [testMethod coveredMethodsStatistics isEmpty not].
	method resetAllCoverageData.
	testMethod resetAllCoverageData.! !

!CSBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 3/8/2010 17:28:53.475'!
testRetrievingTestsForMethod
	| aSuite |
	self undoInTearDownDo: [
		self traceClass: CSExamplePerson].
	aSuite := CSExampleTest suite.
	self runAndTraceSuite: aSuite.
	self assert: ((CSExamplePerson>>#firstname:) coveringTestMethods includes: CSExampleTest >> #testFirstnameAccessors).! !

!CSBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 1/22/2010 10:12'!
testRetrievingTestsForQuickReturnMethod
	| aSuite |
	self undoInTearDownDo: [
		self traceClass: CSExamplePerson].
	aSuite := CSExampleTest suite.
	self runAndTraceSuite: aSuite.
	self assert: ((CSExamplePerson>>#firstname) coveringTestMethods includes: CSExampleTest >> #testFirstnameAccessors).! !

CSTestBase subclass: #CSClassEventTests
	instanceVariableNames: 'unwrappedMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 1/15/2010 15:05'!
handleClassEvent: aClassEvent
	unwrappedMethods := aClassEvent oldItem methodDict values collect: [ :ea | ea unwrappedMethod ]! !

!CSClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 1/11/2010 10:24'!
setUp
	super setUp.
	self undoInTearDownDo: [
		self tracePackage: self codeSightTestExamplesPackage ].! !

!CSClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 1/11/2010 10:18'!
systemNotifier
	^ SystemChangeNotifier uniqueInstance! !

!CSClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 1/14/2010 14:25'!
tearDown
	self systemNotifier noMoreNotificationsFor: self.
	Object subclass: #CSExamplePerson
		instanceVariableNames: 'firstname'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'CodeSightTestExamples'.
	super tearDown.! !

!CSClassEventTests methodsFor: 'as yet unclassified' stamp: 'bs 1/17/2010 14:34'!
testMethodDictAccessOfModifiedClass
	self systemNotifier notify: self ofSystemChangesOfItem: #class  using: #handleClassEvent:.
	Object subclass: #CSExamplePerson
		instanceVariableNames: 'firstname f'
		classVariableNames: 'Foo'
		poolDictionaries: ''
		category: 'CodeSightTestExamples'.
	self shouldnt: [ unwrappedMethods anySatisfy: [ :ea | ea == nil ]  ].! !

CSTestBase subclass: #CSCodeSightTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSCodeSightTests methodsFor: 'as yet unclassified' stamp: 'bs 1/8/2010 17:28'!
testOpenCloseTestRunner
	| aTestRunnerMorph |
	aTestRunnerMorph := self csTestRunner open.
	self should: [ aTestRunnerMorph isKindOf: SystemWindow ].
	aTestRunnerMorph delete.! !

CSTestBase subclass: #CSInstrumentorTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSInstrumentorTests methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 08:09:07.439'!
createWrappingTestClass
	| aClass |
	aClass := Object subclass: #CSFooBarWrapping
					instanceVariableNames: ''
					classVariableNames: ''
					poolDictionaries: ''
					category: 'CodeSightTestExamples'.
	
	self createdClasses add: aClass.
	^ aClass! !

CSInstrumentorTests subclass: #CSWeavingInstrumentorTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSWeavingInstrumentorTests methodsFor: 'running' stamp: 'bs 3/2/2010 08:25:08.006'!
instrumentorClass
	^ CSWeavingInstrumentor! !

!CSWeavingInstrumentorTests methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2010 07:46:23.444'!
methodsOfPackage: aPackageInfo
	^ (aPackageInfo classes flatCollect: [ :c | {c. c class} ]) flatCollect: [ :c | c methodDict values ]! !

!CSWeavingInstrumentorTests methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2010 07:55:04.122'!
nonTestMethodsOfPackage: aPackageInfo
	^ (aPackageInfo classes flatCollect: [ :c | {c. c class} ]) 
			flatCollect: [ :c | c methodDict values reject: [ :m | m isTestMethod ] ]! !

!CSWeavingInstrumentorTests methodsFor: 'as yet unclassified' stamp: 'bs 3/5/2010 11:35:52.32'!
testCompiledMethodAccess
	self tracePackage: self codeSightTestExamplesPackage.
	self should: [ (CSExamplePerson >> #firstname) isInstrumentedMethod ].
	self shouldnt: [(CSExamplePerson >> #firstname) hasCoveringTestMethods] raise: Error.! !

!CSWeavingInstrumentorTests methodsFor: 'as yet unclassified' stamp: 'bs 3/5/2010 11:36:46.732'!
testExtensionCleanUpAfterMethodRemoval
	| orginalIndexSize getCurrentIndexSize aPackage methods instrumentedMethods |
	getCurrentIndexSize := [ CSWeavingInstrumentor orderedMethodExtensions size ].
	orginalIndexSize := getCurrentIndexSize value.
	
	aPackage := self codeSightTestExamplesPackage.
	self registerPackage: aPackage.
	
	instrumentedMethods := self nonTestMethodsOfPackage: aPackage.
	self should: [ instrumentedMethods allSatisfy: [ :m | m isInstrumentedMethod ] ].
	self should: [ getCurrentIndexSize value = (orginalIndexSize + instrumentedMethods size) ].
	
	self unregisterPackage: aPackage.
	methods := self methodsOfPackage: aPackage.
	self should: [ methods allSatisfy: [ :m | m isInstrumentedMethod not ] ].
	self should: [ getCurrentIndexSize value = orginalIndexSize  ].! !

!CSWeavingInstrumentorTests methodsFor: 'as yet unclassified' stamp: 'bs 3/5/2010 11:36:59.906'!
testReinstrumentAfterChangeOfInstrumentedMethod
	
	self tracePackage: self codeSightTestExamplesPackage.
	
	CSExamplePerson compile: (CSExamplePerson sourceCodeAt: #firstname).
	self should: [(CSExamplePerson >> #firstname) isInstrumentedMethod ].! !

CSInstrumentorTests subclass: #CSWrappingInstrumentorTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSWrappingInstrumentorTests methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 08:25:19.432'!
instrumentorClass
	^ CSWrappingInstrumentor! !

!CSWrappingInstrumentorTests methodsFor: 'registration' stamp: 'bs 3/2/2010 13:34:23.492'!
testCompiledMethodAccess
			
	self undoInTearDownDo: [
		self traceClass: CSExamplePerson ].
	
	self should: [ (CSExamplePerson >> #firstname) isMwMethodWrapper ].
	self shouldnt: [(CSExamplePerson >> #firstname) hasCoveringTestMethods] raise: Error.! !

!CSWrappingInstrumentorTests methodsFor: 'registration' stamp: 'bs 3/8/2010 17:50:16.728'!
testDynamicRegistrationAndWrappingOfClassesAndMethods
	|aClass selector|
	
	selector := #firstname.
	self tracePackage: self codeSightTestExamplesPackage.
	aClass := self createWrappingTestClass.
	
	self should: [self instrumentor instrumentedClasses includes: aClass].
	aClass compile: (CSExamplePerson sourceCodeAt: selector).
	self should: [(aClass >> selector) isMwMethodWrapper]. 
	self should: [self instrumentor isMethodInstrumented: selector inClass: aClass].
	aClass removeSelector: selector.
	self shouldnt: [self instrumentor isMethodInstrumented: selector inClass: aClass].
	aClass compile: (CSExamplePerson sourceCodeAt: selector).
	aClass removeFromSystem. 
	self shouldnt: [self instrumentor instrumentedClasses includes: aClass].
	self shouldnt: [ self instrumentor instrumentedMethods includesKey: aClass ]! !

!CSWrappingInstrumentorTests methodsFor: 'registration' stamp: 'bs 3/4/2010 21:48:40.558'!
testReregistrationAfterClassModification
	"note, classes have idendity. modification does only change the same object.
	 registration is handled with classes' identity"
	|instVarName nRegisteredMethods|
	instVarName := 'foobar'. 
	self undoInTearDownDo: [
		self traceClass: CSExamplePerson ].
	
	[	nRegisteredMethods := self instrumentor instrumentedMethods size.
		CSExamplePerson addInstVarName: instVarName.
		self should: [(CSExamplePerson >> #firstname) isKindOf: CSCoverageTracingWrapper ].
		self should: [nRegisteredMethods == self instrumentor instrumentedMethods size]]
	ensure: [
		(CSExamplePerson instVarNames includes: instVarName)
				ifTrue: [CSExamplePerson removeInstVarName: instVarName] ]! !

!CSWrappingInstrumentorTests methodsFor: 'registration' stamp: 'replica 3/1/2010 14:35:25.761'!
testRewrapAfterChangeOfWrappedMethod
 
	self undoInTearDownDo: [
		self tracePackage: self codeSightTestExamplesPackage ].
	
	CSExamplePerson compile: (CSExamplePerson sourceCodeAt: #firstname).
	self should: [(CSExamplePerson >> #firstname) isMwMethodWrapper].! !

!CSWrappingInstrumentorTests methodsFor: 'registration' stamp: 'bs 3/8/2010 17:27:40.442'!
testUninstall
	self instrumentor instrumentMethod: #firstname inClass: CSExamplePerson.
	self should: [self instrumentor isMethodInstrumented: #firstname inClass: CSExamplePerson].
	self instrumentor uninstrumentMethod: (CSExamplePerson >> #firstname).
	self shouldnt: [self instrumentor isMethodInstrumented: #firstname inClass: CSExamplePerson].
	self deny: [(CSExamplePerson >> #firstname) isMwMethodWrapper].! !

!CSWrappingInstrumentorTests methodsFor: 'registration' stamp: 'replica 3/1/2010 14:26:59.17'!
testUnregisterAllAndReset
	| packages classes methods |
	packages := self instrumentor instrumentedPackages copy.
	classes := self instrumentor instrumentedClasses copy.
	methods := self instrumentor instrumentedMethods copy.
	
	self instrumentor instrumentClass: CSExamplePerson.
	self instrumentor uninstrumentAllAndReset.
	self assert: [self instrumentor instrumentedPackages size = 0].
	self assert: [self instrumentor instrumentedClasses size = 0].
	self assert: [self instrumentor instrumentedMethods keys size = 0].
	self assert: [(CSExamplePerson >> #firstname) isMwMethodWrapper not].
	
	packages do: [:ea | self instrumentor instrumentPackage: ea].
	classes do: [:ea | self instrumentor instrumentClass: ea].
	methods keysAndValuesDo: [ :aClass :selectors | 
		selectors do: [:s | self instrumentor instrumentMethod: s inClass: aClass] ].! !

!CSWrappingInstrumentorTests methodsFor: 'registration' stamp: 'bs 1/4/2010 11:48'!
testUnregisterPackage
	| aPackage |
	aPackage := self codeSightTestExamplesPackage.
	(self instrumentor instrumentedPackages includes: aPackage)
		ifTrue: [self unregisteredPackages add: aPackage]
		ifFalse: [self registeredPackages add: aPackage].
	
	
	self instrumentor instrumentPackage: aPackage.
	self should: [(CSExamplePerson >> #firstname) isMwMethodWrapper].
	self instrumentor uninstrumentPackage: aPackage.
	self shouldnt: [(CSExamplePerson >> #firstname) isMwMethodWrapper].
	! !

!CSWrappingInstrumentorTests methodsFor: 'registration' stamp: 'bs 1/4/2010 11:48'!
testWrapperInstallation
	| aPackage |
	aPackage := self codeSightTestExamplesPackage.
	(self instrumentor instrumentedPackages includes: aPackage)
		ifTrue: [self unregisteredPackages add: aPackage]
		ifFalse: [self registeredPackages add: aPackage].
	
	self instrumentor instrumentPackage: aPackage.
	self should: [(CSExamplePerson >> #firstname) isMwMethodWrapper].
	self shouldnt: [(CSExampleTest >> #testFirstnameAccessors) isMwMethodWrapper].
	
	self instrumentor uninstrumentPackage: aPackage.
	self shouldnt: [(CSExamplePerson >> #firstname) isMwMethodWrapper].
	
	self instrumentor instrumentPackage: aPackage.
	self instrumentor instrumentPackage: aPackage.
	self instrumentor uninstrumentPackage: aPackage.
	self shouldnt: [(CSExamplePerson >> #firstname) isMwMethodWrapper].! !

!CSTestBase methodsFor: 'accessing' stamp: 'bs 1/4/2010 11:42'!
codeSight
	^ codeSight! !

!CSTestBase methodsFor: 'accessing' stamp: 'bs 1/4/2010 11:42'!
codeSight: anObject
	codeSight := anObject! !

!CSTestBase methodsFor: 'running' stamp: 'bs 2/25/2010 09:08:05.732'!
codeSightClass
	^ CSCodeSight! !

!CSTestBase methodsFor: 'accessing' stamp: 'bs 1/15/2010 14:37'!
codeSightTestExamplesClasses
	^ self codeSightTestExamplesPackage classes gather: [ :ea | { ea. ea class }]! !

!CSTestBase methodsFor: 'accessing' stamp: 'bs 1/4/2010 22:17'!
codeSightTestExamplesPackage
	
	^ PackageInfo named: 'CodeSightTestExamples'.! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 13:36:31.951'!
createCoverageWrapperOn: aSymbol inClass: aClass
	| wrapper method extension |
	method := aClass >> aSymbol.
	extension := CSNonTestMethodExtension new.
	extension codeSight: self codeSight.
	extension clientMethod: method.
	method methodExtension: extension.
	
	wrapper := CSCoverageTracingWrapper on: #firstname inClass: CSExamplePerson.
	self undoInTearDown ifTrue: [
		self createdWrappers add: wrapper].
	^ wrapper.! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 1/23/2010 00:16'!
createExamplePersonSubclass
	| aClass |
	aClass := CSExamplePerson subclass: #CSExamplePersonSubclass
							instanceVariableNames: ''
							classVariableNames: ''
							poolDictionaries: ''
							category: 'CodeSightTestExamples'.
	self undoInTearDown ifTrue: [
		self createdClasses add: aClass].
	^ aClass! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 12/22/2009 14:15'!
createWrapper: aWrapperClass on: aSelector inClass: aClass
	| result |
	result := aWrapperClass on: aSelector inClass: aClass.
	self undoInTearDown ifTrue: [
		self createdWrappers add: result].
	^ result! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'test 9/18/2009 17:17'!
createdClasses
	^ createdClasses ifNil: [createdClasses := OrderedCollection new]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 12/22/2009 14:13'!
createdWrappers
	^ createdWrappers ifNil: [createdWrappers := OrderedCollection new]! !

!CSTestBase methodsFor: 'accessing' stamp: 'bs 1/13/2010 08:55'!
csTestRunner
	^ self codeSight csTestRunner! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'test 9/21/2009 08:40'!
installMethod: source inClass: aClass
	|selector|
	selector := aClass compile: source.
	self undoInTearDown ifTrue: [
		self installedMethods add: {aClass. selector}].
	^ selector! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 9/17/2009 20:56'!
installedMethods
	^ installedMethods ifNil: [installedMethods := OrderedCollection new]! !

!CSTestBase methodsFor: 'accessing' stamp: 'bs 1/4/2010 15:40'!
instrumentor
	^ self codeSight instrumentor! !

!CSTestBase methodsFor: 'running' stamp: 'bs 3/2/2010 08:28:29.905'!
instrumentorClass
	^ CSWrappingInstrumentor! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 1/4/2010 12:00'!
registerClass: aClass
	(self instrumentor instrumentedClasses includes: aClass)
		ifFalse: [
			self instrumentor instrumentClass: aClass.
			self undoInTearDown ifTrue: [
				self registeredClasses add: aClass ] ].! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'replica 3/1/2010 13:40:38.561'!
registerPackage: aPackageInfo
	self codeSight addToManagedPackages: aPackageInfo.! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'test 9/17/2009 21:51'!
registeredClasses
	^ registeredClasses ifNil: [registeredClasses := OrderedCollection new]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 11:02'!
registeredPackages
	^ registeredPackages ifNil: [registeredPackages := OrderedCollection new]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'test 9/17/2009 21:58'!
reinstallRemovedMethods
	|aClass selector sourceCode |
	self removedMethods do: [ :classSelectorSourceCodeTuple | 
		aClass := classSelectorSourceCodeTuple first.
		selector := classSelectorSourceCodeTuple second.
		sourceCode := classSelectorSourceCodeTuple third.
		(aClass includesSelector: selector)
			ifFalse: [ aClass compile: sourceCode ] ]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 11:11'!
removeCreatedClasses
	self createdClasses copy do: [ :aClass | 
		aClass removeFromSystem.
		(Smalltalk classNamed: aClass name) 
			ifNotNil: [aClass removeFromSystem].
		self createdClasses remove: aClass. ]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 9/17/2009 20:59'!
removeInstalledMethods
	| aClass selector |
	self installedMethods do: [:classSelectorTuple |
		aClass := classSelectorTuple first.
		selector := classSelectorTuple second.
		(aClass includesSelector: selector) 
			ifTrue: [ aClass removeSelector: selector ] ]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 12/21/2009 18:53'!
removeMethod: aCompiledMethod
	|selector sourceCode aClass|
	aClass := aCompiledMethod methodClass.
	selector := aCompiledMethod selector.
	sourceCode := aClass sourceCodeAt: selector.
	self removedMethods add: {aClass. selector. sourceCode}.
	aClass removeSelector: selector. ! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 9/17/2009 20:28'!
removedMethods
	^ removedMethods ifNil: [removedMethods := OrderedCollection new]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 1/4/2010 12:01'!
reregisterPackages
	self unregisteredPackages copy do: [:aPackageInfo |
		self instrumentor instrumentPackage: aPackageInfo.
		self unregisteredPackages remove: aPackageInfo ].! !

!CSTestBase methodsFor: 'running' stamp: 'bs 1/15/2010 14:37'!
resetCodeSightDataInTestExamplesPackage
	self codeSightTestExamplesClasses
			do: [ :aClass | aClass methodDict values do: [ :method | method resetAllCoverageData ] ].! !

!CSTestBase methodsFor: 'running' stamp: 'bs 3/2/2010 09:32:31.905'!
runAndTraceInSuite: aTestMethod
	| aSuite |
	aSuite := TestSuite new.
	aSuite addTest: aTestMethod newTestCase.
	self runAndTraceSuite: aSuite.! !

!CSTestBase methodsFor: 'running' stamp: 'bs 1/22/2010 10:24'!
runAndTraceSuite: aSuite
	self codeSight activateTracing.
	self csTestRunner reset; runSuite: aSuite.
	self codeSight deactivateTracing.! !

!CSTestBase methodsFor: 'running' stamp: 'bs 3/2/2010 08:34:16.164'!
setUp
	super setUp.
	self resetCodeSightDataInTestExamplesPackage.
	self codeSight: self codeSightClass new.
	
	self codeSight instrumentor: self instrumentorClass new.
	self codeSight instrumentor codeSight: self codeSight.
	
	tddAutoRunTestRunner := CSTestRunner 
		allSubInstances select: [:runner | runner isInTddAutoRunMode].
	tddAutoRunTestRunner do: [:runner | runner tddAutoRunStop].
! !

!CSTestBase methodsFor: 'running' stamp: 'bs 1/5/2010 14:42'!
tearDown
	self
		uninstallCreatedWrappers;
		unregisterClasses;
		unregisterPackages;
		reregisterPackages;
		removeCreatedClasses;
		reinstallRemovedMethods;
		removeInstalledMethods.

	self codeSight cleanUp.
	self codeSight: nil.
	self resetCodeSightDataInTestExamplesPackage.
		
	tddAutoRunTestRunner do: [:runner | runner tddAutoRunStart].
	
	super tearDown.! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'replica 3/1/2010 14:34:19.621'!
traceClass: aClass
	(self instrumentor instrumentedClasses includes: aClass)
		ifFalse: [ self registerClass: aClass ]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'replica 2/24/2010 12:32:03.746'!
tracePackage: aPackageInfo
	(self codeSight managedPackages includes: aPackageInfo)
		ifFalse: [ self registerPackage: aPackageInfo ]! !

!CSTestBase methodsFor: 'accessing' stamp: 'test 9/21/2009 08:37'!
undoInTearDown
	^ undoInTearDown ifNil: [undoInTearDown := false]! !

!CSTestBase methodsFor: 'accessing' stamp: 'test 9/21/2009 08:36'!
undoInTearDown: anObject
	undoInTearDown := anObject! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'test 9/21/2009 08:37'!
undoInTearDownDo: aBlock
	self undoInTearDown: true.
	aBlock value.
	self undoInTearDown: false.! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 12/22/2009 14:15'!
uninstallCreatedWrappers
	self createdWrappers do: [ :wrapper | wrapper uninstall ].! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 1/4/2010 12:01'!
unregisterClasses
	self registeredClasses do: [:aClass |
		self instrumentor uninstrumentClass: aClass ].! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2010 07:49:28.968'!
unregisterPackage: aPackageInfo
	self codeSight removeFromManagedPackages: aPackageInfo. ! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'replica 3/1/2010 13:41:00.643'!
unregisterPackages
	self codeSight managedPackages copy do: [:aPackageInfo |
		self codeSight removeFromManagedPackages: aPackageInfo ]. ! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 11:20'!
unregisteredPackages
	^ unregisteredPackages ifNil: [unregisteredPackages := OrderedCollection new]! !

CSTestBase subclass: #CSWrapperExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSWrapperExtensionTests methodsFor: 'as yet unclassified' stamp: 'replica 3/1/2010 14:25:47.812'!
testConflictDetection
	| wrapperOne wrapperTwo aClass aSelector |
	aClass := CSExamplePerson.
	aSelector := #firstname:.
	
	self undoInTearDownDo: [
		wrapperOne := self createWrapper: MwCalledMethodWrapper on: aSelector inClass: aClass.
		wrapperTwo := self createWrapper: MwCountMethodWrapper on: aSelector inClass: aClass.
		].
	
	wrapperOne installClosestToMethod.
	self should: [ wrapperTwo installClosestToMethod ] raise: AssertionFailure.
	
	wrapperTwo uninstall.
	wrapperOne uninstall.! !

!CSWrapperExtensionTests methodsFor: 'as yet unclassified' stamp: 'replica 3/1/2010 14:25:36.825'!
testInstallClosestToMethod
	| current wrapperOne wrapperTwo aClass aSelector |
	aClass := CSExamplePerson.
	aSelector := #firstname:.
	current := aClass compiledMethodAt: aSelector.
	
	self undoInTearDownDo: [
		wrapperOne := self createWrapper: MwCalledMethodWrapper on: aSelector inClass: aClass.
		wrapperTwo := self createWrapper: MwCountMethodWrapper on: aSelector inClass: aClass.
		].
	
	wrapperOne install.
	wrapperTwo installClosestToMethod.
	
	self deny: [ wrapperTwo clientMethod isMwMethodWrapper ].
	
	current isMwMethodWrapper
		ifTrue: [ 
			self assert: [ current clientMethod == wrapperTwo ].
			self assert: [ wrapperOne clientMethod == current ] ]
		ifFalse: [
			self assert: [ wrapperTwo clientMethod == current ].
			self assert: [ wrapperOne clientMethod == wrapperTwo ] ].
	
	wrapperTwo uninstall.
	wrapperOne uninstall.! !

TestCase subclass: #CSTestResultCopyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-DistributionTests'!

!CSTestResultCopyTest methodsFor: 'as yet unclassified' stamp: 'bs 2/20/2010 21:22:47.834'!
testCopy
	| sut aTest theCopy |
	sut := TestResult new.
	aTest := CSExampleTest selector: #testFailing.
	aTest fooBar: 'Hello'.
	self should: [ aTest fooBar = 'Hello' ].
	(sut instVarNamed: 'passed') add: aTest.
	
	theCopy := sut copy.
	self should: [ theCopy passed size = 1 ].
	self should: [ theCopy passed asArray first fooBar = nil ].! !

!TestCase methodsFor: '*CodeSight' stamp: 'bs 12/21/2009 17:45'!
currentTestCaseMethod
	^ self class >> self selector! !

!TestCase methodsFor: '*CodeSight' stamp: 'bs 12/21/2009 17:45'!
recordRunFailedWith: anException
	self currentTestCaseMethod testFailedWith: anException.
	
	! !

!TestCase methodsFor: '*CodeSight' stamp: 'bs 12/21/2009 17:46'!
recordRunWasSuccessful
	self currentTestCaseMethod testWasSuccessful! !

Actor subclass: #CSActor
	instanceVariableNames: 'codeSight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Distribution'!

!CSActor methodsFor: 'accessing' stamp: 'replica 2/24/2010 21:11:53.096'!
codeSight
	^ codeSight! !

!CSActor methodsFor: 'accessing' stamp: 'replica 2/24/2010 21:11:53.097'!
codeSight: anObject
	codeSight := anObject! !

!CSActor methodsFor: 'as yet unclassified' stamp: 'replica 2/24/2010 21:20:59.344'!
recipient
	^ self codeSight! !

!Symbol methodsFor: '*CodeSight' stamp: 'bs 9/10/2009 08:54'!
isTestSelector
	^ (self last ~= $:) and: ['test*' match: self]! !

!BreakpointManager class methodsFor: '*codesight' stamp: 'bs 4/16/2009 10:27'!
compileWithSelfRemovingBreakpoint: aSymbol in: aClass 
	"Compile and return a new method containing a break statement"

	| source node method |
	source := self sourceWithSelfRemovingBreakpointFor: aSymbol in: aClass.
	node := aClass compilerClass new
		compile: source
		in: aClass 
		notifying: nil 
		ifFail: [self error: '[breakpoint] unable to install breakpoint'].
	node isNil ifTrue: [^nil].
	"dunno what the arguments mean..."
	method := node generate.
	^method! !

!BreakpointManager class methodsFor: '*codesight' stamp: 'bs 4/16/2009 10:26'!
installSelfRemovingBreakpointInClass: aClass selector: aSymbol 
	"Install a new method containing a breakpoint.
	The receiver will remember this for unstalling it later"

	| breakMethod |
	breakMethod _ self compileWithSelfRemovingBreakpoint: aSymbol in: aClass.
	breakMethod isNil
		ifTrue: [^ nil].
	self installed at: breakMethod put: aClass >> aSymbol. "old method"
	aClass basicAddSelector: aSymbol withMethod: breakMethod.! !

!BreakpointManager class methodsFor: '*codesight' stamp: 'bs 4/16/2009 10:28'!
sourceWithSelfRemovingBreakpointFor: aSymbol in: aClass 
	"Compose new source containing a break statement (currently it will be the first,
	later we want to insert it in any place)"

	| oldSource methodNode breakOnlyMethodNode sendBreakMessageNode |
	oldSource := aClass sourceCodeAt: aSymbol.
	methodNode := aClass compilerClass new
		compile: oldSource
		in: aClass 
		notifying: nil 
		ifFail: [self error: '[breakpoint] unable to install breakpoint'].
	breakOnlyMethodNode := aClass compilerClass new
		compile: 'temporaryMethodSelectorForBreakpoint
self debugAndUninstallBreakpointBefore.
^self'
		in: aClass 
		notifying: nil 
		ifFail: [self error: '[breakpoint] unable to install breakpoint'].
	sendBreakMessageNode := breakOnlyMethodNode block statements first.
	methodNode block statements addFirst: sendBreakMessageNode.
	^methodNode printString
	! !

!BreakpointManager class methodsFor: '*codesight' stamp: 'bs 4/15/2009 23:08'!
unInstallInClass: aClass selector: aSymbol
	self unInstall: (aClass compiledMethodAt: aSymbol)! !

SwaGeneralScrollPane subclass: #CSActivityScroller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-View'!

!CSActivityScroller methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:46'!
hScrollbarNeeded
	"Never show the horizontal scrollbar."
	
	^ false! !

!CSActivityScroller methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 21:15'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		scrollTarget: CSActivityMorphList new.
		
	self scrollTarget addDependent: self.! !

!CSActivityScroller methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:56'!
newVScrollbar
	"Answer a new vertical scrollbar."

	^CSActivityScrollBar new
		model: self;
		setValueSelector: #vScrollbarValue:! !

!CSActivityScroller methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 21:14'!
update: aSymbol

	aSymbol = #resized
		ifTrue: [self updateScrollbars]! !

!CSActivityScroller methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:46'!
vScrollbarNeeded
	"Always show the vertical scrollbar."

	^ true! !

!AbstractEvent methodsFor: '*codesight' stamp: 'bs 1/5/2010 16:00'!
csEventHandlerSelector
	^ (self itemKind, self changeKind, ':') asSymbol.! !

CompiledMethod variableByteSubclass: #CSInstrumentedMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracing'!

!CSInstrumentedMethod class methodsFor: 'tracing activation' stamp: 'bs 3/4/2010 22:16:13.241'!
activateBefore: methodIndex inClass: aClass
	| aMethodExtension |
	aMethodExtension := CSWeavingInstrumentor methodExtensionAtIndex: methodIndex.
	aMethodExtension codeSight activateTracing.! !

!CSInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 3/4/2010 22:16:13.264'!
activationOn: aSelectorSymbol inClass: aClass
	| originalMethod decompiledMethodNode methodNode aroundCodeNode wrappedStatements statementToAdd instrumentedMethod originalStatements |
	
	originalMethod := aClass >> aSelectorSymbol.
	decompiledMethodNode := originalMethod decompile.
	decompiledMethodNode instVarNamed: 'properties' put: nil.
	methodNode := Parser new parse: decompiledMethodNode asString class: aClass.
	
	aroundCodeNode := self createActivationAroundCodeFor: originalMethod.
	wrappedStatements := aroundCodeNode "return" expr "ensure" receiver "block" statements. 
	
	originalStatements := methodNode body statements copy.
	methodNode body statements removeAll: originalStatements.
	
	originalStatements do: [  :st | 
		statementToAdd := (st isKindOf: ReturnNode) ifTrue: [ st expr ] ifFalse: [ st ] .
		wrappedStatements add: statementToAdd ].
	
	methodNode body statements addFirst: aroundCodeNode.
	
	instrumentedMethod := methodNode generateUsing: self.
	instrumentedMethod originalMethod: originalMethod.
		
	^ instrumentedMethod! !

!CSInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 3/5/2010 08:29:59.641'!
createActivationAroundCodeFor: aCompiledMethod
	| extIndex aroundCode aroundCodeMethodNode |
	extIndex := CSWeavingInstrumentor indexForMethodExtension: aCompiledMethod methodExtension.
	
	aroundCode := 
		'^ [',
			'(' , CSWeavingInstrumentor asString , ' methodExtensionAtIndex: ' , extIndex asString , ')' ,
			'     codeSight activateTracing.',
		'] ensure: [',
			'(' , CSWeavingInstrumentor asString , ' methodExtensionAtIndex: ' , extIndex asString , ')' ,
			'     codeSight deactivateTracing.',
		']'.
	
	aroundCodeMethodNode := Parser new parse: 'foo ', aroundCode class: Object.
	^ aroundCodeMethodNode body statements first! !

!CSInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 3/5/2010 11:39:50.164'!
createTraceCallFor: aCompiledMethod
	| extIndex traceCallString tmpMethodNode |
	extIndex := CSWeavingInstrumentor indexForMethodExtension: aCompiledMethod methodExtension.
	
	traceCallString := 
		'(' , CSWeavingInstrumentor asString , ' methodExtensionAtIndex: ' , extIndex asString , ')' ,
		'     calledByRunningTestWithReceiver: self'.

	tmpMethodNode := Parser new parse: 'foo ' , traceCallString class: Object.
	^ tmpMethodNode body statements first! !

!CSInstrumentedMethod class methodsFor: 'tracing activation' stamp: 'bs 3/4/2010 22:16:13.253'!
deactivateAfter: methodIndex inClass: aClass
	| aMethodExtension |
	aMethodExtension := CSWeavingInstrumentor methodExtensionAtIndex: methodIndex.
	aMethodExtension codeSight deactivateTracing.! !

!CSInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 3/5/2010 11:42:57.148'!
on: aSelectorSymbol inClass: aClass
	| originalMethod methodNode traceCallNode instrumentedMethod |
	
	originalMethod := aClass >> aSelectorSymbol.
	methodNode := self parseSource: originalMethod.
	
	traceCallNode := self createTraceCallFor: originalMethod.
	methodNode body statements addFirst: traceCallNode.
	
	instrumentedMethod := methodNode generateUsing: self.
	instrumentedMethod originalMethod: originalMethod.
		
	^ instrumentedMethod! !

!CSInstrumentedMethod class methodsFor: 'instance creation' stamp: 'bs 3/4/2010 22:16:13.325'!
parseSource: aCompiledMethod
	| source |
	source := aCompiledMethod getSource.
	^ Parser new parse: source class: aCompiledMethod methodClass.
	! !

!CSInstrumentedMethod class methodsFor: 'tracing' stamp: 'bs 3/4/2010 22:16:13.337'!
traceCallTo: extensionIndex inClass: aClass withReceiver: anObject 
	(CSWeavingInstrumentor methodExtensionAtIndex: extensionIndex) calledByRunningTestWithReceiver: anObject! !

!CSInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.15'!
clientMethod
	^ self originalMethod! !

!CSInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.162'!
compiledMethod
	^ self originalMethod! !

!CSInstrumentedMethod methodsFor: 'install-uninstall' stamp: 'bs 3/4/2010 22:16:13.218'!
install
	self methodClass addSelectorSilently: self selector withMethod: self.! !

!CSInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.173'!
methodExtension
	^ self originalMethod methodExtension! !

!CSInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.184'!
methodExtension: anObject
	^ self originalMethod methodExtension: anObject! !

!CSInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.195'!
originalMethod
	^ self properties at: #codeSightOriginalMethod ifAbsent: [ nil ]! !

!CSInstrumentedMethod methodsFor: 'accessing' stamp: 'bs 3/4/2010 22:16:13.207'!
originalMethod: aCompiledMethod
	self properties at: #codeSightOriginalMethod put: aCompiledMethod! !

!CSInstrumentedMethod methodsFor: 'install-uninstall' stamp: 'bs 3/4/2010 22:16:13.229'!
uninstall
	(self methodClass includesSelector: self selector)
		ifTrue: [
			 self methodClass 
				addSelectorSilently: self selector 
				withMethod: self originalMethod. ]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 21:56'!
called: aCompiledMethod
	self methodExtension called: aCompiledMethod! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 21:56'!
called: aCompiledMethod receiver: anObject 
	self methodExtension called: aCompiledMethod receiver: anObject ! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'replica 2/24/2010 20:53:47.254'!
called: aCompiledMethod receiverClasses: classes 
	self methodExtension called: aCompiledMethod receiverClasses: classes ! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:24'!
coveredMethods
	^ self methodExtension coveredMethods! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:25'!
coveredMethodsStatistics
	^ self methodExtension coveredMethodsStatistics! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:25'!
coveringAndNotFixedTestMethods
	^ self methodExtension coveringAndNotFixedTestMethods! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:25'!
coveringTestMethods
	^ self methodExtension coveringTestMethods! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:26'!
coveringTestMethodsWhenReceiverWasOfKind: aClass 
	^ self methodExtension coveringTestMethodsWhenReceiverWasOfKind: aClass ! !

!CompiledMethod methodsFor: '*CodeSight-FailedExpression' stamp: 'bs 12/31/2009 16:27'!
failedExpression
	| interval |
	interval := self failedExpressionInterval.
	^ self getSource asString copyFrom: interval first to: interval last.! !

!CompiledMethod methodsFor: '*CodeSight-FailedExpression' stamp: 'bs 12/31/2009 16:06'!
failedExpressionInterval
	^ self properties at: #codeSightFailedExpression ifAbsent: [ nil ]! !

!CompiledMethod methodsFor: '*CodeSight-FailedExpression' stamp: 'bs 12/31/2009 16:19'!
failedExpressionInterval: aSelectionInterval
	self properties at: #codeSightFailedExpression put: aSelectionInterval.! !

!CompiledMethod methodsFor: '*CodeSight-FailedExpression' stamp: 'bs 12/22/2009 18:24'!
findTestMethodInStack: anException
	^ anException signalerContext contextStack 
		detect: [:aMethodContext | aMethodContext method = self]
		ifNone: [nil]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:26'!
fixedTestMethods
	^ self methodExtension fixedTestMethods! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:26'!
fixes: aCompiledTestMethod 
	^ self methodExtension fixes: aCompiledTestMethod ! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:26'!
fixesAll: compiledTestMethods
	^ self methodExtension fixesAll: compiledTestMethods! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:27'!
hasCoveringTestMethods
	^ self methodExtension hasCoveringTestMethods! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:27'!
hasFixedTestMethods
	^ self methodExtension hasFixedTestMethods! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/17/2010 15:41'!
hasManagedMethodExtension
	| extension | 
	extension := self properties at: #codeSightMethodExtension ifAbsent: [ nil ].
	^ extension notNil and: [ (extension isKindOf: CSUnmanagedNonTestMethodExtension) not ]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/17/2010 15:28'!
hasMethodExtension
	^ self properties includesKey: #codeSightMethodExtension! !

!CompiledMethod methodsFor: '*CodeSight-FailedExpression' stamp: 'bs 12/21/2009 15:58'!
hasTestFailed
	^ self properties includesKey: #codeSightFailedExpression
	! !

!CompiledMethod methodsFor: '*CodeSight-Instrumentation' stamp: 'bs 3/5/2010 10:23:38.358'!
installSilently
	self methodClass addSelectorSilently: self selector withMethod: self.! !

!CompiledMethod methodsFor: '*CodeSight-Instrumentation' stamp: 'bs 3/5/2010 10:29:50.568'!
isInstrumentedMethod
	^ self uninstrumentedMethod notNil! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 11/27/2009 10:41'!
isTestMethod
	^ (self methodClass inheritsFrom: TestCase) and: [self selector isTestSelector]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/17/2010 14:48'!
methodExtension
	| extension extensionClass |
	^ (self properties at: #codeSightMethodExtension ifAbsent: [ nil ])
		ifNil: [
			extensionClass := self isTestMethod 
				ifTrue: [ CSTestMethodExtension ] 
				ifFalse: [ CSUnmanagedNonTestMethodExtension ].
			extension := extensionClass new clientMethod: self; yourself.
			self properties at: #codeSightMethodExtension put: extension. ] ! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 21:48'!
methodExtension: anObject
	^ self properties at: #codeSightMethodExtension put: anObject.! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:07'!
newTestCase
	self assert: [ self isTestMethod ].
	
	^ self methodClass selector: self selector.! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 11/27/2009 11:05'!
overriddenAndOverridingMethods
	^ self overriddenAndOverridingMethodsIn: self methodClass! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'test 9/20/2009 21:39'!
overriddenAndOverridingMethodsIn: aClass
	|result|
	result := (self overridingMethodsIn: aClass) copy.
	(self overriddenMethodIn: aClass) 
		ifNotNilDo: [:aMethod | result add: aMethod].
	^ result! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'test 9/20/2009 21:34'!
overriddenMethod
	^ self overriddenMethodIn: self methodClass! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'test 9/20/2009 21:49'!
overriddenMethodIn: aClass
	^ (aClass superclass whichClassIncludesSelector: self selector)
			ifNotNilDo: [ :superclass | (superclass >> self selector) clientMethod ]
			ifNil: [ nil ].! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'test 9/20/2009 21:34'!
overridingMethods
	^ self overridingMethodsIn: self methodClass! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 11/27/2009 10:54'!
overridingMethodsIn: aClass
	| overriders |
	overriders := Set new.
	self methodClass addOverridersOf: self selector to: overriders.
	
	^ overriders collect: [ :overrider | 
			(overrider >> self selector) clientMethod ]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 22:48'!
privateAddCoveringTestMethod: aCompiledTestMethod
	self methodExtension privateAddCoveringTestMethod: aCompiledTestMethod! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/21/2010 13:33'!
privateCovered: aCompiledAppMethod withReceiver: anObject
	self methodExtension privateCovered: aCompiledAppMethod withReceiver: anObject! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 22:17'!
privateRemoveCoveredMethod: aCompiledAppMethod
	self methodExtension privateRemoveCoveredMethod: aCompiledAppMethod! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 22:17'!
privateRemoveCoveringTestMethod: aTestCaseMethod
	self methodExtension privateRemoveCoveringTestMethod: aTestCaseMethod! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 22:17'!
privateStatisticsForCoveredMethod: aCompiledMethod 
	^ self methodExtension privateStatisticsForCoveredMethod: aCompiledMethod! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:31'!
pvtCodeSightMonitor! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:31'!
pvtCoveredMethodsStatistics! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:31'!
pvtCoveringTestMethods! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:31'!
pvtFixedTestMethods! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:32'!
pvtRemoveCoveredMethod: aCompiledAppMethod! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:32'!
pvtRemoveCoveringTestMethod: aTestCaseMethod! !

!CompiledMethod methodsFor: '*CodeSight-Instrumentation' stamp: 'bs 3/5/2010 10:28:38.898'!
reinstallUninstrumentedMethodSilently
	self methodClass 
		addSelectorSilently: self selector 
		withMethod: self uninstrumentedMethod.! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:32'!
removeCoveredMethod: aCompiledAppMethod
	^ self methodExtension removeCoveredMethod: aCompiledAppMethod! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:32'!
removeCoveringTestMethod: aTestCaseMethod
	^ self methodExtension removeCoveringTestMethod: aTestCaseMethod! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:33'!
removeFixedTestMethodIfNotCoveringAnymore: aTestCaseMethod
	^ self methodExtension removeFixedTestMethodIfNotCoveringAnymore: aTestCaseMethod! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/17/2010 14:40'!
resetAllCoverageData
	^ self methodExtension: nil! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:33'!
resetCoveredMethodsStatistics
	^ self methodExtension resetCoveredMethodsStatistics! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:33'!
resetCoveringTestMethods
	^ self methodExtension resetCoveringTestMethods! !

!CompiledMethod methodsFor: '*CodeSight-FailedExpression' stamp: 'bs 12/21/2009 12:57'!
resetFailedExpression
	self properties removeKey: #codeSightFailedExpression ifAbsent: [].! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:33'!
resetFixedTestMethods
	^ self methodExtension resetFixedTestMethods! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 1/16/2010 20:33'!
statisticsForCoveredMethod: aCompiledMethod 
	^ self methodExtension statisticsForCoveredMethod: aCompiledMethod ! !

!CompiledMethod methodsFor: '*CodeSight-FailedExpression' stamp: 'bs 12/31/2009 16:24'!
testFailedWith: anException
	| testMethodContext pc pcRange | 
	testMethodContext := self findTestMethodInStack: anException.
	testMethodContext
		ifNotNil: [
			pc := testMethodContext pc.
			pcRange := testMethodContext debuggerMap 
				rangeForPC: pc contextIsActiveContext: false.
			self failedExpressionInterval: pcRange ].! !

!CompiledMethod methodsFor: '*CodeSight-FailedExpression' stamp: 'bs 12/21/2009 15:51'!
testWasSuccessful
	self resetFailedExpression! !

!CompiledMethod methodsFor: '*CodeSight-Instrumentation' stamp: 'bs 3/5/2010 09:15:49.696'!
uninstrumentedMethod
	^ self properties at: #csUninstrumentedMethod ifAbsent: [ nil ].! !

!CompiledMethod methodsFor: '*CodeSight-Instrumentation' stamp: 'bs 3/5/2010 09:16:07.542'!
uninstrumentedMethod: aCompiledMethod
	^ self properties at: #csUninstrumentedMethod put: aCompiledMethod.! !

TextAttribute subclass: #CSTextBackgroundColor
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Text'!

!CSTextBackgroundColor methodsFor: 'accessing' stamp: 'bs 12/21/2009 16:57'!
color
	^ color! !

!CSTextBackgroundColor methodsFor: 'accessing' stamp: 'bs 12/21/2009 16:57'!
color: anObject
	color := anObject! !

!CSTextBackgroundColor methodsFor: 'displaying' stamp: 'bs 12/21/2009 17:03'!
emphasizeBackground: bounds on: aCanvas
	aCanvas 
		fillRectangle: bounds
		color: self color.! !

!CSTextBackgroundColor methodsFor: 'as yet unclassified' stamp: 'bs 12/21/2009 17:34'!
shoutShouldPreserve
	^ true! !

!CSTextBackgroundColor methodsFor: 'as yet unclassified' stamp: 'bs 12/22/2009 18:22'!
writeScanOn: strm
	! !

!TextAttribute methodsFor: '*CodeSight' stamp: 'bs 12/21/2009 17:01'!
emphasizeBackground: bounds on: aCanvas
	"Subclasses may override"! !

!OBMethodCategoryNode methodsFor: '*codesight' stamp: 'bs 1/14/2010 14:49'!
backgroundColor
	| methodSelectors methodsToBeChecked |
	
	(self csInfo isClassManaged: theClass)
		ifTrue: [
			methodSelectors := (name = ClassOrganizer allCategory)
				ifTrue: [theClass organization allMethodSelectors]
				ifFalse: [theClass organization listAtCategoryNamed: name].
			
			methodsToBeChecked := methodSelectors select: [:aSelector | aSelector isTestSelector not ] 
														 	  thenCollect: [:aSelector | theClass compiledMethodAt: aSelector].
				
			(methodsToBeChecked allSatisfy: [:aMethod | aMethod hasCoveringTestMethods])
				ifFalse: [^ Color lightOrange]].
	
	^ super backgroundColor! !

MwMethodWrapper subclass: #CSCoverageTracingWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracing'!

!CSCoverageTracingWrapper class methodsFor: 'wrapping' stamp: 'bs 3/2/2010 13:35:31.764'!
canWrap: aSelector inClass: aClass
	
	^ ((self canWrapClass: aClass) and: [self canWrapMethod: aSelector inClass: aClass])
			ifFalse: [false]
			ifTrue: [super canWrap: aSelector inClass: aClass]! !

!CSCoverageTracingWrapper class methodsFor: 'wrapping' stamp: 'bs 3/2/2010 13:35:31.767'!
canWrapClass: aClass
	| classesNotToBeWrapped |
	classesNotToBeWrapped := {CSTestStatistic. CSInstrumentor. CSInstrumentor class. CSWrappingInstrumentor. CSWrappingInstrumentor class. CSWeavingInstrumentor. CSWeavingInstrumentor class.}.
	^ (classesNotToBeWrapped includes: aClass) not.! !

!CSCoverageTracingWrapper class methodsFor: 'wrapping' stamp: 'bs 3/2/2010 13:35:31.769'!
canWrapMethod: aSelector inClass: aClass
	^ (self methodsNotToBeWrapped includesKey: aClass)
			ifFalse: [true]
			ifTrue: [
				((self methodsNotToBeWrapped at: aClass) includes: aSelector) not]! !

!CSCoverageTracingWrapper class methodsFor: 'as yet unclassified' stamp: 'bs 3/2/2010 13:35:31.762'!
initialize	
	" self initialize "
	super initialize.! !

!CSCoverageTracingWrapper class methodsFor: 'wrapping' stamp: 'bs 3/2/2010 13:35:31.772'!
methodsNotToBeWrapped
	| result |
	result := Dictionary new.
	result 
		at: (CSCodeSight) 
		put: (#(#isTracingActivated #runningTestMethod)).
	result 
		at: (CSInfo class) 
		put: (#(#instance)).
		
	^ result! !

!CSCoverageTracingWrapper methodsFor: 'evaluating' stamp: 'bs 3/2/2010 13:35:31.703'!
beforeMethod
	self shouldNotImplement! !

!CSCoverageTracingWrapper methodsFor: 'evaluating' stamp: 'bs 3/2/2010 13:35:31.705'!
beforeMethodWithReceiver: anObject.
	self shouldNotImplement! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.713'!
called: aCompiledMethod
	^ self clientMethod called: aCompiledMethod! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.714'!
called: aCompiledMethod receiver: anObject
	^ self clientMethod called: aCompiledMethod receiver: anObject! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.716'!
called: aCompiledMethod receiverClasses: classes
	^ self clientMethod called: aCompiledMethod receiverClasses: classes! !

!CSCoverageTracingWrapper methodsFor: 'evaluating' stamp: 'bs 3/2/2010 13:35:31.706'!
compiledMethod
	^ self clientMethod! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.718'!
coveredMethods
	^ self clientMethod coveredMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.719'!
coveredMethodsStatistics
	^ self clientMethod coveredMethodsStatistics! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.721'!
coveringAndNotFixedTestMethods
	^ self clientMethod coveringAndNotFixedTestMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.723'!
coveringTestMethods
	^ self clientMethod coveringTestMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.724'!
coveringTestMethodsWhenReceiverWasOfKind: aClass
	^ self clientMethod coveringTestMethodsWhenReceiverWasOfKind: aClass! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.726'!
fixedTestMethods
	^ self clientMethod fixedTestMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.728'!
fixes: aTestMethod
	^ self clientMethod fixes: aTestMethod! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.729'!
fixesAll: testMethods
	^ self clientMethod fixesAll: testMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.73'!
hasCoveringTestMethods
	^ self clientMethod hasCoveringTestMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.732'!
hasFixedTestMethods
	^ self clientMethod hasFixedTestMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.734'!
hasManagedMethodExtension
	^ self clientMethod hasManagedMethodExtension! !

!CSCoverageTracingWrapper methodsFor: 'testing' stamp: 'bs 3/2/2010 13:35:31.707'!
ifActive: aBlock
	self isActive ifTrue: [aBlock value]! !

!CSCoverageTracingWrapper methodsFor: 'testing' stamp: 'bs 3/2/2010 13:35:31.709'!
isActive
	^ self codeSight isTracingActivated! !

!CSCoverageTracingWrapper methodsFor: 'testing' stamp: 'bs 3/8/2010 17:22:06.118'!
isInstalled
	self definingClass ifNotNil:
		[:class|
		self clientSelector ifNotNil:
			[:selector|
			^self == (class methodDict at: selector ifAbsent: [])]].
	^false! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.735'!
methodExtension
	^ self unwrappedMethod methodExtension! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.736'!
methodExtension: anObject
	^ self clientMethod methodExtension: anObject! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.738'!
newTestCase
	^ self clientMethod newTestCase! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.74'!
overriddenAndOverridingMethods
	^ self clientMethod overriddenAndOverridingMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.741'!
overriddenAndOverridingMethodsIn: aClass
	^ self clientMethod overriddenAndOverridingMethodsIn: aClass! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.743'!
overriddenMethod
	^ self clientMethod overriddenMethod! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.744'!
overriddenMethodIn: aClass
	^ self clientMethod overriddenMethodIn: aClass! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.746'!
overridingMethods
	^ self clientMethod overridingMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.748'!
overridingMethodsIn: aClass
	^ self clientMethod overridingMethodsIn: aClass! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.749'!
removeCoveredMethod: aCompiledAppMethod
	^ self clientMethod removeCoveredMethod: aCompiledAppMethod! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.751'!
removeCoveringTestMethod: aTestCaseMethod
	^ self clientMethod removeCoveringTestMethod: aTestCaseMethod! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.753'!
removeFixedTestMethodIfNotCoveringAnymore: aTestCaseMethod
	^ self clientMethod removeFixedTestMethodIfNotCoveringAnymore: aTestCaseMethod.! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.754'!
resetAllCoverageData
	^ self clientMethod resetAllCoverageData! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.756'!
resetCoveredMethodsStatistics
	^ self clientMethod resetCoveredMethodsStatistics! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.758'!
resetCoveringTestMethods
	^ self clientMethod resetCoveringTestMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.759'!
resetFixedTestMethods
	^ self clientMethod resetFixedTestMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 3/2/2010 13:35:31.76'!
statisticsForCoveredMethod: aCompiledMethod
	^ self clientMethod statisticsForCoveredMethod: aCompiledMethod! !

!CSCoverageTracingWrapper methodsFor: 'evaluating' stamp: 'bs 3/2/2010 13:35:31.711'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	self methodExtension beforeMethodWithReceiver: anObject. 
	^ self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects! !

MwMethodWrapper subclass: #CSRefactoringVariationWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSRefactoringVariationWrapper class methodsFor: 'as yet unclassified' stamp: 'bs 12/8/2009 22:59'!
initialize
	"self initialize"
	super initialize! !

!CSRefactoringVariationWrapper class methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2010 22:14:46.852'!
on: aSelectorSymbol inClass: aClass withCode: sourceCodeString
	| wrapper variationAst |
	wrapper := super on: aSelectorSymbol inClass: aClass.
	variationAst := Compiler new 
						compile: sourceCodeString in: aClass
						notifying: nil
						ifFail: [].
	wrapper variationMethod: (variationAst generateUsing: aClass).
	^ wrapper! !

!CSRefactoringVariationWrapper methodsFor: 'as yet unclassified' stamp: 'bs 12/8/2009 23:00'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	^ self variationMethod valueWithReceiver: anObject arguments: anArrayOfObjects.! !

!CSRefactoringVariationWrapper methodsFor: 'as yet unclassified' stamp: 'bs 12/8/2009 21:57'!
variationMethod
	^ self properties at: #codeSightVariationMethod ifAbsent: []! !

!CSRefactoringVariationWrapper methodsFor: 'as yet unclassified' stamp: 'bs 12/8/2009 21:58'!
variationMethod: aCompiledMethod
	self properties at: #codeSightVariationMethod put: aCompiledMethod! !

MwMethodWrapper subclass: #CSWithTracingWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracing'!

!CSWithTracingWrapper methodsFor: 'evaluating' stamp: 'bs 3/2/2010 13:37:40.914'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	| codeSight |
	codeSight := self codeSight.
	^ [
		codeSight activateTracing. 
		self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	] ensure: [ codeSight deactivateTracing. ]! !

!Behavior methodsFor: '*CodeSight' stamp: 'bs 10/28/2009 10:03'!
addOverridersOf: aSelector to: aCollection
	self allSubclassesDo: [:subclass | 
		(subclass includesSelector: aSelector)
			ifTrue: [aCollection add: subclass]
			ifFalse: [subclass addOverridersOf: aSelector to: aCollection]]! !

MultiNewParagraph subclass: #CSParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!CSParagraph methodsFor: 'fonts-display' stamp: 'bs 12/21/2009 16:48'!
displayOn: aCanvas using: displayScanner at: somePosition
	"Send all visible lines to the displayScanner for display"
	
	| visibleRectangle line |
	visibleRectangle := aCanvas clipRect.
	(self lineIndexForPoint: visibleRectangle topLeft)
		to: (self lineIndexForPoint: visibleRectangle bottomRight)
		do: [:i | line := lines at: i.
			self drawBackgroundEmphasisInLine: line on: aCanvas ].
	
	super displayOn: aCanvas using: displayScanner at: somePosition.
! !

!CSParagraph methodsFor: 'fonts-display' stamp: 'bs 12/21/2009 17:01'!
drawBackgroundEmphasisInLine: line on: aCanvas
	| textLine |
	textLine := self text
		copyFrom: line first
		to: line last.
	textLine runs withStartStopAndValueDo: [:start :stop :attributes | 
		attributes do: [:anAttr | | cb1 cb2 bounds |
			cb1 := self characterBlockForIndex: start + (line first - 1).
			cb2 := self characterBlockForIndex: stop + (line first - 1). 
			bounds := cb1 left @ line top corner: cb2 right @ line bottom.
			anAttr emphasizeBackground: bounds on: aCanvas ] ]! !

SimpleHierarchicalListMorph subclass: #CSTestTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-View'!

!CSTestTree class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 23:27'!
on: someTestCases

	^ self
			on: [Array with:  (MorphWithSubmorphsWrapper with: World)]
			list: #value
			selected: nil
			changeSelected: nil
			menu: nil
			keystroke: nil! !

!CSTestTree methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 23:40'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #rigid;
		borderWidth: 0;
		extent: (CSActivityMorph defaultWidth - 10 ) @ 50;
		color: (Color white alpha: 0.7).! !

!CSTestTree methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 23:18'!
scrollBarThickness

	^ 5! !

SimpleHierarchicalListMorph subclass: #CSTreeMorph
	instanceVariableNames: 'scrollBarThickness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-View'!

!CSTreeMorph class methodsFor: 'as yet unclassified' stamp: 'bs 12/31/2009 11:41'!
on: someTestCases

	^ self
			on: [Array with:  (MorphWithSubmorphsWrapper with: World)]
			list: #value
			selected: nil
			changeSelected: nil
			menu: nil
			keystroke: nil! !

!CSTreeMorph methodsFor: 'as yet unclassified' stamp: 'bs 12/31/2009 11:44'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #rigid;
		borderWidth: 0;
		extent: (CSActivityMorph defaultWidth - 10 ) @ 50;
		color: (Color white alpha: 0.7);
		scrollBarThickness: 5.! !

!CSTreeMorph methodsFor: 'as yet unclassified' stamp: 'bs 12/31/2009 11:43'!
scrollBarThickness
	^ scrollBarThickness ifNil: [super scrollBarThickness]! !

!CSTreeMorph methodsFor: 'as yet unclassified' stamp: 'bs 12/31/2009 11:43'!
scrollBarThickness: aPositiveInteger
	scrollBarThickness := aPositiveInteger! !

ListItemWrapper subclass: #CSTestCaseItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-View'!

!CSTestCaseItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 12/16/2009 12:07'!
asString

	^ item name! !

!CSTestCaseItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 12/16/2009 11:56'!
contents

	^ item value collect: [:test |
		CSTestItemWrapper with: test]! !

ListItemWrapper subclass: #CSTestItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-View'!

!CSTestItemWrapper methodsFor: 'as yet unclassified' stamp: 'mt 12/16/2009 11:57'!
asString

	^ item selector asString! !

!OBPluggableTextMorphWithShout methodsFor: '*codesight-override' stamp: 'bs 1/14/2010 11:33'!
textMorphClass
	^ CSTextMorph! !

Morph subclass: #CSActivityMorph
	instanceVariableNames: 'label bgColor isFinished tree addedOrModifiedMethodNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-View'!

!CSActivityMorph class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:59'!
defaultWidth

	^ CSActivityMorphList defaultWidth - (CSActivityMorphList defaultInset * 2)! !

!CSActivityMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 22:57'!
activate
	"Moves this activity in the owning list to visualize its state."

	self owner ifNotNilDo: [:activityMorphList |
		activityMorphList activateActivity: self].! !

!CSActivityMorph methodsFor: 'modification recording' stamp: 'bs 12/31/2009 15:31'!
addedOrModifiedMethodNames
	^ addedOrModifiedMethodNames ifNil: [addedOrModifiedMethodNames := Set new]! !

!CSActivityMorph methodsFor: 'modification recording' stamp: 'bs 1/8/2010 19:31'!
addedOrModifiedMethods
	^ self addedOrModifiedMethodNames collect: [ :name | CompiledMethod fromQualifiedName: name ]! !

!CSActivityMorph methodsFor: 'accessing' stamp: 'mt 12/15/2009 22:12'!
bgColor

	^ bgColor ifNil: [^ Color transparent]! !

!CSActivityMorph methodsFor: 'accessing' stamp: 'mt 12/15/2009 22:12'!
bgColor: aColor

	bgColor := aColor.
	self color: self bgColor.! !

!CSActivityMorph methodsFor: 'ui-building' stamp: 'bs 1/20/2010 10:30'!
buildModifiedItemsTree
	^ self buildTreeOn: #modifiedItems! !

!CSActivityMorph methodsFor: 'ui-building' stamp: 'bs 1/20/2010 17:26'!
buildTreeOn: aSelectorSymbol
	| tree |
	tree := CSTestTree on: self list: aSelectorSymbol selected: nil changeSelected: nil.
	self addMorphBack: tree.
	self addDependent: tree.
	self invalidRect: self fullBounds.
	^ tree.! !

!CSActivityMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 22:55'!
contextMenu

	| menu |
	menu := MenuMorph entitled: 'Activity'.
	menu
		add: 'Activate'
		target: self
		selector: #activate
		enabled: true
		icon: nil.
	menu
		add: 'Finish'
		target: self
		selector: #finish
		enabled: true
		icon: nil.
	menu addLine.
	menu
		add: 'Delete'
		target: self
		selector: #delete
		enabled: true
		icon: nil.
	^ menu! !

!CSActivityMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 22:40'!
delete

	super delete.
	self changed: #activityDeleted.! !

!CSActivityMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 22:30'!
finish
	"Moves this activity in the owning list to visualize its state."

	self owner ifNotNilDo: [:activityMorphList |
		activityMorphList finishActivity: self].! !

!CSActivityMorph methodsFor: 'event handling' stamp: 'mt 12/15/2009 22:53'!
handleMouseEnter: evt
	"Hightlight the morph."

	super handleMouseEnter: evt.
	self isFinished
		ifFalse: [self color: Color blue muchLighter].! !

!CSActivityMorph methodsFor: 'event handling' stamp: 'mt 12/15/2009 22:12'!
handleMouseLeave: evt

	super handleMouseLeave: evt.
	self color: self bgColor.! !

!CSActivityMorph methodsFor: 'event handling' stamp: 'mt 12/15/2009 22:42'!
handlesMouseDown: evt

	^ true! !

!CSActivityMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 23:03'!
highlightWithColor: aColor
	"Reset the color then wait some time and restore the old one. Can be used for flashing effects."
	
	| old |
	old := self bgColor.
	self bgColor: aColor.
	[(Delay forMilliseconds: 500) wait. self bgColor: old] fork.! !

!CSActivityMorph methodsFor: 'initialize-release' stamp: 'bs 1/20/2010 21:24'!
initialize
	super initialize.
	self
		changeTableLayout;
		hResizing: #rigid;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		layoutInset: 3;
		extent: self class defaultWidth @ 50;
		addMorph: self label;
		buildTreeOn: #modifiedItems.! !

!CSActivityMorph methodsFor: 'accessing' stamp: 'mt 12/15/2009 22:51'!
isFinished

	^ isFinished ifNil: [false]! !

!CSActivityMorph methodsFor: 'accessing' stamp: 'mt 12/15/2009 22:51'!
isFinished: aBoolean

	isFinished := aBoolean.! !

!CSActivityMorph methodsFor: 'testing' stamp: 'bs 12/22/2009 16:51'!
isNewBehavior
	^ false! !

!CSActivityMorph methodsFor: 'testing' stamp: 'bs 12/22/2009 16:51'!
isRefactoring
	^ false! !

!CSActivityMorph methodsFor: 'accessing' stamp: 'mt 12/16/2009 11:08'!
label

	^ label ifNil: [label := TextMorph new lock; hResizing: #spaceFill]! !

!CSActivityMorph methodsFor: 'modification recording' stamp: 'bs 1/1/2010 00:45'!
methodAddedOrModified: aMethod
	self addedOrModifiedMethodNames add: aMethod qualifiedName.
	self changed: #modifiedItems.! !

!CSActivityMorph methodsFor: 'modification recording' stamp: 'bs 1/2/2010 10:22'!
methodRemoved: aMethod
	self addedOrModifiedMethodNames remove: aMethod qualifiedName ifAbsent: [].
	self changed: #modifiedItems.! !

!CSActivityMorph methodsFor: 'modification recording' stamp: 'bs 12/31/2009 23:16'!
modifiedItems
	
	| g groups |
	g := IdentityDictionary new.
	self addedOrModifiedMethods do: [:method |
		(g includesKey: method methodClass)
			ifFalse: [g at: method methodClass put: OrderedCollection new].
		(g at: method methodClass) add: method ].
	
	groups := OrderedCollection new.
	g associationsDo: [:group | groups add: (CSTestCaseItemWrapper with: group)].
	^ groups! !

!CSActivityMorph methodsFor: 'event handling' stamp: 'mt 12/15/2009 22:52'!
mouseDown: evt
	"Do nothing upon mouse-down except inform the hand to watch for a 
	double-click; wait until an ensuing click:, doubleClick:, or drag: 
	message gets dispatched"
	
	(self isFinished not and: [evt yellowButtonPressed] )
		ifTrue: [
			self contextMenu popUpInWorld.
			evt wasHandled: true].! !

!CSActivityMorph methodsFor: 'modification recording' stamp: 'bs 1/2/2010 00:04'!
nonTestMethodRemoved: aMethod
	! !

!CSActivityMorph methodsFor: 'accessing' stamp: 'mt 12/15/2009 21:29'!
setLabelText: aString

	self label contentsWrapped: aString! !

!CSActivityMorph methodsFor: 'modification recording' stamp: 'bs 1/2/2010 00:03'!
testMethodRemoved: aMethod
	! !

!CSActivityMorph methodsFor: 'as yet unclassified' stamp: 'bs 1/2/2010 13:06'!
visualizeFinishState
	self bgColor: Color gray lighter! !

!CSActivityMorph methodsFor: 'as yet unclassified' stamp: 'bs 1/2/2010 13:05'!
visualizeOpenState
	self bgColor: Color red lighter! !

CSActivityMorph subclass: #CSNewBehaviorMorph
	instanceVariableNames: 'testMethodName testMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-View'!

!CSNewBehaviorMorph methodsFor: 'as yet unclassified' stamp: 'bs 1/15/2010 22:58'!
finish
	super finish.
	self addedOrModifiedMethods do: [ :method | method fixes: self testMethod ].! !

!CSNewBehaviorMorph methodsFor: 'testing' stamp: 'bs 12/22/2009 16:51'!
isNewBehavior
	^ true.! !

!CSNewBehaviorMorph methodsFor: 'modification recording' stamp: 'bs 1/2/2010 00:07'!
nonTestMethodRemoved: aMethod
	self methodRemoved: aMethod! !

!CSNewBehaviorMorph methodsFor: 'accessing' stamp: 'bs 1/3/2010 21:12'!
testMethod
	^ CompiledMethod fromQualifiedName: self testMethodName! !

!CSNewBehaviorMorph methodsFor: 'accessing' stamp: 'bs 1/3/2010 21:12'!
testMethod: aTestMethod
	self testMethodName: aTestMethod qualifiedName.
	self updateLabel.! !

!CSNewBehaviorMorph methodsFor: 'accessing' stamp: 'bs 1/3/2010 21:12'!
testMethodName
	^ testMethodName! !

!CSNewBehaviorMorph methodsFor: 'accessing' stamp: 'bs 1/3/2010 21:12'!
testMethodName: anObject
	testMethodName := anObject! !

!CSNewBehaviorMorph methodsFor: 'modification recording' stamp: 'bs 1/3/2010 21:27'!
testMethodRemoved: aMethod
	(self testMethodName = aMethod qualifiedName) ifTrue: [ self owner deleteActivity: self ]! !

!CSNewBehaviorMorph methodsFor: 'as yet unclassified' stamp: 'bs 12/22/2009 16:48'!
updateLabel

	self setLabelText: 
		(self testMethod
			ifNil: ['n/a']
			ifNotNil: [self testMethod qualifiedName])! !

CSActivityMorph subclass: #CSRefactoringMorph
	instanceVariableNames: 'event brokenTests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-View'!

CSRefactoringMorph class
	instanceVariableNames: 'someTestCases'!

CSRefactoringMorph class
	instanceVariableNames: 'someTestCases'!

!CSRefactoringMorph class methodsFor: 'as yet unclassified' stamp: 'bs 12/14/2009 10:32'!
on: aCompiledMethod
	^ self new 
		method: aCompiledMethod;
		addMorph: (StringMorph contents: aCompiledMethod qualifiedName);
		extent: 200 @ 50; 
		yourself.! !

!CSRefactoringMorph methodsFor: 'as yet unclassified' stamp: 'bs 1/20/2010 21:15'!
brokenTestItems
	
	| g groups |
	g := IdentityDictionary new.
	self brokenTests do: [:method |
		(g includesKey: method methodClass)
			ifFalse: [g at: method methodClass put: OrderedCollection new].
		(g at: method methodClass) add: method ].
	
	groups := OrderedCollection new.
	g associationsDo: [:group | groups add: (CSTestCaseItemWrapper with: group)].
	^ groups! !

!CSRefactoringMorph methodsFor: 'accessing' stamp: 'bs 1/20/2010 21:15'!
brokenTests
	^ brokenTests ifNil: [ brokenTests := Set new ]! !

!CSRefactoringMorph methodsFor: 'accessing' stamp: 'bs 1/20/2010 21:18'!
brokenTests: anObject
	brokenTests := anObject.
	self changed: #brokenTestItems! !

!CSRefactoringMorph methodsFor: 'accessing' stamp: 'bs 1/20/2010 21:11'!
event
	^ event! !

!CSRefactoringMorph methodsFor: 'accessing' stamp: 'bs 1/20/2010 21:11'!
event: anObject
	event := anObject! !

!CSRefactoringMorph methodsFor: 'initialize-release' stamp: 'bs 1/20/2010 21:22'!
initialize
	super initialize.
	self buildTreeOn: #brokenTestItems.! !

!CSRefactoringMorph methodsFor: 'testing' stamp: 'bs 12/22/2009 16:51'!
isRefactoring
	^ true.! !

!CSRefactoringMorph methodsFor: 'updating' stamp: 'bs 1/20/2010 21:12'!
updateLabel

	self setLabelText: 
		(self event
			ifNil: ['n/a']
			ifNotNil: [self event asString])! !

Morph subclass: #CSActivityMorphList
	instanceVariableNames: 'separator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-View'!

!CSActivityMorphList class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 22:06'!
defaultInset

	^ 0! !

!CSActivityMorphList class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:53'!
defaultWidth
	"Calculate the correct width out of default values of the environment."

	^ CSTddMonitor defaultWidth
	 - SwaGeneralScrollPane defaultScrollbarThickness
	 - (CSTddMonitor defaultInset * 2)! !

!CSActivityMorphList class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 22:25'!
numberOfFinishedTasksToKeep

	^ 4! !

!CSActivityMorphList methodsFor: 'activity handling' stamp: 'mt 12/15/2009 23:00'!
activateActivity: anActivityMorph
	"Changes the position of the given activity morph to visualize its state."

	self
		removeMorph: anActivityMorph;
		addMorph: anActivityMorph after: self separator.
		
	anActivityMorph highlightWithColor: Color yellow.! !

!CSActivityMorphList methodsFor: 'activity handling' stamp: 'bs 1/3/2010 17:00'!
activatedActivity
	| separatorIndex |
	separatorIndex := self submorphIndexOf: self separator.
	^ (separatorIndex = self submorphs size)
		ifTrue: [nil]
		ifFalse: [self submorphs at: separatorIndex + 1].! !

!CSActivityMorphList methodsFor: 'activity handling' stamp: 'bs 12/22/2009 16:43'!
activities

	^ self submorphs select: [ :ea | ea isKindOf: CSActivityMorph ]! !

!CSActivityMorphList methodsFor: 'activity handling' stamp: 'bs 1/2/2010 13:09'!
addActivity: anActivityMorph

	self addMorph: anActivityMorph behind: self separator.
	anActivityMorph 
		addDependent: self;
		visualizeOpenState;
		isFinished: false.! !

!CSActivityMorphList methodsFor: 'activity handling' stamp: 'bs 1/3/2010 21:22'!
deleteActivity: anActivityMorph

	anActivityMorph delete! !

!CSActivityMorphList methodsFor: 'private' stamp: 'mt 12/15/2009 22:29'!
discardOldActivities
	"Only keep a specific number of finished activities in the list."
	
	| behind frontMorphs |
	behind := false.
	frontMorphs := OrderedCollection new.
	
	self submorphs do: [:morph |
		morph == self separator
			ifTrue: [behind := true]
			ifFalse: [behind ifFalse: [frontMorphs add: morph]]].
		
	[frontMorphs size > self class numberOfFinishedTasksToKeep]
		whileTrue: [self removeMorph: frontMorphs first. frontMorphs remove: frontMorphs first]! !

!CSActivityMorphList methodsFor: 'activity handling' stamp: 'bs 1/2/2010 13:06'!
finishActivity: anActivityMorph
	"Changes the position of the given activity morph to visualize its state."

	self
		removeMorph: anActivityMorph;
		addMorph: anActivityMorph inFrontOf: self separator;
		discardOldActivities.
		
	anActivityMorph
		visualizeFinishState;
		isFinished: true;
		highlightWithColor: Color yellow.! !

!CSActivityMorphList methodsFor: 'initialization' stamp: 'mt 12/15/2009 22:08'!
initialize

	super initialize.
	self
		changeTableLayout;
		hResizing: #rigid;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		layoutInset: self class defaultInset;
		cellInset: 5;
		extent: self class defaultWidth @ 10;
		color: Color transparent;
		addMorph: self separator.! !

!CSActivityMorphList methodsFor: 'activity handling' stamp: 'mt 12/16/2009 11:23'!
privateAddMorph: aMorph atIndex: index

	super privateAddMorph: aMorph atIndex: index.
	self invalidRect: self fullBounds.
	self changed: #resized.! !

!CSActivityMorphList methodsFor: 'activity handling' stamp: 'mt 12/15/2009 21:54'!
refactoringActivityOn: aCompiledMethod
	"Return the submorph based of the given method."

	^ self submorphs detect: [:s | s method = aCompiledMethod]! !

!CSActivityMorphList methodsFor: 'activity handling' stamp: 'bs 1/2/2010 13:09'!
reopenActivity: anActivityMorph
	"Changes the position of the given activity morph to visualize its state."

	self
		removeMorph: anActivityMorph;
		addMorph: anActivityMorph behind: self separator;
		discardOldActivities.
		
	anActivityMorph
		visualizeOpenState;
		isFinished: false;
		highlightWithColor: Color yellow.! !

!CSActivityMorphList methodsFor: 'accessing' stamp: 'mt 12/15/2009 22:06'!
separator
	"Separator to seperate open and closed activities."

	^ separator ifNil: [separator :=
		Morph new
			extent: CSActivityMorph defaultWidth @ 2;
			color: (Color black alpha: 0.5)]! !

!CSActivityMorphList methodsFor: 'updating' stamp: 'mt 12/16/2009 11:39'!
update: aSymbol

	aSymbol = #activityDeleted
		ifTrue: [
			self invalidRect: self fullBounds.
			self changed: #resized]! !

Morph subclass: #CSTddMonitor
	instanceVariableNames: 'list'
	classVariableNames: 'Inst'
	poolDictionaries: ''
	category: 'CodeSight-View'!

!CSTddMonitor class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:48'!
defaultHeight

	^ 500! !

!CSTddMonitor class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:53'!
defaultInset

	^ 7! !

!CSTddMonitor class methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:48'!
defaultWidth

	^ 200! !

!CSTddMonitor class methodsFor: 'instance creation' stamp: 'bs 12/22/2009 16:34'!
open

	^ self new open.! !

!CSTddMonitor methodsFor: 'activity handling' stamp: 'mt 12/15/2009 22:03'!
addRefactoringActivityOn: aCompiledMethod withTests: someTestCases

	self list addActivity: (CSRefactoringMorph new
		method: aCompiledMethod;
		tests: someTestCases).! !

!CSTddMonitor methodsFor: 'building' stamp: 'bs 1/3/2010 18:39'!
buildWith: aBuilder
	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; "label: self label; extent: self extent;"
		"children: (OrderedCollection new 
			add: ((self buildItemListWith: aBuilder)
				frame: (0.00 @ 0.00 corner: 1.0 @ 1.0 );
				yourself);
			yourself);"
		yourself.
	^ aBuilder build: window.! !

!CSTddMonitor methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:53'!
initialize
	
	super initialize.
	self
		borderWidth: 0;
		color: (Color gray alpha: 0.5);
		changeTableLayout;
		layoutInset: self class defaultInset;
		listDirection: #topToBottom;
		initializeList.! !

!CSTddMonitor methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 22:03'!
initializeList
	
	| scroller |
	scroller := CSActivityScroller new.
	self addMorph: scroller.
	self list: scroller scrollTarget.! !

!CSTddMonitor methodsFor: 'accessing' stamp: 'bs 12/22/2009 16:38'!
list
	^ list! !

!CSTddMonitor methodsFor: 'accessing' stamp: 'mt 12/15/2009 21:58'!
list: anObject
	list := anObject! !

!CSTddMonitor methodsFor: 'activity handling' stamp: 'bs 1/18/2010 09:32'!
modification: aCsEvent brokeTests: testMethods
	! !

!CSTddMonitor methodsFor: 'activity handling' stamp: 'bs 1/2/2010 14:23'!
newBehaviorSpecified:  aTestMethod 
	| activity |
	activity := self list activities 
		detect: [ :ea | ea isNewBehavior and: [ ea testMethod qualifiedName = aTestMethod qualifiedName ] ]
		ifNone: [ nil ].
	
	activity
		ifNil: [ self list addActivity: (CSNewBehaviorMorph new testMethod: aTestMethod) ]
		ifNotNil: [ self list reopenActivity: activity ].! !

!CSTddMonitor methodsFor: 'activity handling' stamp: 'bs 1/3/2010 22:27'!
nonTestMethodAddedOrModified: aMethod
	self list activatedActivity ifNotNilDo: [ :activity | 
		activity methodAddedOrModified: aMethod ]! !

!CSTddMonitor methodsFor: 'activity handling' stamp: 'bs 1/2/2010 00:12'!
nonTestMethodRemoved: aMethod
	self list activities do: [ :ea | ea nonTestMethodRemoved: aMethod ]
	! !

!CSTddMonitor methodsFor: 'as yet unclassified' stamp: 'mt 12/15/2009 20:57'!
open

	self
		openInWorld;
		extent: self class defaultWidth @ self class defaultHeight.! !

!CSTddMonitor methodsFor: 'activity handling' stamp: 'bs 1/3/2010 21:10'!
reset
	self list activities do: [ :ea | self list deleteActivity: ea ].! !

!CSTddMonitor methodsFor: 'activity handling' stamp: 'bs 1/2/2010 00:12'!
testMethodRemoved: aMethod
	self list activities do: [ :ea | ea testMethodRemoved: aMethod ]! !

!CSTddMonitor methodsFor: 'activity handling' stamp: 'bs 12/22/2009 20:03'!
testsTurnedGreen: testMethods
	| testMethodNames |
	testMethodNames := testMethods collect: [ :ea | ea qualifiedName ].
	self list activities 
		select: [ :ea | ea isNewBehavior and: [ testMethodNames includes: ea testMethod qualifiedName ]]
		thenDo: [ :ea | ea finish ].! !

!CSTddMonitor methodsFor: 'activity handling' stamp: 'bs 1/2/2010 14:33'!
unsupportedTestSpecified:  aTestMethod 
	| activity |
	activity := self list activities 
		detect: [ :ea | ea isNewBehavior and: [ ea testMethod qualifiedName = aTestMethod qualifiedName ] ]
		ifNone: [ nil ].
	
	activity
		ifNil: [ self list addActivity: (CSNewBehaviorMorph new testMethod: aTestMethod) ]
		ifNotNil: [ self list reopenActivity: activity ].! !

!CSTddMonitor methodsFor: 'activity handling' stamp: 'bs 1/2/2010 14:34'!
unsupportedTestsSpecified:  testMethods
	testMethods do: [ :ea | self unsupportedTestSpecified: ea ].! !
CSReplicator initialize!
CSFailedExpressionStyler initialize!
CSPackageChooser initialize!
CSTestRunner initialize!
CSCoverageTracingWrapper initialize!
CSRefactoringVariationWrapper initialize!
